import bpy
import math
import mathutils

def auto_root(Bone_Activo):
    obj = bpy.context.active_object
    threshold_distance = 0.001 
    encontrar_bone = None
    Props = bpy.context.scene.S_General_PropertyGroup
    
    bpy.ops.object.mode_set(mode='EDIT')
    Bone_name = None 
    if obj and obj.type == 'ARMATURE':
        armature = obj.data 
        parent_bone = None

        if Props.use_active_bone == False: 
            for bone in armature.edit_bones:
                distance = math.sqrt(sum((a - b) ** 2 for a, b in zip(bone.head, (0.0, 0.0, 0.0))))
                if distance < threshold_distance:
                    parent_bone = bone
                    Bone_name = bone.name 
                    break
                
        else:
            parent_bone = armature.edit_bones.get(Bone_Activo)
            if parent_bone:
                Bone_name = parent_bone.name
                
        Bone_new_name = []
        if parent_bone:
            new_bone1 = armature.edit_bones.new("New_Root_1")
            new_bone1.head = parent_bone.head
            new_bone1.tail = parent_bone.tail
            new_bone1.roll = parent_bone.roll
            new_bone1.use_deform = False
            parent_bone.parent = new_bone1
            new_bone1.color.palette = 'THEME09'
    
            Bone_new_name.append("New_Root_1")
            
            new_bone2 = armature.edit_bones.new("New_Root_2")
            new_bone2.head = parent_bone.head
            new_bone2.tail = parent_bone.tail
            new_bone2.roll = parent_bone.roll
            new_bone2.use_deform = False
            new_bone1.parent = new_bone2
            new_bone2.color.palette = 'THEME03'
            Bone_new_name.append("New_Root_2")
    
        bpy.ops.object.mode_set(mode='POSE')
    
        Bone_Pose_new = []
        for name in Bone_new_name:
            Bone_Pose_new.append(obj.pose.bones.get(name))
        Bone_original = obj.pose.bones.get(Bone_name)
    
        if Bone_Pose_new and Bone_original:
            for bone in Bone_Pose_new:
                bone.custom_shape = Bone_original.custom_shape
            for i in range(len(Bone_Pose_new)):
                scale_factor = 1.4 + (i * 0.2)
    
                scale_factor_vector = mathutils.Vector((scale_factor, scale_factor, 0))
                custom_shape_scale_xyz_vector = mathutils.Vector(Bone_original.custom_shape_scale_xyz)
                Bone_Pose_new[i].custom_shape_scale_xyz = scale_factor_vector * custom_shape_scale_xyz_vector
                Bone_Pose_new[i].custom_shape_rotation_euler[0] = Bone_original.custom_shape_rotation_euler[0]
