import bpy


def Fisicas_Run():

    props = bpy.context.scene.H_Fisicas_PropertyGroup
    Stretch_to = props.Stretch_to
    Volume_Varition = props.Volume_Varition
    Fuerza_Fisicas = props.Fuerza_Fisicas
    Frame_Bake_1 = props.Frame_Bake_1
    Frame_Bake_2 = props.Frame_Bake_2
    Frame_Bake_Steo = props.Frame_Bake_Steo
    
    Armature = bpy.context.active_object
    bpy.ops.object.mode_set(mode='EDIT')
    bpy.context.object.data.use_mirror_x = False


    selected_bones = [bone for bone in bpy.context.selected_editable_bones]
    selected_bones_Name = [bone.name for bone in bpy.context.selected_editable_bones]

    num_selected_bones = len(selected_bones)

    def App_Bones(Control, Bones, Cuantos = int(0)):

        for i in range(Cuantos):

            ultima_letra = Bones[-1].lower()  

            Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']

            if not Tiene_L_O_R:
                Bone_Name = Control + Bones[:-3] + str(i)
            else:
                Bone_Name = Control + Bones + "." + str(i)

            bpy.ops.armature.bone_primitive_add(name=Bone_Name)

    def Encontrar_Bone(Control, Bones, Varible = [], Cuantos = int(0)):

        for i in range(Cuantos):

            ultima_letra = Bones[-1].lower()  

            Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']

            if not Tiene_L_O_R:
                Bone_Name = Control + Bones[:-3] + str(i)
            else:
                Bone_Name = Control + Bones + "." + str(i)

            Varible.append(Armature.data.edit_bones.get(Bone_Name))

    def Posicionar_Bones(Bone, head, tail, roll, length, tengo_length = True):

        Bone.head = head
        Bone.tail = tail
        Bone.roll = roll

        if tengo_length == True:
            Bone.length = length
        else:
            print("no quiero length en el bone")

    def pocioner_Bones_tail(Bone, head, tail, roll, length, tengo_length = True):

        Bone.head = head
        Bone.tail = tail
        Bone.length *= 2
        Bone.head = tail
        Bone.roll = roll

        if tengo_length == True:
            Bone.length = length
        else:
            print("no quiero length en el bone")

    #si estoy en Edit Bone
    if Armature and Armature.type == 'ARMATURE':


        Ficas_Controles = []
        Nombre = "Ficas_"
        Bones_sub_Name = "Bone"

        App_Bones(Nombre, Bones_sub_Name, Cuantos = int(num_selected_bones + 1))
        Encontrar_Bone(Nombre, Bones_sub_Name, Ficas_Controles, Cuantos = int(num_selected_bones + 1))
        print(Ficas_Controles[0].name)
        if Ficas_Controles:

            for i in range(num_selected_bones):
                Posicionar_Bones(Ficas_Controles[i], 
                                 selected_bones[i].head, 
                                 selected_bones[i].tail, 
                                 selected_bones[i].roll, 
                                 selected_bones[i].length, 
                                 tengo_length = False)

                pocioner_Bones_tail(Ficas_Controles[-1], 
                                    selected_bones[-1].head, 
                                    selected_bones[-1].tail, 
                                    selected_bones[-1].roll, 
                                    selected_bones[-1].length / 4, tengo_length = True)

            for i in range(num_selected_bones + 1):
                Ficas_Controles[i].use_deform = False

            for i in range(num_selected_bones):
                Ficas_Controles[i+1].parent = Ficas_Controles[i]
                Ficas_Controles[i+1].use_connect = True

            Ficas_Controles[0].parent = selected_bones[0].parent
            Ficas_Controles[0].use_connect = False


        bpy.context.object.data.use_mirror_x = True


        bpy.ops.object.mode_set(mode='POSE')

        Pose_selected_bones = []

        for i in range(num_selected_bones):
                Control = selected_bones_Name[i]
                Bones = Armature.pose.bones.get(Control)
                Pose_selected_bones.append(Bones)


        Pose_Ficas_Controles = []

        for i in range(num_selected_bones + 1):


            Bones = Bones_sub_Name

            ultima_letra = Bones[-1].lower()

            Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']

            if not Tiene_L_O_R:
                Bone_Name = Nombre + Bones[:-3] + str(i)
            else:
                Bone_Name = Nombre + Bones + "." + str(i)

            Bones = Armature.pose.bones.get(Bone_Name)
            Pose_Ficas_Controles.append(Bones)

        if Pose_Ficas_Controles:

            for i in range(num_selected_bones):

                if Stretch_to == False:
                    constraint = Pose_Ficas_Controles[i].constraints.new(type='DAMPED_TRACK')
                    constraint.target = Armature
                    constraint.subtarget = Pose_Ficas_Controles[i+1].name
                    constraint.influence = Fuerza_Fisicas

                else:
                    constraint = Pose_Ficas_Controles[i].constraints.new(type='STRETCH_TO')
                    constraint.target = Armature
                    constraint.subtarget = Pose_Ficas_Controles[i+1].name
                    constraint.bulge = Volume_Varition
                    constraint.influence = Fuerza_Fisicas


            for i in range(num_selected_bones):

                constraint = Pose_selected_bones[i].constraints.new(type='COPY_TRANSFORMS')
                constraint.name = "RIG_CREATOR_FISICAS"
                constraint.target = Armature
                constraint.subtarget = Pose_Ficas_Controles[i].name

            for bone in Pose_selected_bones:
                bone.bone.select = True

            bpy.ops.nla.bake(frame_start=Frame_Bake_1, 
                             frame_end=Frame_Bake_2,
                             step=Frame_Bake_Steo, 
                             only_selected=True, 
                             visual_keying=True, 
                             clear_constraints=False, 
                             clear_parents=False, 
                             use_current_action=True, 
                             clean_curves=False, 
                             bake_types={'POSE'})

            for bone in Pose_selected_bones:
                for constraint in bone.constraints:
                    if constraint.type == 'COPY_TRANSFORMS':
                        if constraint.name == "RIG_CREATOR_FISICAS":
                            bone.constraints.remove(constraint)


        bpy.ops.object.mode_set(mode='EDIT')

        post_Ficas_Controles = []
        Encontrar_Bone(Nombre, Bones_sub_Name, post_Ficas_Controles, Cuantos = int(num_selected_bones + 1))

        if post_Ficas_Controles:
            for i in range(len(post_Ficas_Controles)):
                Armature.data.edit_bones.remove(post_Ficas_Controles[i])

        bpy.ops.object.mode_set(mode='POSE')

    