import bpy
from mathutils import Vector
import sys
import os
from bl_ui.generic_ui_list import draw_ui_list
current_dir = os.path.dirname(__file__)
sys.path.append(current_dir) 

from Operadores.Rig_Creator_Operation.Creador_Bones import *

def Crear_bone(obj, armature, bone_a, bone_b):
    
    name_a = bone_a.name
    name_b = bone_b.name
    
    # Switch to Edit mode
    bpy.ops.object.mode_set(mode='EDIT')
    
    # Get edit bones
    edit_bone_a = armature.edit_bones.get(name_a)
    edit_bone_b = armature.edit_bones.get(name_b)
    
    # Create a new bone
    new_bone_name = f"IK_Pierna_Bone_Rig_creator_New_asdfadsfgert"
    new_bone = armature.edit_bones.new(new_bone_name)
    
    # Position the new bone
    new_bone.head = edit_bone_a.head
    new_bone.tail = edit_bone_a.tail
    new_bone.roll = edit_bone_a.roll
    new_bone.parent = edit_bone_b
    
    # Switch to Pose mode
    bpy.ops.object.mode_set(mode='POSE')
    
    # Get the pose bone for the new bone
    pose_new_bone = obj.pose.bones.get(new_bone_name)
    
    # Add COPY_TRANSFORMS constraint
    constraint = bone_a.constraints.new(type='COPY_TRANSFORMS')
    constraint.target = obj
    constraint.subtarget = pose_new_bone.name
    
    # Apply the visual transformation of the pose
    bone_a.bone.select = True
    bpy.context.view_layer.update()
    bpy.ops.pose.visual_transform_apply()
    bone_a.bone.select = False
    
    # Remove the constraint
    bone_a.constraints.remove(constraint)
    
    # Switch to Edit mode
    bpy.ops.object.mode_set(mode='EDIT')
    
    # Remove the new bone
    new_bone_name = f"IK_Pierna_Bone_Rig_creator_New_asdfadsfgert"
    armature.edit_bones.remove(armature.edit_bones.get(new_bone_name))
    
    # Switch back to Pose mode
    bpy.ops.object.mode_set(mode='POSE')

def GENRAL_(Fk_exite, Ik_exite, use_ik = False, ik_pierna = False):
    
    obj = bpy.context.active_object

    if obj and obj.type == 'ARMATURE' and obj.mode == 'POSE':
        armature = obj.pose
        
        def Encontral_bone(Bones, Existe):
           for nombre in Existe:
            if nombre in armature.bones:
                Bones.append(armature.bones[nombre])
        
        Bones_Fk = []
        Encontral_bone(Bones_Fk, Fk_exite)
        
        Bones_ik = []
        Encontral_bone(Bones_ik, Ik_exite)
        
        if Bones_Fk and Bones_ik:
            def constarint(bone_a, bone_b, use = [True, True, True]):

                constraint = bone_a.constraints.new(type='COPY_ROTATION')
                constraint.target = obj
                constraint.subtarget = bone_b.name
                constraint.use_x = use[0]
                constraint.use_y = use[1]
                constraint.use_z = use[2]
                
                
                bone_a.bone.select = True
                # Aplicar la transformación visual de la pose
                bpy.context.view_layer.update()
                bpy.ops.pose.visual_transform_apply()

                bone_a.constraints.remove(constraint)
                if bone_a.name == Bones_Fk[1].name:
                    bone_a.rotation_quaternion[2] = 0.0
                    bone_a.rotation_quaternion[3] = 0.0
                bone_a.bone.select = False 
                11 
            if use_ik == False:   
                       
                for i in range(len(Bones_Fk)):
                    constarint(
                        Bones_Fk[i], 
                        Bones_ik[i], 
                        use = [True, True, True]
                        )
            else:
                
                Crear_bone(obj, obj.data, Bones_Fk[-1], Bones_ik[-1])

                for i in range(len(Bones_Fk)-1):
                    constarint(
                        Bones_Fk[i], 
                        Bones_ik[i], 
                        use = [True, True, True]
                        )
                     
#Fk A IK
def IMAN_BRAZO_L(use_invert = False):
    Fk_exite = [
            "Control_FK_Brazo_L.001",
            "Control_FK_Brazo_L.002",
            "Control_FK_Brazo_L.003", 
        ]
    Ik_exite = [
            "Control_IK_Brazo_L.001",
            "Control_IK_Brazo_L.002",
            "Control_IK_Brazo_L.003", 
        ]
    
    Ik_exite_2 = [
            "SubControl_IK_Brazo_L.001",
            "Control_IK_Brazo_L.003", 
        ]
    
    if use_invert == False:
        GENRAL_(Fk_exite, Ik_exite)
    else:
        GENRAL_(Ik_exite_2, Fk_exite,use_ik=use_invert)
    
def IMAN_BRAZO_R(use_invert = False):
    Fk_exite = [
            "Control_FK_Brazo_R.001",
            "Control_FK_Brazo_R.002",
            "Control_FK_Brazo_R.003", 
        ]
    Ik_exite = [
            "Control_IK_Brazo_R.001",
            "Control_IK_Brazo_R.002",
            "Control_IK_Brazo_R.003", 
        ]
    
    Ik_exite_2 = [
            "SubControl_IK_Brazo_R.001",
            "Control_IK_Brazo_R.003", 
        ]
    
    
    if use_invert == False:
        GENRAL_(Fk_exite, Ik_exite)
    else:
        GENRAL_(Ik_exite_2, Fk_exite,use_ik=use_invert)

def IMAN_PIERNA_L(use_invert = False):
    Fk_exite = [
            "FK_Pierna_L.001",
            "FK_Pierna_L.002",
            "FK_Pierna_L.003", 
            "FK_Pierna_L.004", 
            ]
    Ik_exite = [
            "IK_Pierna_L.001",
            "IK_Pierna_L.002",
            "IK_Pierna_L.003", 
            "IK_Pierna_L.004", 
            ]
    
    Fk_exite_2 = [
            "FK_Pierna_L.001",
            "FK_Pierna_L.002",
            "FK_Pierna_L.003", 
             
            ]
    
    Ik_exite_2 = [
            "SudIK_Pierna_L.002",
            "SudIK_Pierna_L.004",
            ]
    
    if use_invert == False:
        GENRAL_(Fk_exite, Ik_exite)
    else:
        GENRAL_(Ik_exite_2, Fk_exite_2,use_ik=use_invert,ik_pierna=True)
    
def IMAN_PIERNA_R(use_invert = False):
    Fk_exite = [
            "FK_Pierna_R.001",
            "FK_Pierna_R.002",
            "FK_Pierna_R.003", 
            "FK_Pierna_R.004", 
            ]
    Ik_exite = [
            "IK_Pierna_R.001",
            "IK_Pierna_R.002",
            "IK_Pierna_R.003", 
            "IK_Pierna_R.004", 
            ]
    
    Fk_exite_2 = [
            "FK_Pierna_R.001",
            "FK_Pierna_R.002",
            "FK_Pierna_R.003", 
             
            ]
    
    Ik_exite_2 = [
            "SudIK_Pierna_R.002",
            "SudIK_Pierna_R.004",
            ]
    
    if use_invert == False:
        GENRAL_(Fk_exite, Ik_exite)
    else:
        GENRAL_(Ik_exite_2, Fk_exite_2,use_ik=use_invert,ik_pierna=True)


#usar pole target
def IMAN_POLE_TARGET(use_Right = "L", use_pierna = False):
    obj = bpy.context.active_object
    if obj and obj.type == 'ARMATURE' and obj.mode == 'POSE':
        armature = obj.pose
        if use_pierna == False:
            bone_a = armature.bones.get(f"SubControl_IK_Brazo_{use_Right}.003")
            bone_b = [
                armature.bones.get(f"Control_FK_Brazo_{use_Right}.001"),
                armature.bones.get(f"Control_FK_Brazo_{use_Right}.002"),
                armature.bones.get(f"Control_FK_Brazo_{use_Right}.003")
                ]
            bone_c = armature.bones.get(f"Control_IK_Brazo_{use_Right}.003")
        else:
            bone_a = armature.bones.get(f"SudIK_Pierna_{use_Right}.003")
            bone_b = [
                armature.bones.get(f"FK_Pierna_{use_Right}.001"),
                armature.bones.get(f"FK_Pierna_{use_Right}.002"),
                armature.bones.get(f"FK_Pierna_{use_Right}.003")
                      ]
            bone_c = armature.bones.get(f"SudIK_Pierna_{use_Right}.004")
        
        
        if bone_a and bone_b and bone_c:
            
            

            bone_a.bone.select = True
            # Aplicar la transformación visual de la pose
            bpy.context.view_layer.update()
            bpy.ops.pose.visual_transform_apply()
            bone_a.bone.select = False
            
            
            
            
            
            if not use_pierna:
                constraint = bone_c.constraints.new(type='COPY_TRANSFORMS')
                constraint.target = obj
                constraint.subtarget = bone_b[2].name

                bone_c.bone.select = True
                # Aplicar la transformación visual de la pose
                bpy.context.view_layer.update()
                bpy.ops.pose.visual_transform_apply()

                bone_c.constraints.remove(constraint)
            else:
                Crear_bone(obj, obj.data, bone_c, bone_b[2])
            

            