import bpy
import os
current_dir = os.path.dirname(__file__)

from Operadores.Rig_Creator_Operation.Creador_Bones import *

class CustomPanelCol(bpy.types.Operator):
    bl_idname = "wm.call_col_panel"
    bl_label = "Call Panel col"

    
    def execute(self, context):
        # Nombre completo del panel que quieres llamar
        panel_name = "VIEWColletions_layers"
        # Llama al panel
        bpy.ops.wm.call_panel(name=panel_name)
        
        return {'FINISHED'}

class CustomPanelprop(bpy.types.Operator):
    bl_idname = "wm.call_prop_panel"
    bl_label = "Call Panel prop"

    
    def execute(self, context):
        # Nombre completo del panel que quieres llamar
        panel_name_2 = "VIEWCustomProperties"
        # Llama al panel
        bpy.ops.wm.call_panel(name=panel_name_2)
        
        return {'FINISHED'}

class wmRig_Creator(bpy.types.Operator):
    bl_idname = "wm.rig_creator"
    bl_label = "Call Rig Creator"

    
    def execute(self, context):
        # Nombre completo del panel que quieres llamar
        panel_name_2 = "Rig_Creator"
        # Llama al panel
        bpy.ops.wm.call_panel(name=panel_name_2)
        
        return {'FINISHED'}

class wmAdd_Bone_Def(bpy.types.Operator):
    bl_idname = "wm.add_bone_def"
    bl_label = "Add Bone Def"

    @classmethod
    def poll(cls, context):
        # Verificar si el contexto es una armadura en modo pose
        obj = context.object
        return obj and obj.type == 'ARMATURE' and bpy.context.object.mode == 'EDIT'

    def execute(self, context):  
        bone_sin_def()
        return {'FINISHED'}
    
addon_keymaps = []

def reg_key():
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon

    if kc:
        
        km = kc.keymaps.new(name='3D View', space_type='VIEW_3D')
        
        #kmi = km.keymap_items.new("wm.call_col_panel", type="H", value="PRESS", ctrl=True, alt=True, shift= True)
        #kmi = km.keymap_items.new("wm.call_prop_panel", type="H", value="PRESS", ctrl=True, alt=True)
        #
        #kmi = km.keymap_items.new("wm.rig_creator", type="C", value="PRESS", ctrl=True, alt=True, shift= True)
        kmi = km.keymap_items.new("wm.add_bone_def", type="A", value="PRESS", ctrl=True, alt=False, shift= True)
        
        kmi = km.keymap_items.new('wm.call_menu_pie', type="C", value="PRESS", ctrl=True, alt=True, shift= True)
        kmi.properties.name = 'Call_Rig_Menu'
        
        addon_keymaps.append((km, kmi))

def unreg_key():
    for km, kmi in addon_keymaps:
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()



from Operadores.Auto_root import *
from Operadores.Fisicas import *

from Characters.Characters_H import *

from Characters.Call_CHT import *
from Operadores.Iman_Fk import *
from Paneles.Varios import *
from Operadores.optimizar_mesh import*
from Operadores.E_Generador import*

class General_operator(bpy.types.Operator):
    bl_idname = "gen.oper_h"
    bl_label = "General operator"

    type: bpy.props.StringProperty(default="")

    Bone_activo: bpy.props.StringProperty(default="")

    def execute(self, context):
        
        if self.type == "AUTO_ROOT":
            auto_root(self.Bone_activo)
        if self.type == "FISICAS":
            Fisicas_Run()

        if self.type == "RESET_DATA":
            reset_CTS()

        #Fk a IK
        if self.type == "IMAN_BRAZO_L":
            IMAN_BRAZO_L()
        if self.type == "IMAN_BRAZO_R":
            IMAN_BRAZO_R()
        if self.type == "IMAN_PIERNA_L":
            IMAN_PIERNA_L()
        if self.type == "IMAN_PIERNA_R":
            IMAN_PIERNA_R()
           
        #IK a FK
        if self.type == "IK_IMAN_BRAZO_L":
            IMAN_BRAZO_L(use_invert=True)
        if self.type == "IK_IMAN_BRAZO_R":
            IMAN_BRAZO_R(use_invert=True)
        if self.type == "IK_IMAN_PIERNA_L":
            IMAN_PIERNA_L(use_invert=True)
        if self.type == "IK_IMAN_PIERNA_R":
            IMAN_PIERNA_R(use_invert=True)
            
        #pole Ik
        if self.type == "IK_POLE_IMAN_BRAZO_L":
            IMAN_POLE_TARGET(use_Right = "L")
            
        if self.type == "IK_POLE_IMAN_BRAZO_R":
            IMAN_POLE_TARGET(use_Right = "R")
        
        if self.type == "IK_POLE_IMAN_PIERNA_L":
            IMAN_POLE_TARGET(use_Right = "L", use_pierna=True)
            
        if self.type == "IK_POLE_IMAN_PIERNA_R":
            IMAN_POLE_TARGET(use_Right = "R", use_pierna=True)
            
        if self.type == "OPTIMIZAR_MESH_LOW":
            optimizar_mesh_low()
        if self.type == "OPTIMIZAR_MESH_MED":
            optimizar_mesh_med()
        if self.type == "OPTIMIZAR_MESH_QUIT":
            optimizar_mesh_quit()
            
        if self.type == "G_RIG":
            G_rig()
            
            
        if self.type == "CALL_COL_MENU":
            bpy.ops.wm.call_menu(name='col.call_menu')
            
        if self.type == "CALL_BONE_MENU":
            bpy.ops.wm.call_menu(name='col.call_menu_prop_bone')
            
        if self.type == "CALL_ARMATURE_MENU":
            bpy.ops.wm.call_menu(name='col.call_menu_prop_armature')
            
        return {'FINISHED'}
    


