import bpy
import sys
import os
current_dir = os.path.dirname(__file__)
sys.path.append(current_dir)   


def append(collection_name):
    
    def Opcion_1():
        blend_file = 'SAVE_RIG_CREATOR.blend'

        # Obtener la ruta completa al directorio del addon
        addon_directory = os.path.dirname(bpy.data.filepath)
        blend_directory = os.path.join(addon_directory, 'Itms')
        blend_filepath = os.path.join(blend_directory, blend_file)

        print(f"Appending from: {blend_filepath}")

        bpy.ops.wm.append(
                directory=blend_filepath + r"\Collection",  # Ruta al directorio de la colección
                filename=collection_name,
            )
    def Opcion_2():
        # Obtener la ruta absoluta del directorio del addon
        addon_directory = os.path.dirname(os.path.abspath(__file__))

        # Construir la ruta al directorio que contiene el archivo .blend
        blend_directory = os.path.join(addon_directory, 'Itms')

        # Nombre del archivo .blend
        blend_file = 'SAVE_RIG_CREATOR.blend'

        # Construir la ruta completa al archivo .blend
        blend_filepath = os.path.join(blend_directory, blend_file)

        print(f"Attempting to append from: {blend_filepath}")

        # Verificar si el archivo .blend existe
        if not os.path.exists(blend_filepath):
            print(f"File not found: {blend_filepath}")
            return
    
        bpy.ops.wm.append(
                directory=blend_filepath + r"\Collection",
                filename=collection_name,
            )
    def Opcion_3():
        # Obtener la ruta absoluta del directorio del addon
        addon_directory = os.path.dirname(os.path.abspath(__file__))

        # Nombre del archivo .blend
        blend_file = 'SAVE_RIG_CREATOR.blend'

        print(f"Attempting to append {collection_name} from {blend_file}")

        # Cargar la colección desde el archivo .blend
        bpy.ops.wm.append(
            directory=blend_file,
            filename=collection_name,
        )
    try:
        Opcion_1()
        print(f"Successfully appended {collection_name} from {blend_filepath}")
    except Exception as e:
        try:
            Opcion_2()
        except Exception as e:
            Opcion_3()
            
        print(f"Failed to append {collection_name}: {e}")
        
    return
