import bpy 

def Add_Bones(Nombres_Base, Bones_name, Cuantos, New_Bones = []):
    
    def eliminar_sufijo_numero(Bones_name, cuantos):
        # Obtener la lista de sufijos numéricos
        sufijos = [".{:03d}".format(num) for num in range(1, 1000)]

        # Verificar si el nombre del hueso contiene alguno de los sufijos
        for sufijo in sufijos:
            if sufijo in Bones_name:
                # Eliminar el sufijo del nombre del hueso
                Bones_name = Bones_name.replace(sufijo, "")
                name = Bones_name + f".{cuantos+1:03}"
                break  # Salir del bucle después de eliminar el primer sufijo encontrado
            else:
                name = Bones_name + f".{cuantos+1:03}"
        return name

    for i in range(Cuantos):

        Bone_Name = Nombres_Base + eliminar_sufijo_numero(Bones_name, i)

        # Añadir el hueso al armature
        bpy.ops.armature.bone_primitive_add(name=Bone_Name)
        new_bone = list(bpy.context.object.data.edit_bones)[-1]
        # Añadir el hueso a la lista de nuevos huesos
        New_Bones.append(new_bone)
        

def Posicionar_Bones(Bone, head, tail, roll, length, tengo_length = True):

    Bone.head = head
    Bone.tail = tail
    Bone.roll = roll

    if tengo_length == True:
        Bone.length = length

def Posicionar_Bones_tail(Bone, head, tail, roll, length, tengo_length = True):

    Bone.head = head
    Bone.tail = tail
    Bone.length *= 2
    Bone.head = tail
    Bone.roll = roll

    if tengo_length == True:
        Bone.length = length

def Bone_Bucar_Pose(Bone_Name, Bones):
    for Bone in Bone_Name:
        b = bpy.context.object.pose.bones.get(Bone)
        Bones.append(b)

def bone_sin_def():
    # Agregar el hueso primitivo
    bpy.ops.armature.bone_primitive_add(name="Bone")
    
    # Obtener el nuevo hueso
    new_bone = list(bpy.context.object.data.edit_bones)[-1]
    
    # Obtener la posición del cursor 3D
    cursor_location = bpy.context.scene.cursor.location
    
    # Configurar las posiciones del nuevo hueso
    new_bone.head = cursor_location
    new_bone.tail = cursor_location
    new_bone.length = 1.0
    
    # Desactivar la deformación del hueso
    new_bone.use_deform = False
    
    
    
def posicionar_pole_bones(obj):
    
    base_heads_n = [
        "Base_Brazo_L.002",
        "Base_Brazo_R.002",
        ]
    
    base_tails_n = [
        "SubControl_IK_Brazo_L.003",
        "SubControl_IK_Brazo_R.003",
        ]
    
    pole_names = [
            "IK_(key:4ffff)pole_brazo_L",
            "IK_(key:4ffff)pole_brazo_R",
        ]
    
    for pole_name, base_head_n, base_tail_n in zip(pole_names, base_heads_n, base_tails_n):
        pole_bone = obj.data.edit_bones.get(pole_name)
        base_head = obj.data.edit_bones.get(base_head_n)
        base_tail = obj.data.edit_bones.get(base_tail_n)

        if pole_bone and base_head and base_tail:
            pole_bone.head = base_head.head
            pole_bone.tail = base_tail.head

    base_heads_n = [
        "Base_Pierna_L.002",
        "Base_Pierna_R.002"
        ]
    
    base_tails_n = [
        "SudIK_Pierna_L.003",
        "SudIK_Pierna_R.003",
        ]
    
    pole_names = [
            "IK_(key:4ffff)pole_Piena_L",
            "IK_(key:4ffff)pole_Piena_R"
        ]
    
    for pole_name, base_head_n, base_tail_n in zip(pole_names, base_heads_n, base_tails_n):
        pole_bone = obj.data.edit_bones.get(pole_name)
        base_head = obj.data.edit_bones.get(base_head_n)
        base_tail = obj.data.edit_bones.get(base_tail_n)

        if pole_bone and base_head and base_tail:
            pole_bone.head = base_head.head
            pole_bone.tail = base_tail.head