import bpy

import sys
import os
current_dir = os.path.dirname(__file__)
sys.path.append(current_dir)   

from Creador_Bones import * 

def Generator_Curve():
    
    Rig_props = bpy.context.scene.Rig_Creator_PropertyGroup 
    
    Armature = bpy.context.active_object
    bpy.ops.object.mode_set(mode='EDIT')
    selected_bones = [bone for bone in bpy.context.selected_editable_bones]

    if selected_bones:
        
        if Rig_props.use_curve_root:
            
            bone_root_curve = []
            
            Add_Bones(
            Rig_props.Base_name_curve_root, 
            selected_bones[0].name,
            1,
            bone_root_curve
            )
            
            bone_root_curve[0].color.palette = 'THEME01'
            
            Posicionar_Bones(
                bone_root_curve[0], selected_bones[0].head, 
                selected_bones[0].tail, selected_bones[0].roll, 
                selected_bones[0].length / 4, tengo_length = False
                )
            
        #add curve free
        bone_curve_free = []
        Add_Bones(
            Rig_props.Base_name_curve_free, 
            selected_bones[0].name, 
            (len(selected_bones) * 2), 
            bone_curve_free
            )
        
        bone_curve_cont = []
        Add_Bones(
            Rig_props.Base_name_curve_cont, 
            selected_bones[0].name, 
            (len(selected_bones)+1), 
            bone_curve_cont
            )
        
        for i in range(len(selected_bones)):
            Posicionar_Bones(
                bone_curve_free[i], selected_bones[i].head, 
                selected_bones[i].tail, selected_bones[i].roll, 
                selected_bones[0].length / 4, tengo_length = True
                )
            Posicionar_Bones(
                bone_curve_cont[i], selected_bones[i].head, 
                selected_bones[i].tail, selected_bones[i].roll, 
                selected_bones[0].length / 4, tengo_length = True
                )
            bone_curve_free[i].parent = bone_curve_cont[i]
            
        for i in range(len(selected_bones)):   
            Posicionar_Bones_tail(
                bone_curve_free[i+len(selected_bones)], selected_bones[i].head, 
                selected_bones[i].tail, selected_bones[i].roll,
                selected_bones[0].length / 4, tengo_length = True
                )
        
        Posicionar_Bones_tail(
                bone_curve_cont[-1], selected_bones[-1].head, 
                selected_bones[-1].tail, selected_bones[-1].roll,
                selected_bones[0].length / 4, tengo_length = True
                )
        
        for i in range(len(selected_bones)): 
            bone_curve_free[i+len(selected_bones)].parent = bone_curve_cont[i+1]
            
        for bone in bone_curve_free:
            bone.use_deform = False
            bone.color.palette = 'THEME03'
            

        for bone in bone_curve_cont:
            bone.use_deform = False
            bone.color.palette = 'THEME04'
            if Rig_props.use_curve_root:
                bone.parent = bone_root_curve[0]

        
        #modificar select bones
        for i in range(len(selected_bones)):
            
            selected_bones[i].bbone_handle_type_start = 'TANGENT'
            selected_bones[i].bbone_handle_type_end = 'TANGENT'
            selected_bones[i].bbone_segments = Rig_props.curve_int_Segments
            
            selected_bones[i].use_connect = False
            selected_bones[i].parent = bone_curve_free[i]
            selected_bones[i].bbone_custom_handle_start = bone_curve_free[i]

        for i in range(len(selected_bones)): 
            selected_bones[i].bbone_custom_handle_end = bone_curve_free[i+len(selected_bones)]

        
        #name
        name_bone_curve_free = []
        name_selected_bones = []
        name_bone_curve_cont = []
        
        def Append_name(Bone, donde):
            for b in Bone:
                donde.append(b.name)
                
        Append_name(bone_curve_free, name_bone_curve_free)
        Append_name(selected_bones, name_selected_bones)
        Append_name(bone_curve_cont, name_bone_curve_cont)
        
        if Rig_props.use_curve_root:
            name_bone_root_curve = []
            Append_name(bone_root_curve, name_bone_root_curve)

        #modo pose
        bpy.ops.object.mode_set(mode='POSE')

        #pose select 
        Pose_selected_bones = []
        Bone_Bucar_Pose(name_selected_bones, Pose_selected_bones)

        #pose bone curve free
        pose_bone_curve_free = []
        Bone_Bucar_Pose(name_bone_curve_free, pose_bone_curve_free)
        
        #name bone curve cont
        pose_bone_curve_cont = []
        Bone_Bucar_Pose(name_bone_curve_cont, pose_bone_curve_cont)
        
        if Rig_props.use_curve_root:
            pose_bone_root_curve = []
            Bone_Bucar_Pose(name_bone_root_curve, pose_bone_root_curve)
            
        #curve free generator pose
        if Pose_selected_bones and pose_bone_curve_free and name_bone_curve_cont:
            
            bpy.context.view_layer.objects.active = Armature
            
            #drive
            def add_drive(bone, Donde, control_bone, cual, use_menos_1 = False):
                # Añadir un controlador a la propiedad de ubicación X del cubo
                
                driver = bone.driver_add(Donde).driver

                # Configurar el controlador
                driver.type = 'SCRIPTED'
                var = driver.variables.new()
                var.name = "var"
                var.targets[0].id_type = 'OBJECT'
                var.targets[0].id = Armature
                #var.targets[0].bone_target = control_bone.name
                var.targets[0].data_path=f'pose.bones["{control_bone.name}"].{cual}'
                
                # Escribir la expresión del controlador
                if use_menos_1 == False:
                    driver.expression = "var-1"
                else:
                    driver.expression = "var"
            
            for i in range(len(Pose_selected_bones)):
                add_drive(
                    Pose_selected_bones[i],
                    "bbone_easein",
                    pose_bone_curve_free[i],
                    "scale[1]"
                    )
                
            for i in range(len(Pose_selected_bones)):

                add_drive(
                    Pose_selected_bones[i],
                    "bbone_easeout",
                    pose_bone_curve_free[i+len(Pose_selected_bones)],
                    "scale[1]"
                    )

            #if Rig_props.use_curve_root:
            #    
            #    # Iterar sobre los huesos seleccionados para añadir controladores
            #    for i in range(len(Pose_selected_bones)):
            #        add_drive(Pose_selected_bones[i], "bbone_scalein[0]", pose_bone_curve_cont[i], "scale[0]", use_menos_1=True)
            #        add_drive(Pose_selected_bones[i], "bbone_scalein[1]", pose_bone_curve_cont[i], "scale[1]", use_menos_1=True)
            #        add_drive(Pose_selected_bones[i], "bbone_scalein[2]", pose_bone_curve_cont[i], "scale[2]", use_menos_1=True)
#
            #    # Iterar sobre los huesos seleccionados (excepto el último) para añadir controladores
            #    for i in range(len(Pose_selected_bones) - 1):
            #        add_drive(Pose_selected_bones[i], "bbone_scaleout[0]", pose_bone_curve_cont[i+1], "scale[0]", use_menos_1=True)
            #        add_drive(Pose_selected_bones[i], "bbone_scaleout[1]", pose_bone_curve_cont[i+1], "scale[1]", use_menos_1=True)
            #        add_drive(Pose_selected_bones[i], "bbone_scaleout[2]", pose_bone_curve_cont[i+1], "scale[2]", use_menos_1=True)
            #    
            #    add_drive(Pose_selected_bones[-1], "bbone_scaleout[0]", pose_bone_curve_cont[-1], "scale[0]", use_menos_1=True)
            #    add_drive(Pose_selected_bones[-1], "bbone_scaleout[1]", pose_bone_curve_cont[-1], "scale[1]", use_menos_1=True)
            #    add_drive(Pose_selected_bones[-1], "bbone_scaleout[2]", pose_bone_curve_cont[-1], "scale[2]", use_menos_1=True)
            
            #constraint
            for i in range(len(Pose_selected_bones)):
                #Scale
                if Rig_props.use_curve_root:
                    constraint = Pose_selected_bones[i].constraints.new(type='COPY_SCALE')
                    constraint.target = Armature
                    constraint.subtarget = pose_bone_root_curve[0].name
                else:
                    constraint = Pose_selected_bones[i].constraints.new(type='COPY_SCALE')
                    constraint.target = Armature
                    constraint.subtarget = pose_bone_curve_cont[i].name
                
                
                #Stretch_to
                constraint = Pose_selected_bones[i].constraints.new(type='STRETCH_TO')
                constraint.target = Armature
                constraint.subtarget = pose_bone_curve_free[i+len(Pose_selected_bones)].name
                constraint.bulge = Rig_props.curve_bulge

                
                
            #visul bone
            if bpy.data.objects["Materiales_RIG_CREATOR.3"]:
                
                for i in range(len(pose_bone_curve_cont)):
                    
                    pose_bone_curve_cont[i].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.3"]

            if bpy.data.objects["Materiales_RIG_CREATOR.0"]:
                
                for i in range(len(Pose_selected_bones)):
                    
                    pose_bone_curve_free[i].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.0"]
                    pose_bone_curve_free[i].custom_shape_rotation_euler[0] = -1.5708
                    pose_bone_curve_free[i].custom_shape_scale_xyz[2] = 2
                    pose_bone_curve_free[i].custom_shape_scale_xyz[1] = 0
                    pose_bone_curve_free[i].custom_shape_scale_xyz[0] = 20
                    pose_bone_curve_free[i].lock_location[0] = True
                    pose_bone_curve_free[i].lock_location[1] = True
                    pose_bone_curve_free[i].lock_location[2] = True
                    pose_bone_curve_free[i].lock_scale[0] = True
                    pose_bone_curve_free[i].lock_scale[1] = False
                    pose_bone_curve_free[i].lock_scale[2] = True

                    
                for i in range(len(Pose_selected_bones)):
                    
                    valor = i+len(Pose_selected_bones)
                    
                    pose_bone_curve_free[valor].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.0"]
                    pose_bone_curve_free[valor].custom_shape_rotation_euler[0] = 1.5708
                    pose_bone_curve_free[valor].custom_shape_scale_xyz[2] = 2
                    pose_bone_curve_free[valor].custom_shape_scale_xyz[1] = 0
                    pose_bone_curve_free[valor].custom_shape_scale_xyz[0] = 20
                    pose_bone_curve_free[valor].lock_location[0] = True
                    pose_bone_curve_free[valor].lock_location[1] = True
                    pose_bone_curve_free[valor].lock_location[2] = True
                    pose_bone_curve_free[valor].lock_scale[0] = True
                    pose_bone_curve_free[valor].lock_scale[1] = False
                    pose_bone_curve_free[valor].lock_scale[2] = True
                
            if Rig_props.use_curve_root:
                
                pose_bone_root_curve[0].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.2"]
                pose_bone_root_curve[0].custom_shape_scale_xyz[2] = 1
                pose_bone_root_curve[0].custom_shape_scale_xyz[1] = 0
                pose_bone_root_curve[0].custom_shape_scale_xyz[0] = 1
