import bpy 


import sys
import os
current_dir = os.path.dirname(__file__)
sys.path.append(current_dir)   

from Creador_Bones import * 

def Generador_FK_DEF_ROT():
    active_scene = bpy.context.scene

    Rig_props = active_scene.Rig_Creator_PropertyGroup

    use_fk = Rig_props.use_fk
    use_def = Rig_props.use_def
    use_dedos = Rig_props.use_dedos
    use_dedos_rot = Rig_props.use_dedos_rot
    use_Segments = Rig_props.use_Segments
    use_Parent = Rig_props.use_Parent
    Base_name_DEF = Rig_props.Base_name_DEF
    Base_name_FK = Rig_props.Base_name_FK
    Base_name_DEDOS = Rig_props.Base_name_DEDOS

    if use_fk == False:
        use_dedos = False

    Armature = bpy.context.active_object
    bpy.ops.object.mode_set(mode='EDIT')

    selected_bones = [bone for bone in bpy.context.selected_editable_bones]

    if use_def == True:
        CONTROL = Base_name_DEF
        
    if use_fk == True: 
        FK = Base_name_FK
        
    if use_dedos == True:
        DEDOS = Base_name_DEDOS

    #si estoy en Edit Bone
    if Armature and Armature.type == 'ARMATURE':
        
        if selected_bones:
                
                Numero_Bones = (len(selected_bones)+1)

                Def_Bone = []
                Fk_Bone = []
                Dedos_Bone = []
                Fk_off_and_Rot = []
                
                #segments
                if use_Segments == True:
                        for bone in selected_bones:
                                bone.bbone_segments = Rig_props.int_Segments
                        
                #Def Bone
                if use_def == True:
                        #add bone def
                        Add_Bones(CONTROL, selected_bones[0].name, Numero_Bones, Def_Bone)
                        #pocionar los bone def
                        if Def_Bone:
                            for i in range(len(selected_bones)):
                                Posicionar_Bones(Def_Bone[i], selected_bones[i].head, 
                                                 selected_bones[i].tail, selected_bones[i].roll, 
                                                 selected_bones[0].length / 4, tengo_length = True)
                            if Numero_Bones > 1:
                                Posicionar_Bones_tail(Def_Bone[-1], selected_bones[-1].head, 
                                                    selected_bones[-1].tail, selected_bones[-1].roll, selected_bones[0].length / 4, 
                                                    tengo_length = True)
                            else:
                                Posicionar_Bones_tail(Def_Bone[-1], selected_bones[0].head, 
                                                    selected_bones[0].tail, selected_bones[0].roll, selected_bones[0].length / 4, 
                                                    tengo_length = True)

                            #deformacion apagada
                            for i in range(Numero_Bones):
                                Def_Bone[i].use_deform = False

                            #padre del hueso
                            if use_Parent == True:
                                if use_fk == False:
                                    selected_bones[0].parent = Def_Bone[0]
                                    
                            for Bone in Def_Bone:
                                Bone.color.palette = 'THEME09'
                #FK Controles:
                if use_fk == True:
                        Add_Bones(FK, selected_bones[0].name, Numero_Bones, Fk_Bone)

                        if Fk_Bone:
                            for i in range(len(selected_bones)):
                                Posicionar_Bones(Fk_Bone[i], selected_bones[i].head, 
                                                 selected_bones[i].tail, selected_bones[i].roll, 
                                                 selected_bones[i].length, tengo_length = False)
     
                            if Numero_Bones > 1:
                                Posicionar_Bones_tail(Fk_Bone[-1], selected_bones[-1].head, 
                                                    selected_bones[-1].tail, selected_bones[-1].roll, selected_bones[-1].length / 4, 
                                                    tengo_length = True)
                            else:
                                Posicionar_Bones_tail(Fk_Bone[-1], selected_bones[0].head, 
                                                    selected_bones[0].tail, selected_bones[0].roll, selected_bones[0].length / 4, 
                                                    tengo_length = True)

    
                            for bone in Fk_Bone:
                                bone.use_deform = False

                            for i in range(Numero_Bones-1):
                                Fk_Bone[i + 1].parent = Fk_Bone[i]
                                if len(selected_bones) > 1:
                                    if Fk_Bone[i + 1].parent != None:
                                        Fk_Bone[i + 1].use_connect = True

                            if use_Parent == True:
                                if use_def == True:
                                    selected_bones[0].parent = Def_Bone[0]
                                    for i in range(len(selected_bones)):
                                        Def_Bone[i].parent = Fk_Bone[i]
                                    Def_Bone[-1].parent = Fk_Bone[-2]
                                    Fk_Bone[-1].parent = selected_bones[-1]
                                    Fk_Bone[-1].use_connect = True
                                else:
                                    selected_bones[0].parent = Fk_Bone[0]
                                
                        
                        for Bone in Fk_Bone:
                                Bone.color.palette = 'THEME03'

                #Dedos Bones
                if use_dedos == True:
                    Add_Bones(DEDOS, selected_bones[0].name, 2, Dedos_Bone)
                    if Dedos_Bone:
       
                        Posicionar_Bones(Dedos_Bone[0], selected_bones[0].head, 
                                         selected_bones[0].tail, selected_bones[0].roll, 
                                         selected_bones[0].length / 2, tengo_length = True)
                        
                        Posicionar_Bones(Dedos_Bone[1], selected_bones[0].head, 
                                         selected_bones[-1].tail, selected_bones[0].roll, 
                                         selected_bones[0].length, tengo_length = False)
                        
                        D = Dedos_Bone[1].length
                        Dedos_Bone[1].length = D + selected_bones[0].length
                        Fk_Bone[0].parent = Dedos_Bone[1]
                        Dedos_Bone[1].parent = Dedos_Bone[0]
                        
                        
                        for bone in Dedos_Bone:
                             bone.use_deform = False
                             
                    Dedos_Bone[0].color.palette = 'THEME01'
                    Dedos_Bone[1].color.palette = 'THEME04'
                
                #si no esta el rot activo
                if use_fk == False and use_dedos_rot == True:
                    
                    Add_Bones(CONTROL, selected_bones[0].name, 1, Fk_off_and_Rot)
                    
                    if Fk_off_and_Rot:
                        Posicionar_Bones_tail(
                            Fk_off_and_Rot[0],
                            selected_bones[-1].head,
                            selected_bones[-1].tail,
                            selected_bones[-1].roll,
                            selected_bones[-1].length / 2,
                            tengo_length = True
                            )
                        
                        Fk_off_and_Rot[0].use_deform = False
                        Fk_off_and_Rot[0].parent = selected_bones[-1]
                        Fk_off_and_Rot[0].use_connect = True
                        
                #name
                Name_Def_Bone = []
                Name_Fk_Bone = []
                Name_Dedos_Bone = []
                Name_select_Bone = []
                Name_Fk_off_and_Rot = []
                
                def Append_name(Bone, donde):
                        for b in Bone:
                                donde.append(b.name)

                Append_name(Def_Bone, Name_Def_Bone)
                Append_name(Fk_Bone, Name_Fk_Bone)
                Append_name(Dedos_Bone, Name_Dedos_Bone)
                Append_name(selected_bones, Name_select_Bone)
                Append_name(Fk_off_and_Rot, Name_Fk_off_and_Rot)

        

        #modo pose
        bpy.ops.object.mode_set(mode='POSE')

        #pose select 
        Pose_selected_bones = []
        Bone_Bucar_Pose(Name_select_Bone, Pose_selected_bones)
        
        #def select pose
        if use_def == True:
            Pose_Def_Bone = []
            Bone_Bucar_Pose(Name_Def_Bone, Pose_Def_Bone)
        #fk select pose
        if use_fk == True:
            Pose_Fk_Bone = []
            Bone_Bucar_Pose(Name_Fk_Bone, Pose_Fk_Bone)
        #dedos select pose
        if use_dedos == True:
            Pose_Dedos_Bone = []
            Bone_Bucar_Pose(Name_Dedos_Bone, Pose_Dedos_Bone)
        #dedos Fk off and Rot
        if use_fk == False and use_dedos_rot == True:
            Pose_Fk_off_and_Rot = []
            Bone_Bucar_Pose(Name_Fk_off_and_Rot, Pose_Fk_off_and_Rot)

        
        #constraint a Bone
        if Pose_selected_bones:
            
                if use_fk == False and use_dedos_rot == True and use_def == True:
                    if Pose_Fk_off_and_Rot:
                        constraint = Pose_Fk_off_and_Rot[0].constraints.new(type='COPY_TRANSFORMS')
                        constraint.target = Armature
                        constraint.subtarget = Pose_Def_Bone[-1].name
                
                if use_def == True:
                        for i in range(len(Pose_selected_bones)):
                            constraint = Pose_selected_bones[i].constraints.new(type='COPY_TRANSFORMS')
                            constraint.target = Armature
                            constraint.subtarget = Pose_Def_Bone[i].name
                            constraint = Pose_selected_bones[i].constraints.new(type='STRETCH_TO')
                            constraint.target = Armature
                            constraint.subtarget = Pose_Def_Bone[i+1].name

                if use_fk == True:
                        if Pose_Fk_Bone[-1]:
                            constraint = Pose_Fk_Bone[-1].constraints.new(type='COPY_TRANSFORMS')
                            constraint.target = Armature
                            constraint.subtarget = Pose_Def_Bone[-1].name
                
                if use_dedos_rot == True:
                        if use_def and use_fk:
                                constraint = Pose_Def_Bone[-1].constraints.new(type='COPY_ROTATION')
                                constraint.target = Armature
                                constraint.subtarget = Pose_Fk_Bone[-2].name
                                constraint.mix_mode = 'BEFORE'
                                constraint.target_space = 'LOCAL'
                                constraint.owner_space = 'LOCAL'
                                

                
                if use_dedos == True:
                        
                        
                        if Pose_Fk_Bone[0]:
                                constraint = Pose_Fk_Bone[0].constraints.new(type='COPY_SCALE')
                                constraint.target = Armature
                                constraint.subtarget = Pose_Dedos_Bone[0].name
                        
                        if use_fk == True:
                                if len(Pose_Fk_Bone) > 1:
                                        for i in range(len(Pose_Fk_Bone)-1):
                                                constraint = Pose_Fk_Bone[i+1].constraints.new(type='TRANSFORM')
                                                constraint.target = Armature
                                                constraint.subtarget = Pose_Dedos_Bone[1].name
                                                constraint.target_space = 'LOCAL'
                                                constraint.owner_space = 'LOCAL'
                                                constraint.map_from = 'SCALE'
                                                constraint.from_min_y_scale = 0.2
                                                constraint.from_max_y_scale = 1.8
                                                constraint.map_to = 'ROTATION'
                                                constraint.map_to_x_from = 'Y'
                                                constraint.to_min_x_rot = 3.141592653589793
                                                constraint.to_max_x_rot = -3.141592653589793
                                                
                                        constraint_to_remove = None
                                        for constraint in Pose_Fk_Bone[-1].constraints:
                                            if constraint.type == 'TRANSFORM':
                                                constraint_to_remove = constraint

                                        if constraint_to_remove:
                                            Pose_Fk_Bone[-1].constraints.remove(constraint_to_remove)


        if Pose_selected_bones:

                if use_def == True:
                        if bpy.data.objects["Materiales_RIG_CREATOR.3"]:
                            for bone in Pose_Def_Bone:
                                bone.custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.3"]
                
                if use_fk == True:
                        if bpy.data.objects["Materiales_RIG_CREATOR.1"]:
                                for i in range(len(Pose_selected_bones)):
                                    Pose_Fk_Bone[i].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.1"]
                                    Pose_Fk_Bone[i].custom_shape_translation[1] = Pose_Fk_Bone[i].length / 2

                if use_dedos == True:
                        
                        Pose_Dedos_Bone[1].lock_scale[0] = True
                        Pose_Dedos_Bone[1].lock_scale[2] = True
                        Pose_Dedos_Bone[1].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.0"]
                        Pose_Dedos_Bone[1].custom_shape_rotation_euler[0] = -3.141592653589793 / 2
                        Pose_Dedos_Bone[1].custom_shape_scale_xyz[1] = 0 
                        Pose_Dedos_Bone[1].custom_shape_scale_xyz[0] *= 5 

                        Pose_Dedos_Bone[0].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.2"]
