import bpy 

icon_constraint = {
    'CAMERA_SOLVER':'CON_CAMERASOLVER',
    'FOLLOW_TRACK':'CON_FOLLOWTRACK',
    'OBJECT_SOLVER':'CON_OBJECTSOLVER',
    'COPY_LOCATION':'CON_LOCLIKE',
    'COPY_ROTATION':'CON_ROTLIKE',
    'COPY_SCALE':'CON_SIZELIKE',
    'COPY_TRANSFORMS':'CON_TRANSLIKE',
    'LIMIT_DISTANCE':'CON_DISTLIMIT',
    'LIMIT_LOCATION':'CON_LOCLIMIT',
    'LIMIT_ROTATION':'CON_ROTLIMIT',
    'LIMIT_SCALE':'CON_SIZELIMIT',
    'MAINTAIN_VOLUME':'CON_SAMEVOL',
    'TRANSFORM':'CON_TRANSFORM',
    'TRANSFORM_CACHE':'CON_TRANSFORM_CACHE',
    'CLAMP_TO':'CON_CLAMPTO',
    'DAMPED_TRACK':'CON_TRACKTO',
    'IK':'CON_KINEMATIC',
    'LOCKED_TRACK':'CON_LOCKTRACK',
    'SPLINE_IK':'CON_SPLINEIK',
    'STRETCH_TO':'CON_STRETCHTO',
    'TRACK_TO':'CON_TRACKTO',
    'ACTION':'ACTION',
    'ARMATURE':'CON_ARMATURE',
    'CHILD_OF':'CON_CHILDOF',
    'FLOOR':'CON_FLOOR',
    'FOLLOW_PATH':'CON_FOLLOWPATH',
    'PIVOT':'CON_PIVOT',
    'SHRINKWRAP':'CON_SHRINKWRAP',
}


#constraint en blender 
constraint_types = [
    ('CAMERA_SOLVER', "Camera Solver", 'CON_CAMERASOLVER'),
    ('FOLLOW_TRACK', "Follow Track", 'CON_FOLLOWTRACK'),
    ('OBJECT_SOLVER', "Object Solver", 'CON_OBJECTSOLVER'),
    ('COPY_LOCATION', "Copy Location", 'CON_LOCLIKE'),
    ('COPY_ROTATION', "Copy Rotation", 'CON_ROTLIKE'),
    ('COPY_SCALE', "Copy Scale", 'CON_SIZELIKE'),
    ('COPY_TRANSFORMS', "Copy Transforms", 'CON_TRANSLIKE'),
    ('LIMIT_DISTANCE', "Limit Distance", 'CON_DISTLIMIT'),
    ('LIMIT_LOCATION', "Limit Location", 'CON_LOCLIMIT'),
    ('LIMIT_ROTATION', "Limit Rotation", 'CON_ROTLIMIT'),
    ('LIMIT_SCALE', "Limit Scale", 'CON_SIZELIMIT'),
    ('MAINTAIN_VOLUME', "Maintain Volume", 'CON_SAMEVOL'),
    ('TRANSFORM', "Transformation", 'CON_TRANSFORM'),
    ('TRANSFORM_CACHE', "Transform Cache", 'CON_TRANSFORM_CACHE'),
    ('CLAMP_TO', "Clamp To", 'CON_CLAMPTO'),
    ('DAMPED_TRACK', "Damped Track", 'CON_TRACKTO'),
    ('IK', "Inverse Kinematic", 'CON_KINEMATIC'),
    ('LOCKED_TRACK', "Locked Track", 'CON_LOCKTRACK'),
    ('SPLINE_IK', "Spline IK", 'CON_SPLINEIK'),
    ('STRETCH_TO', "Stretch To", 'CON_STRETCHTO'),
    ('TRACK_TO', "Track To", 'CON_TRACKTO'),
    ('ACTION', "Action", 'ACTION'),
    ('ARMATURE', "Armature", 'CON_ARMATURE'),
    ('CHILD_OF', "Child Of", 'CON_CHILDOF'),
    ('FLOOR', "Floor", 'CON_FLOOR'),
    ('FOLLOW_PATH', "Follow Path", 'CON_FOLLOWPATH'),
    ('PIVOT', "Pivot", 'CON_PIVOT'),
    ('SHRINKWRAP', "Shrinkwrap", 'CON_SHRINKWRAP'),
]

def Constraint_list_Draw(self, context, use_Bone=True):
    
    layout = self.layout
 
    if use_Bone == True:
        bone = context.active_pose_bone
    
        if bone is not None:

            Bone_Constraint_list_index = bone.Bone_Constraint_list_index
            Bone_Constraint_list = bone.Bone_Constraint_list

            row = layout.row(align=False)
            row.template_list("BONE_CONST_UL_List", "", 
                              bone, "Bone_Constraint_list", 
                              bone, "Bone_Constraint_list_index",
                              rows=8 if bone.Bone_Constraint_list else 1,
                              )

            col = row.column(align=False)
            row_ = col.column(align=True)
            
            if Bone_Constraint_list:
               row_.active = True
            else:
                row_.active = False

            row_.operator("bone.const", text= "", icon="REMOVE").type = "X_CONST"
            row_ = col.column(align=True)
            
            if Bone_Constraint_list: 
                row_.operator("bone.const", text="" ,icon="DUPLICATE").type = "DUPLICATE_CONST"
                row_.operator("bone.const", text="" ,icon="CHECKMARK").type = "APPLY_CONST"
                row_.menu("Copy_Constraint_To_Active", text="", icon="DOWNARROW_HLT")

                col = col.column(align=True)
                if len(Bone_Constraint_list) > 1:
                    col.enabled = True
                else:
                    col.enabled = False
                op = col.operator("bone.const", text= "", icon="TRIA_UP")
                op.type = "NONE"
                op.direction = 'UP'
                op = col.operator("bone.const", text= "", icon="TRIA_DOWN")
                op.type = "NONE"
                op.direction = 'DOWN'
    else:
        
        obj = context.active_object
        
        if obj is not None:

            Object_Constraint_list_index = obj.Object_Constraint_list_index
            Object_Constraint_list = obj.Object_Constraint_list

            row = layout.row(align=False)
            row.template_list("OBJECT_CONST_UL_List", "", obj, "Object_Constraint_list", obj, "Object_Constraint_list_index",
                              rows=8 if obj.Object_Constraint_list else 1)

            col = row.column(align=False)

            row_ = col.column(align=True)
            if Object_Constraint_list:
               row_.active = True
            else:
                row_.active = False

            row_.operator("object.const", text= "", icon="REMOVE").type = "X_CONST"

            row_ = col.column(align=True)

            if Object_Constraint_list: 
                row_.operator("object.const", text="" ,icon="DUPLICATE").type = "DUPLICATE_CONST"
                row_.operator("object.const", text="" ,icon="CHECKMARK").type = "APPLY_CONST"
                row_.menu("Copy_Constraint_To_Active_OBJ", text="", icon="DOWNARROW_HLT")
                
                col = col.column(align=True)
                if len(Object_Constraint_list) > 1:
                    col.enabled = True
                else:
                    col.enabled = False
                op = col.operator("object.const", text= "", icon="TRIA_UP")
                op.type = "NONE"
                op.direction = 'UP'
                op = col.operator("object.const", text= "", icon="TRIA_DOWN")
                op.type = "NONE"
                op.direction = 'DOWN'
                
def Extra_Botones(self, context, use_Bone = True):
    
    layout = self.layout
    
    def Swith_icon(Value):
        if Value == True:
            return "RESTRICT_SELECT_OFF"
        else:
            return "RESTRICT_SELECT_ON"
    
    del_constraint, icon = "Clear Constraints", "PANEL_CLOSE"
    
    copy_constraint = "Copy Constraint"
    to_Active_Label = "    To Active"
    to_Active_Label_Idex = "    To Active (Index)"
    
    if use_Bone == True:
        selected_bones = bpy.context.selected_pose_bones
        layout.operator("bone.const", text=del_constraint, icon=icon).type = "DEL_ALL"
        layout.separator(factor=1.0)
        layout_ = layout.column()
        Bone = bpy.context.active_pose_bone
        if len(selected_bones) > 1 and Bone:
            layout_.enabled = True
        else:
            layout_.enabled = False
        layout_.label(text=copy_constraint, icon=Swith_icon(layout_.enabled))
        layout_.operator("bone.const", text=to_Active_Label).type = "COPY_SEL_CONST"
        layout_.operator("bone.const", text=to_Active_Label_Idex).type = "COPY_SEL_CONST_INDEX"
    else:
        selected_obj = bpy.context.selected_objects
        layout.operator("object.const", text=del_constraint, icon=icon).type = "DEL_ALL"
        layout.separator(factor=1.0)
        layout_ = layout.column()
        if len(selected_obj) > 1:
            layout_.enabled = True
        else:
            layout_.enabled = False 
        layout_.label(text=copy_constraint, icon=Swith_icon(layout_.enabled))
        layout_.operator("object.const", text=to_Active_Label).type = "COPY_SEL_CONST"
        layout_.operator("object.const", text=to_Active_Label_Idex).type = "COPY_SEL_CONST_INDEX"
             


def edit_icon(self, context):
    save_const = context.scene.save_constraint
    if save_const:
        save_constraint_index = context.scene.save_constraint_index
        if 0 <= save_constraint_index < len(save_const):
            props = save_const[save_constraint_index]

            for const in constraint_types:
                if props.type == const[0]:
                    props.icon = const[2]

class save_constraint_group(bpy.types.PropertyGroup):
    pass
    

def None_Constraint():
    
    save_constraint_index = bpy.context.scene.save_constraint_index
    save_const = bpy.context.scene.save_constraint
    
    save = save_const.add()
    
    
    for i in range(len(bpy.context.scene.save_constraint)):
        bpy.context.scene.save_constraint_index = i
        
def Delet_Constraint():
    bpy.ops.uilist.entry_remove(list_path="scene.save_constraint", active_index_path="scene.save_constraint_index")

def Move_const(Donde):
    if Donde == "UP_CONST":
        bpy.ops.uilist.entry_move(list_path="scene.save_constraint", active_index_path="scene.save_constraint_index", direction='UP')
    else:
        bpy.ops.uilist.entry_move(list_path="scene.save_constraint", active_index_path="scene.save_constraint_index", direction='DOWN')

def save_Constraint():
    
    save_constraint_index = bpy.context.scene.save_constraint_index
    save_const = bpy.context.scene.save_constraint
    
    Bone = bpy.context.active_pose_bone
    
    if Bone:
        for constraint in Bone.constraints:
            save = save_const.add()
            save.name = constraint.name
            save.type = constraint.type
            
            if hasattr(constraint, 'target'):
                save.use_active_object = False
                save.target = constraint.target
                
            if hasattr(constraint, 'subtarget'):
                save.use_active_bone = False
                save.bone = constraint.subtarget
            
            if hasattr(constraint, 'target_space'):
                save.target_space = constraint.target_space

            if hasattr(constraint, 'owner_space'):
               save.owner_space = constraint.owner_space
               
            if hasattr(constraint, 'influence'):   
                save.influence = constraint.influence
    
    for i in range(len(bpy.context.scene.save_constraint)):
        bpy.context.scene.save_constraint_index = i

def add_const_to_Bone(custom, cont_Constraint):
    
    Rig_props = bpy.context.scene.Rig_Creator_PropertyGroup
    
    save_constraint_index = bpy.context.scene.save_constraint_index
    save_const = bpy.context.scene.save_constraint
    
    if 0 <= save_constraint_index < len(save_const):
        
        if custom != "CUSTOM":
            props = save_const[save_constraint_index]
        else:
            props = cont_Constraint
            
        selected_bones = bpy.context.selected_pose_bones
        Bone = bpy.context.active_pose_bone
        
        
        if selected_bones:
            def add_Const(Bone, padreBone):
                constraint = Bone.constraints.new(type=props.type)
            
                constraint.name = props.name

                if hasattr(constraint, 'target'):

                    if props.use_active_object:
                        constraint.target = bpy.context.active_object
                    else:
                        if props.target:
                            constraint.target = props.target

                if hasattr(constraint, 'subtarget'):
                
                    if props.use_active_bone:
                        constraint.subtarget = padreBone.name
                    else:
                        constraint.subtarget = props.bone

                if hasattr(constraint, 'target_space'):
                   constraint.target_space = props.target_space

                if hasattr(constraint, 'owner_space'):
                   constraint.owner_space = props.owner_space

                if hasattr(constraint, 'influence'):   
                    constraint.influence = props.influence

            padreBone = bpy.context.selected_pose_bones[-1]
            
            if Rig_props.Add_activo_or_Seletion == 'ACTIVE':
                add_Const(Bone, padreBone)
            else:
                for bones in selected_bones:
                    if props.type not in [
                    'CAMERA_SOLVER','FOLLOW_TRACK','OBJECT_SOLVER',
                    'LIMIT_LOCATION','LIMIT_ROTATION','LIMIT_SCALE',
                    ]:
                        if not bones.name == Bone.name:
                            add_Const(bones, Bone)
                    else:
                        add_Const(bones, Bone)
                         
 
def ADD_DEFAULT():

    save_constraint_index = bpy.context.scene.save_constraint_index
    save_const = bpy.context.scene.save_constraint
    
    for constraint in constraint_types:
                    
        # Verificar si ya existe un constraint con este nombre
        exists = False
        for save in save_const:
            if save.name == constraint[1]:
                exists = True
                break
            
        # Si no existe, agregarlo
        if not exists:
            new_save = save_const.add()
            new_save.name = constraint[1]
            new_save.type = constraint[0]
            new_save.icon = constraint[2]
                
        for i in range(len(bpy.context.scene.save_constraint)):
            bpy.context.scene.save_constraint_index = i
            
@bpy.app.handlers.persistent     
def Existe_ADD_DEFAULT(dummy):
    return
    
bpy.app.handlers.load_post.append(Existe_ADD_DEFAULT)

def DEL_ALL():
    save_constraint_index = bpy.context.scene.save_constraint_index
    save_const = bpy.context.scene.save_constraint
    
    # Borrar todos los elementos de la lista save_constraint
    save_const.clear()

    # Restablecer el índice a cero
    bpy.context.scene.save_constraint_index = 0
            