import bpy 
import sys
import os
from bl_ui.generic_ui_list import draw_ui_list
current_dir = os.path.dirname(__file__)
sys.path.append(current_dir) 

from Operadores.Rig_Creator_Operation.Creador_Bones import *

def Resect_Armature():
    
    bpy.ops.object.mode_set(mode='EDIT')    

    Armature = bpy.context.active_object
    Bones_get = Armature.data.edit_bones    

    def Posicionar_Bones(Bone, head, tail, roll, length, tengo_length = True):  

        Bone.head = head
        Bone.tail = tail
        Bone.roll = roll    

        if tengo_length == True:
            Bone.length = length
        else:
            print("no quiero length en el bone")    

    def pocioner_Bones_tail(Bone, head, tail, roll, length, tengo_length = True):   


        Bone.head = head
        Bone.tail = tail
        Bone.length *= 2
        Bone.head = tail
        Bone.roll = roll    

        if tengo_length == True:
            Bone.length = length
        else:
            print("no quiero length en el bone")    

    def Encontral_Bones(Nombre_Bone_Base, repeticiones, append):    

        for i in range(repeticiones):
            Nombre_Bone = f"{Nombre_Bone_Base}.{(i+1):03}"
            hueso = Bones_get.get(Nombre_Bone)
            append.append(hueso)    

    def Encontral_bones_2(name = [], donde=[]):
        for n in name:
            donde.append(Bones_get.get(n))
    if Armature or Armature.type == 'ARMATURE': 
        
        
        
        #Ojos
        base_Ojos_L, base_Ojos_R = Bones_get.get("Base_Ojo_L"), Bones_get.get("Base_Ojo_R")
        
        def posicionar(donde):
            return (
                    donde.head.x, 
                    (donde.head.y+((donde.length*3)*-1)), 
                    donde.head.z)
            
        def base_ojos(base_Ojos, def_ojos, ojo):
            if base_Ojos:
                #def ojos
                def_ojos = Bones_get.get(def_ojos)
                if def_ojos:
                    Posicionar_Bones(
                        def_ojos, 
                        base_Ojos.head, 
                        base_Ojos.tail, 
                        base_Ojos.roll, 
                        base_Ojos.length / 2, 
                        tengo_length = True)

                #control ojos
                ojos = Bones_get.get(ojo)
                if ojos:

                    donde = base_Ojos
                    

                    ojos.head = posicionar(donde)
                    ojos.tail = posicionar(donde)

                    ojos.roll = 0
                    ojos.length = 0.057642
        
        base_ojos(base_Ojos_L, "def_ojo_L", "Ojo_L")      
        base_ojos(base_Ojos_R, "def_ojo_R", "Ojo_R") 
        
        #constrol oJos
        if base_Ojos_L and base_Ojos_R:
            Ojos = [Bones_get.get("Ojos"), Bones_get.get("Ojos.001"), Bones_get.get("Ojos.002")]
            if Ojos:
                L = posicionar(base_Ojos_L)
                R = posicionar(base_Ojos_R)
                p = (
                    ((L[0]+R[0])/2),
                    ((L[1]+R[1])/2),
                    ((L[2]+R[2])/2),
                    )
                for bone in Ojos:
                    
                    bone.head = p 
                    bone.tail = p

                    bone.roll = 0
                    bone.length = 0.057642
                    
        #Root_Mover
        Root_Mover = Bones_get.get("Root_Mover")
        if Root_Mover:
            Posicionar_Bones(Root_Mover, [0, 0, 0], [0, -0.90508, 0], 0,
                                             1, tengo_length = True)    


        #Columna_Base
        Columna_base = []
        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Columna.{i+1:03}") for i in range(6)):
            Encontral_Bones("Base_Columna", 6, Columna_base)    

        if Columna_base:
            #Columna_Def
            Columna_Def = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Columna.{i+1:03}") for i in range(6)):
                Encontral_Bones("Def_Columna", 6, Columna_Def)  

            if Columna_base or Columna_Def:
                for i in range(6):
                    if i < len(Columna_base) or i < len(Columna_Def):
                        Posicionar_Bones(Columna_Def[i], Columna_base[i].head, Columna_base[i].tail, Columna_base[i].roll,
                                         Columna_base[i].length, tengo_length = False)  

            #Cabeza_Controles
            Cabeza_controles = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Columna.{i+1:03}") for i in range(6)):
                Encontral_Bones("Control_Cabeza", 3, Cabeza_controles)  

            if Cabeza_controles:
                Posicionar_Bones(Cabeza_controles[0], Columna_base[5].head, Columna_base[5].tail, Columna_base[5].roll,
                                             Columna_base[5].length, tengo_length = False)  

                Posicionar_Bones(Cabeza_controles[1], Columna_base[5].head, Columna_base[5].tail, Columna_base[5].roll,
                                             Columna_base[5].length / 4, tengo_length = True)
                pocioner_Bones_tail(Cabeza_controles[2], Columna_base[5].head, Columna_base[5].tail, Columna_base[5].roll, 
                                    Columna_base[5].length / 4, tengo_length = True)    

            #Cuello_Controles
            Cuello_controles = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Columna.{i+1:03}") for i in range(6)):
                Encontral_Bones("Control_Cuello", 3, Cuello_controles)  

            if Cuello_controles:
                Posicionar_Bones(Cuello_controles[0], Columna_base[4].head, Columna_base[4].tail, Columna_base[4].roll,
                                                 Columna_base[4].length, tengo_length = False)  

                Posicionar_Bones(Cuello_controles[1], Columna_base[4].head, Columna_base[4].tail, Columna_base[4].roll,
                                             Columna_base[4].length / 4, tengo_length = True)
                pocioner_Bones_tail(Cuello_controles[2], Columna_base[4].head, Columna_base[4].tail, Columna_base[4].roll, 
                                    Columna_base[4].length / 4, tengo_length = True)    

            #Rot_Cabeza

            Rot_Cabeza = Bones_get.get("Rot_Cabeza")
            if Rot_Cabeza:
                Posicionar_Bones(Rot_Cabeza, Columna_base[4].head, Columna_base[4].head, 0,
                                                 Columna_base[4].length / 2, tengo_length = True)   

            #Control_Def_Columna    

            Control_Def_Columna = [] 
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Columna.{i+1:03}") for i in range(6)):
                Encontral_Bones("Control_Def_Columna", 4, Control_Def_Columna)  

            if Control_Def_Columna:
                for i in range(4):
                            Posicionar_Bones(Control_Def_Columna[i], Columna_base[i].head, Columna_base[i].tail, Columna_base[i].roll,
                                             Columna_base[i].length / 4, tengo_length = True)   

            #SubControl_Def_Columna 

            SubControl_Def_Columna = [] 
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Columna.{i+1:03}") for i in range(6)):
                Encontral_Bones("SubControl_Def_Columna", 2, SubControl_Def_Columna)    

            if SubControl_Def_Columna or Control_Def_Columna:
                for i in range(2):
                            Posicionar_Bones(SubControl_Def_Columna[i], Control_Def_Columna[2].head, Control_Def_Columna[2].tail, 
                                             Control_Def_Columna[2].roll,
                                             Control_Def_Columna[2].length / 4, tengo_length = False)   

            #Hombros          
            Hombros = Bones_get.get("Hombros")   
            if Hombros:
                Posicionar_Bones(Hombros, Columna_base[2].head, Columna_base[3].tail, 
                                                 Columna_base[2].roll,
                                                 Columna_base[2].length / 4, tengo_length = False)  

            #Control_UP_Columna
            Control_UP_Columna = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Columna.{i+1:03}") for i in range(6)):
                Encontral_Bones("Control_UP_Columna", 2, Control_UP_Columna)    

            if Control_UP_Columna:
            
                for i in range(2):
                    Posicionar_Bones(Control_UP_Columna[i], Columna_base[i + 2].head, Columna_base[i + 2].tail, 
                                             Columna_base[i + 2].roll,
                                             Columna_base[i + 2].length / 4, tengo_length = False)  

            #Cadera      
            Cadera =  Bones_get.get("Cadera")  
            if Cadera:
                Posicionar_Bones(Cadera, Columna_base[1].tail, Columna_base[0].head, 
                                                 Columna_base[1].roll,
                                                 Columna_base[1].length / 4, tengo_length = False)  


            #Base_Cadera_L or Base_Cadera_R
            Base_Cadera_L = Bones_get.get("Base_Cadera_L") 
            Base_Cadera_R = Bones_get.get("Base_Cadera_R") 
            #Def_Cadera_L or Def_Cadera_L
            Def_Cadera_L = Bones_get.get("Def_Cadera_L") 
            Def_Cadera_R = Bones_get.get("Def_Cadera_R")
            if Def_Cadera_L or Def_Cadera_R:
                Posicionar_Bones(Def_Cadera_L, Base_Cadera_L.head, Base_Cadera_L.tail, Base_Cadera_L.roll,
                                 Base_Cadera_L.length / 4, tengo_length = False) 
                Posicionar_Bones(Def_Cadera_R, Base_Cadera_R.head, Base_Cadera_R.tail, Base_Cadera_R.roll,
                                 Base_Cadera_R.length / 4, tengo_length = False)    

            #Control_Down_Columna
            Control_Down_Columna = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Columna.{i+1:03}") for i in range(6)):
                Encontral_Bones("Control_Down_Columna", 2, Control_Down_Columna)    

            if Control_Down_Columna:    

                Posicionar_Bones(Control_Down_Columna[0], Columna_base[1].tail, Columna_base[1].head, Columna_base[1].roll,
                                 Columna_base[1].length / 4, tengo_length = False) 
                Posicionar_Bones(Control_Down_Columna[1], Columna_base[0].tail, Columna_base[0].head, Columna_base[0].roll,
                                 Columna_base[0].length / 4, tengo_length = False)  

            #Root_Cadera
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Columna.{i+1:03}") for i in range(6)): 
                Root_Cadera = Bones_get.get("Root_Cadera")  

                if Root_Cadera:
                    Posicionar_Bones(Root_Cadera, Columna_base[0].head, Columna_base[0].head, Columna_base[0].roll,
                                     Columna_base[0].length, tengo_length = True)   

        #Base_Hombro_L or Base_Hombro_R
        Base_Hombro_L = []
        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Hombro_L.{i+1:03}") for i in range(2)):
            Encontral_Bones("Base_Hombro_L", 2, Base_Hombro_L)
        Base_Hombro_R = []
        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Hombro_R.{i+1:03}") for i in range(2)):
            Encontral_Bones("Base_Hombro_R", 2, Base_Hombro_R)  

        if Base_Hombro_L or Base_Hombro_R:  

            #Def_Hombros_L or Def_Hombros_R
            Def_Hombros_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Hombro_L.{i+1:03}") for i in range(2)):
                Encontral_Bones("Def_Hombros_L", 2, Def_Hombros_L)
            Def_Hombros_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Hombro_R.{i+1:03}") for i in range(2)):
                Encontral_Bones("Def_Hombros_R", 2, Def_Hombros_R)  

            if Def_Hombros_L or Def_Hombros_R:  

                for i in range(2):
                    Posicionar_Bones(Def_Hombros_L[i], Base_Hombro_L[i].head, Base_Hombro_L[i].tail, Base_Hombro_L[i].roll,
                                 Base_Hombro_L[i].length, tengo_length = False)     

                    Posicionar_Bones(Def_Hombros_R[i], Base_Hombro_R[i].head, Base_Hombro_R[i].tail, Base_Hombro_R[i].roll,
                                 Base_Hombro_R[i].length, tengo_length = False)     

            #Control_Hombros_L or Control_Hombros_R
            Control_Hombros_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Hombro_L.{i+1:03}") for i in range(2)):
                Encontral_Bones("Control_Hombros_L", 3, Control_Hombros_L)
            Control_Hombros_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Hombro_R.{i+1:03}") for i in range(2)):
                Encontral_Bones("Control_Hombros_R", 3, Control_Hombros_R)  

            if Control_Hombros_L or Control_Hombros_R:  

                Posicionar_Bones(Control_Hombros_L[0], Base_Hombro_L[1].head, Base_Hombro_L[1].tail, Base_Hombro_L[1].roll,
                                 Base_Hombro_L[1].length, tengo_length = False) 
                Posicionar_Bones(Control_Hombros_L[1], Base_Hombro_L[1].head, Base_Hombro_L[1].head, Base_Hombro_L[1].roll,
                                 Base_Hombro_L[1].length /4, tengo_length = True)
                pocioner_Bones_tail(Control_Hombros_L[2], Base_Hombro_L[1].head, Base_Hombro_L[1].tail, Base_Hombro_L[1].roll, 
                                    Base_Hombro_L[1].length / 4, tengo_length = True)   


                Posicionar_Bones(Control_Hombros_R[0], Base_Hombro_R[1].head, Base_Hombro_R[1].tail, Base_Hombro_R[1].roll,
                                 Base_Hombro_R[1].length, tengo_length = False) 
                Posicionar_Bones(Control_Hombros_R[1], Base_Hombro_R[1].head, Base_Hombro_R[1].tail, Base_Hombro_R[1].roll,
                                 Base_Hombro_R[1].length / 4, tengo_length = True) 
                pocioner_Bones_tail(Control_Hombros_R[2], Base_Hombro_R[1].head, Base_Hombro_R[1].tail, Base_Hombro_R[1].roll, 
                                    Base_Hombro_R[1].length / 4, tengo_length = True)   


        #Base_Brazo_L or Base_Brazo_R
        Base_Brazo_L = []
        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
            Encontral_Bones("Base_Brazo_L", 3, Base_Brazo_L)
        Base_Brazo_R = []
        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
            Encontral_Bones("Base_Brazo_R", 3, Base_Brazo_R)    


        if Base_Brazo_L or Base_Brazo_R:    

            #Root_Brazo_L or Root_Brazo_R
            Root_Brazo_L = Bones_get.get("Root_Brazo_L.001")
            Root_Brazo_R = Bones_get.get("Root_Brazo_R.001")
            if Root_Brazo_L or Root_Brazo_R:
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                    Posicionar_Bones(Root_Brazo_L, Base_Brazo_L[0].head, Base_Brazo_L[0].tail, 
                                     Base_Brazo_L[0].roll, Base_Brazo_L[0].length / 4, tengo_length = True)
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):    
                    Posicionar_Bones(Root_Brazo_R, Base_Brazo_R[0].head, Base_Brazo_R[0].tail, 
                                     Base_Brazo_R[0].roll, Base_Brazo_R[0].length / 4, tengo_length = True) 

            #Def_Brazo_UP_L or Def_Brazo_UP_R
            Def_Brazo_UP_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                Encontral_Bones("Def_Brazo_UP_L", 2, Def_Brazo_UP_L)
            else:
                Def_Brazo_UP_L == None

            Def_Brazo_UP_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                Encontral_Bones("Def_Brazo_UP_R", 2, Def_Brazo_UP_R)
            else:
                Def_Brazo_UP_R == None  

            if Def_Brazo_UP_L:
            
                Posicionar_Bones(Def_Brazo_UP_L[0], Base_Brazo_L[0].head, ((Base_Brazo_L[0].tail + Base_Brazo_L[0].head) / 2), 
                                 Base_Brazo_L[0].roll,
                                 Base_Brazo_L[0].length, tengo_length = False) 
                Posicionar_Bones(Def_Brazo_UP_L[1], ((Base_Brazo_L[0].tail + Base_Brazo_L[0].head) / 2),Base_Brazo_L[0].tail , 
                                 Base_Brazo_L[0].roll,
                                 Base_Brazo_L[0].length, tengo_length = False)

            if Def_Brazo_UP_R:  

                Posicionar_Bones(Def_Brazo_UP_R[0], Base_Brazo_R[0].head, ((Base_Brazo_R[0].tail + Base_Brazo_R[0].head) / 2), 
                                 Base_Brazo_R[0].roll,
                                 Base_Brazo_R[0].length, tengo_length = False) 
                Posicionar_Bones(Def_Brazo_UP_R[1], ((Base_Brazo_R[0].tail + Base_Brazo_R[0].head) / 2),Base_Brazo_R[0].tail , 
                                 Base_Brazo_R[0].roll,
                                 Base_Brazo_R[0].length, tengo_length = False)  

            #Def_Brazo_DOWN_L or Def_Brazo_DOWN_R
            Def_Brazo_DOWN_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                Encontral_Bones("Def_Brazo_DOWN_L", 2, Def_Brazo_DOWN_L)
            Def_Brazo_DOWN_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                Encontral_Bones("Def_Brazo_DOWN_R", 2, Def_Brazo_DOWN_R)    

            if Def_Brazo_DOWN_L or Def_Brazo_DOWN_R:    

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):  

                    Posicionar_Bones(Def_Brazo_DOWN_L[0], Base_Brazo_L[1].head, ((Base_Brazo_L[1].tail + Base_Brazo_L[1].head) / 2), 
                                     Base_Brazo_L[1].roll,
                                     Base_Brazo_L[1].length, tengo_length = False) 
                    Posicionar_Bones(Def_Brazo_DOWN_L[1], ((Base_Brazo_L[1].tail + Base_Brazo_L[1].head) / 2),Base_Brazo_L[1].tail , 
                                     Base_Brazo_L[1].roll,
                                     Base_Brazo_L[1].length, tengo_length = False)

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):  

                    Posicionar_Bones(Def_Brazo_DOWN_R[0], Base_Brazo_R[1].head, ((Base_Brazo_R[1].tail + Base_Brazo_R[1].head) / 2), 
                                     Base_Brazo_R[1].roll,
                                     Base_Brazo_R[1].length, tengo_length = False) 
                    Posicionar_Bones(Def_Brazo_DOWN_R[1], ((Base_Brazo_R[1].tail + Base_Brazo_R[1].head) / 2),Base_Brazo_R[1].tail , 
                                     Base_Brazo_R[1].roll,
                                     Base_Brazo_R[1].length, tengo_length = False)  

            #Def_Mano_L or Def_Mano_R
            Def_Mano_L = Bones_get.get("Def_Mano_L.001") 
            Def_Mano_R = Bones_get.get("Def_Mano_R.001")    

            if Def_Mano_L or Def_Mano_R:
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                    Posicionar_Bones(Def_Mano_L, Base_Brazo_L[2].head, Base_Brazo_L[2].tail, Base_Brazo_L[2].roll,
                                     Base_Brazo_L[2].length, tengo_length = False)
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                    Posicionar_Bones(Def_Mano_R, Base_Brazo_R[2].head, Base_Brazo_R[2].tail, Base_Brazo_R[2].roll,
                                     Base_Brazo_R[2].length, tengo_length = False)      

            #Control_Rot_Brazo_L or Control_Rot_Brazo_R
            Control_Rot_Brazo_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                Encontral_Bones("Control_Rot_Brazo_L", 3, Control_Rot_Brazo_L)
            Control_Rot_Brazo_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                Encontral_Bones("Control_Rot_Brazo_R", 3, Control_Rot_Brazo_R)  

            if Control_Rot_Brazo_L or Control_Rot_Brazo_R:
                for i in range(3):
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(Control_Rot_Brazo_L[i], Base_Brazo_L[i].head, Base_Brazo_L[i].tail, Base_Brazo_L[i].roll,
                                     Base_Brazo_L[i].length, tengo_length = False)

                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(Control_Rot_Brazo_R[i], Base_Brazo_R[i].head, Base_Brazo_R[i].tail, Base_Brazo_R[i].roll,
                                     Base_Brazo_R[i].length, tengo_length = False)  

            #Control_Def_Brazo_L or Control_Def_Brazo_R
            Control_Def_Brazo_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                Encontral_Bones("Control_Def_Brazo_L", 2, Control_Def_Brazo_L)
            Control_Def_Brazo_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                Encontral_Bones("Control_Def_Brazo_R", 2, Control_Def_Brazo_R)  

            if Control_Def_Brazo_L or Control_Def_Brazo_R:
                for i in range(2):  

                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(Control_Def_Brazo_L[i], Base_Brazo_L[i].head, Base_Brazo_L[i].tail, Base_Brazo_L[i].roll,
                                     Base_Brazo_L[i].length, tengo_length = False)

                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(Control_Def_Brazo_R[i], Base_Brazo_R[i].head, Base_Brazo_R[i].tail, Base_Brazo_R[i].roll,
                                     Base_Brazo_R[i].length, tengo_length = False)  

            #SubControl_Def_Brazo_L or SubControl_Def_Brazo_R 
            SubControl_Def_Brazo_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                Encontral_Bones("SubControl_Def_Brazo_L", 3, SubControl_Def_Brazo_L)
            SubControl_Def_Brazo_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                Encontral_Bones("SubControl_Def_Brazo_R", 3, SubControl_Def_Brazo_R)    

            if SubControl_Def_Brazo_L or SubControl_Def_Brazo_R:
                for i in range(2):
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(SubControl_Def_Brazo_L[i], Base_Brazo_L[i].head, Base_Brazo_L[i].tail, Base_Brazo_L[i].roll,
                                     Base_Brazo_L[0].length / 4, tengo_length = True)

                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(SubControl_Def_Brazo_R[i], Base_Brazo_R[i].head, Base_Brazo_R[i].tail, Base_Brazo_R[i].roll,
                                     Base_Brazo_R[0].length / 4, tengo_length = True)   

            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                pocioner_Bones_tail(SubControl_Def_Brazo_L[2], Base_Brazo_L[1].head,  Base_Brazo_L[1].tail, 
                                     Base_Brazo_L[1].roll,  Base_Brazo_L[0].length / 4, tengo_length = True)

            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                pocioner_Bones_tail(SubControl_Def_Brazo_R[2], Base_Brazo_R[1].head,  Base_Brazo_R[1].tail, 
                                     Base_Brazo_R[1].roll,  Base_Brazo_R[0].length / 4, tengo_length = True)    

            #Control_FK_Brazo_L or Control_FK_Brazo_R
            Control_FK_Brazo_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                Encontral_Bones("Control_FK_Brazo_L", 3, Control_FK_Brazo_L)
            Control_FK_Brazo_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                Encontral_Bones("Control_FK_Brazo_R", 3, Control_FK_Brazo_R)    

            if Control_FK_Brazo_L or Control_FK_Brazo_R:
                for i in range(3):  

                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(Control_FK_Brazo_L[i], Base_Brazo_L[i].head, Base_Brazo_L[i].tail, Base_Brazo_L[i].roll,
                                     Base_Brazo_L[i].length, tengo_length = False)

                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):    
                        Posicionar_Bones(Control_FK_Brazo_R[i], Base_Brazo_R[i].head, Base_Brazo_R[i].tail, Base_Brazo_R[i].roll,
                                     Base_Brazo_R[i].length, tengo_length = False)  

            #Control_IK_Brazo_L or Control_IK_Brazo_R
            Control_IK_Brazo_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                Encontral_Bones("Control_IK_Brazo_L", 3, Control_IK_Brazo_L)
            Control_IK_Brazo_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                Encontral_Bones("Control_IK_Brazo_R", 3, Control_IK_Brazo_R)    

            if Control_IK_Brazo_L or Control_IK_Brazo_R:
                for i in range(3):
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(Control_IK_Brazo_L[i], Base_Brazo_L[i].head, Base_Brazo_L[i].tail, Base_Brazo_L[i].roll,
                                     Base_Brazo_L[i].length, tengo_length = False)

                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(Control_IK_Brazo_R[i], Base_Brazo_R[i].head, Base_Brazo_R[i].tail, Base_Brazo_R[i].roll,
                                     Base_Brazo_R[i].length, tengo_length = False)  


            #SubControl_IK_Brazo_L or SubControl_IK_Brazo_R
            SubControl_IK_Brazo_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                Encontral_Bones("SubControl_IK_Brazo_L", 4, SubControl_IK_Brazo_L)
            SubControl_IK_Brazo_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                Encontral_Bones("SubControl_IK_Brazo_R", 4, SubControl_IK_Brazo_R)  

            if SubControl_IK_Brazo_L or SubControl_IK_Brazo_L:  

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                    for i in range(2):  

                        Posicionar_Bones(SubControl_IK_Brazo_L[i], Base_Brazo_L[0].head, Base_Brazo_L[2].head, Base_Brazo_L[0].roll,
                                         Base_Brazo_L[0].length / 2, tengo_length = True)   

                    if SubControl_IK_Brazo_L[2]:    

                        SubControl_IK_Brazo_L[2].head = Base_Brazo_L[1].head    

                        Pocion_Normal = Base_Brazo_L[0].z_axis.normalized()
                        Pocion_Normal_1 = Base_Brazo_L[1].z_axis.normalized()
                        Normales = (Pocion_Normal + Pocion_Normal_1) / 2
                        SubControl_IK_Brazo_L[2].tail = Base_Brazo_L[1].head + (Normales * -1)
                        SubControl_IK_Brazo_L[2].length = 2
                        new_head = (SubControl_IK_Brazo_L[2].head + SubControl_IK_Brazo_L[2].tail) / 2
                        SubControl_IK_Brazo_L[2].head = new_head    

                        SubControl_IK_Brazo_L[2].length = SubControl_IK_Brazo_L[0].length   

                    Posicionar_Bones(SubControl_IK_Brazo_L[3], Base_Brazo_L[2].head, Base_Brazo_L[2].tail, Base_Brazo_L[2].roll,
                                         Base_Brazo_L[2].length / 2, tengo_length = True)   

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                    for i in range(2):  

                        Posicionar_Bones(SubControl_IK_Brazo_R[i], Base_Brazo_R[0].head, Base_Brazo_R[2].tail, Base_Brazo_R[0].roll,
                                         Base_Brazo_R[0].length / 2, tengo_length = True)   

                    if SubControl_IK_Brazo_R[2]:    

                        SubControl_IK_Brazo_R[2].head = Base_Brazo_R[1].head    

                        Pocion_Normal = Base_Brazo_R[0].z_axis.normalized()
                        Pocion_Normal_1 = Base_Brazo_R[1].z_axis.normalized()
                        Normales = (Pocion_Normal + Pocion_Normal_1) / 2
                        SubControl_IK_Brazo_R[2].tail = Base_Brazo_R[1].head + (Normales * -1)
                        SubControl_IK_Brazo_R[2].length = 2
                        new_head = (SubControl_IK_Brazo_R[2].head + SubControl_IK_Brazo_R[2].tail) / 2
                        SubControl_IK_Brazo_R[2].head = new_head    

                        SubControl_IK_Brazo_R[2].length = SubControl_IK_Brazo_R[0].length   

                    Posicionar_Bones(SubControl_IK_Brazo_R[3], Base_Brazo_R[2].head, Base_Brazo_R[2].tail, Base_Brazo_R[2].roll,
                                         Base_Brazo_R[2].length / 2, tengo_length = True)   

            #SUbDef_Brazo_UP_L or SUbDef_Brazo_UP_R
            SUbDef_Brazo_UP_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                Encontral_Bones("SUbDef_Brazo_UP_L", 4, SUbDef_Brazo_UP_L)    
            SUbDef_Brazo_UP_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                Encontral_Bones("SUbDef_Brazo_UP_R", 4, SUbDef_Brazo_UP_R)      

            if SUbDef_Brazo_UP_L or SUbDef_Brazo_UP_R:  

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                    Posicionar_Bones(SUbDef_Brazo_UP_L[0], Base_Brazo_L[0].head, Base_Brazo_L[0].tail, Base_Brazo_L[0].roll,
                                 Base_Brazo_L[0].length / 8, tengo_length = True)
                    Posicionar_Bones(SUbDef_Brazo_UP_L[1], (Base_Brazo_L[0].head + Base_Brazo_L[0].tail) / 2, 
                                    Base_Brazo_L[0].tail, Base_Brazo_L[0].roll,
                                    Base_Brazo_L[0].length / 8, tengo_length = True)

                    for i in range(2):
                        pocioner_Bones_tail(SUbDef_Brazo_UP_L[i+2], Base_Brazo_L[0].head, Base_Brazo_L[0].tail, 
                                            Base_Brazo_L[0].roll, Base_Brazo_L[0].length / 8, tengo_length = True)

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                    Posicionar_Bones(SUbDef_Brazo_UP_R[0], Base_Brazo_R[0].head, Base_Brazo_R[0].tail, Base_Brazo_R[0].roll,
                                 Base_Brazo_R[0].length / 8, tengo_length = True)
                    Posicionar_Bones(SUbDef_Brazo_UP_R[1], (Base_Brazo_R[0].head + Base_Brazo_R[0].tail) / 2, 
                                    Base_Brazo_R[0].tail, Base_Brazo_R[0].roll,
                                    Base_Brazo_R[0].length / 8, tengo_length = True)

                    for i in range(2):
                        pocioner_Bones_tail(SUbDef_Brazo_UP_R[i+2], Base_Brazo_R[0].head, Base_Brazo_R[0].tail, 
                                            Base_Brazo_R[0].roll, Base_Brazo_R[0].length / 8, tengo_length = True)

            #SUbDef_Brazo_DOWN_L or SUbDef_Brazo_DOWN_R
            SUbDef_Brazo_DOWN_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                Encontral_Bones("SUbDef_Brazo_DOWN_L", 4, SUbDef_Brazo_DOWN_L)    
            SUbDef_Brazo_DOWN_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                Encontral_Bones("SUbDef_Brazo_DOWN_R", 4, SUbDef_Brazo_DOWN_R)  

            if SUbDef_Brazo_DOWN_L or SUbDef_Brazo_DOWN_R:  

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                    Posicionar_Bones(SUbDef_Brazo_DOWN_L[0], Base_Brazo_L[1].head, Base_Brazo_L[1].tail, Base_Brazo_L[1].roll,
                                 Base_Brazo_L[1].length / 8, tengo_length = True)
                    Posicionar_Bones(SUbDef_Brazo_DOWN_L[1], (Base_Brazo_L[1].head + Base_Brazo_L[1].tail) / 2, 
                                    Base_Brazo_L[1].tail, Base_Brazo_L[1].roll,
                                    Base_Brazo_L[1].length / 8, tengo_length = True)    

                    for i in range(2):
                        pocioner_Bones_tail(SUbDef_Brazo_DOWN_L[i+2], Base_Brazo_L[1].head, Base_Brazo_L[1].tail, 
                                            Base_Brazo_L[1].roll, Base_Brazo_L[1].length / 8, tengo_length = True)

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                    Posicionar_Bones(SUbDef_Brazo_DOWN_R[0], Base_Brazo_R[1].head, Base_Brazo_R[1].tail, Base_Brazo_R[1].roll,
                                 Base_Brazo_R[1].length / 8, tengo_length = True)
                    Posicionar_Bones(SUbDef_Brazo_DOWN_R[1], (Base_Brazo_R[1].head + Base_Brazo_R[1].tail) / 2, 
                                    Base_Brazo_R[1].tail, Base_Brazo_R[1].roll,
                                    Base_Brazo_R[1].length / 8, tengo_length = True)    

                    for i in range(2):
                        pocioner_Bones_tail(SUbDef_Brazo_DOWN_R[i+2], Base_Brazo_R[1].head, Base_Brazo_R[1].tail, 
                                            Base_Brazo_R[1].roll, Base_Brazo_R[1].length / 8, tengo_length = True)  

            #SUbDef_Mano_L or SUbDef_Mano_R
            SUbDef_Mano_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                Encontral_Bones("SUbDef_Mano_L", 2, SUbDef_Mano_L)    
            SUbDef_Mano_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                Encontral_Bones("SUbDef_Mano_R", 2, SUbDef_Mano_R)      

            if  SUbDef_Mano_L or SUbDef_Mano_R:
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                    Posicionar_Bones(SUbDef_Mano_L[0], Base_Brazo_L[2].head, Base_Brazo_L[2].tail, Base_Brazo_L[2].roll,
                                 Base_Brazo_L[2].length / 4, tengo_length = True)   

                    pocioner_Bones_tail(SUbDef_Mano_L[1], Base_Brazo_L[2].head, Base_Brazo_L[2].tail, 
                                            Base_Brazo_L[2].roll, Base_Brazo_L[2].length / 4, tengo_length = True)
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                    Posicionar_Bones(SUbDef_Mano_R[0], Base_Brazo_R[2].head, Base_Brazo_R[2].tail, Base_Brazo_R[2].roll,
                                 Base_Brazo_R[2].length / 4, tengo_length = True)

                    pocioner_Bones_tail(SUbDef_Mano_R[1], Base_Brazo_R[2].head, Base_Brazo_R[2].tail, 
                                            Base_Brazo_R[2].roll, Base_Brazo_R[2].length / 4, tengo_length = True)  


        #DEDOS_BASE     
        Base_Purgar_L = []
        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_L.{i+1:03}") for i in range(3)):
            Encontral_Bones("Base_Purgar_L", 3, Base_Purgar_L)
        Base_Purgar_R = []
        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_R.{i+1:03}") for i in range(3)):
            Encontral_Bones("Base_Purgar_R", 3, Base_Purgar_R)  

        if Base_Purgar_L or Base_Purgar_R:  

            #Def_Purgar_L or Def_Purgar_R
            Def_Purgar_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_L.{i+1:03}") for i in range(3)):
                Encontral_Bones("Def_Purgar_L", 3, Def_Purgar_L)
            Def_Purgar_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_R.{i+1:03}") for i in range(3)):
                Encontral_Bones("Def_Purgar_R", 3, Def_Purgar_R)    

            if Def_Purgar_L or Def_Purgar_R:
                for i in range(3):
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_L.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(Def_Purgar_L[i], Base_Purgar_L[i].head, Base_Purgar_L[i].tail, 
                                         Base_Purgar_L[i].roll, Base_Purgar_L[i].length, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_R.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(Def_Purgar_R[i], Base_Purgar_R[i].head, Base_Purgar_R[i].tail, 
                                         Base_Purgar_R[i].roll, Base_Purgar_R[i].length, tengo_length = True)   

            #FK_Purgar_L or FK_Purgar_R       
            FK_Purgar_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_L.{i+1:03}") for i in range(3)):
                Encontral_Bones("FK_Purgar_L", 3, FK_Purgar_L)
            FK_Purgar_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_R.{i+1:03}") for i in range(3)):
                Encontral_Bones("FK_Purgar_R", 3, FK_Purgar_R)  

            if FK_Purgar_L or FK_Purgar_R:
                for i in range(3):
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_L.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(FK_Purgar_L[i], Base_Purgar_L[i].head, Base_Purgar_L[i].tail, 
                                         Base_Purgar_L[i].roll, Base_Purgar_L[i].length, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_R.{i+1:03}") for i in range(3)):   
                        Posicionar_Bones(FK_Purgar_R[i], Base_Purgar_R[i].head, Base_Purgar_R[i].tail, 
                                         Base_Purgar_R[i].roll, Base_Purgar_R[i].length, tengo_length = True)   

            #SudDef_Purgar_L or SudDef_Purgar_R
            SudDef_Purgar_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_L.{i+1:03}") for i in range(3)):
                Encontral_Bones("SudDef_Purgar_L", 3, SudDef_Purgar_L)
            SudDef_Purgar_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_R.{i+1:03}") for i in range(3)):
                Encontral_Bones("SudDef_Purgar_R", 3, SudDef_Purgar_R)  

            if SudDef_Purgar_L or SudDef_Purgar_R:  

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_L.{i+1:03}") for i in range(3)):
                    for i in range(2):
                        Posicionar_Bones(SudDef_Purgar_L[i], Base_Purgar_L[i+1].head, Base_Purgar_L[i+1].tail, 
                                             Base_Purgar_L[i+1].roll, Base_Purgar_L[i+1].length / 4, tengo_length = True)   

                    pocioner_Bones_tail(SudDef_Purgar_L[2], Base_Purgar_L[2].head, Base_Purgar_L[2].tail, 
                                        Base_Purgar_L[2].roll, Base_Purgar_L[2].length / 4, tengo_length = True)
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_R.{i+1:03}") for i in range(3)):  
                    for i in range(2):
                        Posicionar_Bones(SudDef_Purgar_R[i], Base_Purgar_R[i+1].head, Base_Purgar_R[i+1].tail, 
                                             Base_Purgar_R[i+1].roll, Base_Purgar_R[i+1].length / 4, tengo_length = True)   

                    pocioner_Bones_tail(SudDef_Purgar_R[2], Base_Purgar_R[2].head, Base_Purgar_R[2].tail, 
                                        Base_Purgar_R[2].roll, Base_Purgar_R[2].length / 4, tengo_length = True)

            #SubFK_Purgar_L or SubFK_Purgar_R
            SubFK_Purgar_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_L.{i+1:03}") for i in range(3)):
                Encontral_Bones("SubFK_Purgar_L", 2, SubFK_Purgar_L)
            SubFK_Purgar_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_R.{i+1:03}") for i in range(3)):
                Encontral_Bones("SubFK_Purgar_R", 2, SubFK_Purgar_R)    

            if SubFK_Purgar_L or SubFK_Purgar_R:    

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_L.{i+1:03}") for i in range(3)):
                    Posicionar_Bones(SubFK_Purgar_L[0], Base_Purgar_L[1].head, Base_Purgar_L[1].tail, 
                                    Base_Purgar_L[1].roll, Base_Purgar_L[1].length / 2, tengo_length = True)
                    Posicionar_Bones(SubFK_Purgar_L[1], Base_Purgar_L[1].head, Base_Purgar_L[1].tail, 
                                    Base_Purgar_L[1].roll, (Base_Purgar_L[1].length + Base_Purgar_L[2].length), tengo_length = True)

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_R.{i+1:03}") for i in range(3)):  
                    Posicionar_Bones(SubFK_Purgar_R[0], Base_Purgar_R[1].head, Base_Purgar_R[1].tail, 
                                    Base_Purgar_R[1].roll, Base_Purgar_R[1].length / 2, tengo_length = True)
                    Posicionar_Bones(SubFK_Purgar_R[1], Base_Purgar_R[1].head, Base_Purgar_R[1].tail, 
                                    Base_Purgar_R[1].roll, (Base_Purgar_R[1].length + Base_Purgar_R[2].length), tengo_length = True)    

        Base_Indice_L = []
        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_L.{i+1:03}") for i in range(4)):
            Encontral_Bones("Base_Indice_L", 4, Base_Indice_L)
        Base_Indice_R = []
        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_R.{i+1:03}") for i in range(4)):
            Encontral_Bones("Base_Indice_R", 4, Base_Indice_R)  

        if Base_Indice_L or Base_Indice_R:  

            #Def_Indice_L or Def_Indice_R
            Def_Indice_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("Def_Indice_L", 4, Def_Indice_L)
            Def_Indice_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("Def_Indice_R", 4, Def_Indice_R)    

            if Def_Indice_L or Def_Indice_R:
                for i in range(4):
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(Def_Indice_L[i], Base_Indice_L[i].head, Base_Indice_L[i].tail, 
                                         Base_Indice_L[i].roll, Base_Indice_L[i].length, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(Def_Indice_R[i], Base_Indice_R[i].head, Base_Indice_R[i].tail, 
                                         Base_Indice_R[i].roll, Base_Indice_R[i].length, tengo_length = True)   

            #FK_Indice_L or FK_Indice_R       
            FK_Indice_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("FK_Indice_L", 4, FK_Indice_L)
            FK_Indice_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("FK_Indice_R", 4, FK_Indice_R)  

            if FK_Indice_L or FK_Indice_R:
                for i in range(4):
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(FK_Indice_L[i], Base_Indice_L[i].head, Base_Indice_L[i].tail, 
                                         Base_Indice_L[i].roll, Base_Indice_L[i].length, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(FK_Indice_R[i], Base_Indice_R[i].head, Base_Indice_R[i].tail, 
                                         Base_Indice_R[i].roll, Base_Indice_R[i].length, tengo_length = True)   

            #SudDef_Indice_L or SudDef_Indice_R
            SudDef_Indice_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("SudDef_Indice_L", 4, SudDef_Indice_L)
            SudDef_Indice_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("SudDef_Indice_R", 4, SudDef_Indice_R)  

            if SudDef_Indice_L or SudDef_Indice_R:
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_L.{i+1:03}") for i in range(4)):
                    for i in range(3):
                        Posicionar_Bones(SudDef_Indice_L[i], Base_Indice_L[i+1].head, Base_Indice_L[i+1].tail, 
                                             Base_Indice_L[i+1].roll, Base_Indice_L[i+1].length / 4, tengo_length = True)
                    pocioner_Bones_tail(SudDef_Indice_L[3], Base_Indice_L[3].head, Base_Indice_L[3].tail, 
                                        Base_Indice_L[3].roll, Base_Indice_L[3].length / 4, tengo_length = True)
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_R.{i+1:03}") for i in range(4)):
                    for i in range(3):
                        Posicionar_Bones(SudDef_Indice_R[i], Base_Indice_R[i+1].head, Base_Indice_R[i+1].tail, 
                                             Base_Indice_R[i+1].roll, Base_Indice_R[i+1].length / 4, tengo_length = True) 
                    pocioner_Bones_tail(SudDef_Indice_R[3], Base_Indice_R[3].head, Base_Indice_R[3].tail, 
                                        Base_Indice_R[3].roll, Base_Indice_R[3].length / 4, tengo_length = True)    

            #SubFK_Indice_L or SubFK_Indice_R
            SubFK_Indice_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("SubFK_Indice_L", 2, SubFK_Indice_L)
            SubFK_Indice_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("SubFK_Indice_R", 2, SubFK_Indice_R)    

            if SubFK_Indice_L or SubFK_Indice_R:    

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_L.{i+1:03}") for i in range(4)):
                    Posicionar_Bones(SubFK_Indice_L[0], Base_Indice_L[1].head, Base_Indice_L[1].tail, 
                                    Base_Indice_L[1].roll, Base_Indice_L[1].length / 2, tengo_length = True)
                    Posicionar_Bones(SubFK_Indice_L[1], Base_Indice_L[1].head, Base_Indice_L[1].tail, 
                                    Base_Indice_L[1].roll, (Base_Indice_L[1].length + 
                                                            Base_Indice_L[2].length +
                                                            Base_Indice_L[3].length 
                                                            ), tengo_length = True)

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_R.{i+1:03}") for i in range(4)):
                    Posicionar_Bones(SubFK_Indice_R[0], Base_Indice_R[1].head, Base_Indice_R[1].tail, 
                                    Base_Indice_R[1].roll, Base_Indice_R[1].length / 2, tengo_length = True)
                    Posicionar_Bones(SubFK_Indice_R[1], Base_Indice_R[1].head, Base_Indice_R[1].tail, 
                                    Base_Indice_R[1].roll, (Base_Indice_R[1].length + 
                                                            Base_Indice_R[2].length +
                                                            Base_Indice_R[3].length 
                                                            ), tengo_length = True) 

        Base_Corazon_L = []
        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_L.{i+1:03}") for i in range(4)):
            Encontral_Bones("Base_Corazon_L", 4, Base_Corazon_L)
        Base_Corazon_R = []
        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_R.{i+1:03}") for i in range(4)):
            Encontral_Bones("Base_Corazon_R", 4, Base_Corazon_R)    

        if Base_Corazon_L or Base_Corazon_R:    

            #Def_Corazon_L or Def_Corazon_R
            Def_Corazon_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("Def_Corazon_L", 4, Def_Corazon_L)
            Def_Corazon_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("Def_Corazon_R", 4, Def_Corazon_R)
            if Def_Corazon_L or Def_Corazon_R:
                for i in range(4):
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(Def_Corazon_L[i], Base_Corazon_L[i].head, Base_Corazon_L[i].tail, 
                                         Base_Corazon_L[i].roll, Base_Corazon_L[i].length, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_R.{i+1:03}") for i in range(4)):   
                        Posicionar_Bones(Def_Corazon_R[i], Base_Corazon_R[i].head, Base_Corazon_R[i].tail, 
                                         Base_Corazon_R[i].roll, Base_Corazon_R[i].length, tengo_length = True)
            #FK_Corazon_L or FK_Corazon_R       
            FK_Corazon_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("FK_Corazon_L", 4, FK_Corazon_L)
            FK_Corazon_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("FK_Corazon_R", 4, FK_Corazon_R)
            if FK_Corazon_L or FK_Corazon_R:
                for i in range(4):
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(FK_Corazon_L[i], Base_Corazon_L[i].head, Base_Corazon_L[i].tail, 
                                         Base_Corazon_L[i].roll, Base_Corazon_L[i].length, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(FK_Corazon_R[i], Base_Corazon_R[i].head, Base_Corazon_R[i].tail, 
                                         Base_Corazon_R[i].roll, Base_Corazon_R[i].length, tengo_length = True)
            #SudDef_Corazon_L or SudDef_Corazon_R
            SudDef_Corazon_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("SudDef_Corazon_L", 4, SudDef_Corazon_L)
            SudDef_Corazon_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("SudDef_Corazon_R", 4, SudDef_Corazon_R)
            if SudDef_Corazon_L or SudDef_Corazon_R:
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_L.{i+1:03}") for i in range(4)):
                    for i in range(3):
                        Posicionar_Bones(SudDef_Corazon_L[i], Base_Corazon_L[i+1].head, Base_Corazon_L[i+1].tail, 
                                             Base_Corazon_L[i+1].roll, Base_Corazon_L[i+1].length / 4, tengo_length = True)
                    pocioner_Bones_tail(SudDef_Corazon_L[3], Base_Corazon_L[3].head, Base_Corazon_L[3].tail, 
                                        Base_Corazon_L[3].roll, Base_Corazon_L[3].length / 4, tengo_length = True)
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_R.{i+1:03}") for i in range(4)):    
                    for i in range(3):
                        Posicionar_Bones(SudDef_Corazon_R[i], Base_Corazon_R[i+1].head, Base_Corazon_R[i+1].tail, 
                                             Base_Corazon_R[i+1].roll, Base_Corazon_R[i+1].length / 4, tengo_length = True) 
                    pocioner_Bones_tail(SudDef_Corazon_R[3], Base_Corazon_R[3].head, Base_Corazon_R[3].tail, 
                                        Base_Corazon_R[3].roll, Base_Corazon_R[3].length / 4, tengo_length = True)
            #SubFK_Corazon_L or SubFK_Corazon_R
            SubFK_Corazon_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("SubFK_Corazon_L", 2, SubFK_Corazon_L)
            SubFK_Corazon_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("SubFK_Corazon_R", 2, SubFK_Corazon_R)
            if SubFK_Corazon_L or SubFK_Corazon_R:
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_L.{i+1:03}") for i in range(4)):
                    Posicionar_Bones(SubFK_Corazon_L[0], Base_Corazon_L[1].head, Base_Corazon_L[1].tail, 
                                    Base_Corazon_L[1].roll, Base_Corazon_L[1].length / 2, tengo_length = True)
                    Posicionar_Bones(SubFK_Corazon_L[1], Base_Corazon_L[1].head, Base_Corazon_L[1].tail, 
                                    Base_Corazon_L[1].roll, (Base_Corazon_L[1].length+
                                                             Base_Corazon_L[2].length+
                                                             Base_Corazon_L[3].length), tengo_length = True)

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_R.{i+1:03}") for i in range(4)):    
                    Posicionar_Bones(SubFK_Corazon_R[0], Base_Corazon_R[1].head, Base_Corazon_R[1].tail, 
                                    Base_Corazon_R[1].roll, Base_Corazon_R[1].length / 2, tengo_length = True)
                    Posicionar_Bones(SubFK_Corazon_R[1], Base_Corazon_R[1].head, Base_Corazon_R[1].tail, 
                                    Base_Corazon_R[1].roll, (Base_Corazon_R[1].length+
                                                             Base_Corazon_R[2].length+
                                                             Base_Corazon_R[3].length), tengo_length = True)    

        Base_Anular_L = []
        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_L.{i+1:03}") for i in range(4)):
            Encontral_Bones("Base_Anular_L", 4, Base_Anular_L)
        Base_Anular_R = []
        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_R.{i+1:03}") for i in range(4)):
            Encontral_Bones("Base_Anular_R", 4, Base_Anular_R)
    

        if Base_Anular_L or Base_Anular_R:  

            #Def_Anular_L or Def_Anular_R
            Def_Anular_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("Def_Anular_L", 4, Def_Anular_L)
            Def_Anular_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("Def_Anular_R", 4, Def_Anular_R)    

            if Def_Anular_L or Def_Anular_R:
                for i in range(4):
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(Def_Anular_L[i], Base_Anular_L[i].head, Base_Anular_L[i].tail, 
                                         Base_Anular_L[i].roll, Base_Anular_L[i].length, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_R.{i+1:03}") for i in range(4)): 
                        Posicionar_Bones(Def_Anular_R[i], Base_Anular_R[i].head, Base_Anular_R[i].tail, 
                                         Base_Anular_R[i].roll, Base_Anular_R[i].length, tengo_length = True)   

            #FK_Anular_L or FK_Anular_R       
            FK_Anular_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("FK_Anular_L", 4, FK_Anular_L)
            FK_Anular_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("FK_Anular_R", 4, FK_Anular_R)  

            if FK_Anular_L or FK_Anular_R:
                for i in range(4):
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(FK_Anular_L[i], Base_Anular_L[i].head, Base_Anular_L[i].tail, 
                                         Base_Anular_L[i].roll, Base_Anular_L[i].length, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(FK_Anular_R[i], Base_Anular_R[i].head, Base_Anular_R[i].tail, 
                                         Base_Anular_R[i].roll, Base_Anular_R[i].length, tengo_length = True)   

            #SudDef_Anular_L or SudDef_Anular_R
            SudDef_Anular_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("SudDef_Anular_L", 4, SudDef_Anular_L)
            SudDef_Anular_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("SudDef_Anular_R", 4, SudDef_Anular_R)  

            if SudDef_Anular_L or SudDef_Anular_R:
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_L.{i+1:03}") for i in range(4)):
                    for i in range(3):
                        Posicionar_Bones(SudDef_Anular_L[i], Base_Anular_L[i+1].head, Base_Anular_L[i+1].tail, 
                                             Base_Anular_L[i+1].roll, Base_Anular_L[i+1].length / 4, tengo_length = True)   

                    pocioner_Bones_tail(SudDef_Anular_L[3], Base_Anular_L[3].head, Base_Anular_L[3].tail, 
                                        Base_Anular_L[3].roll, Base_Anular_L[3].length / 4, tengo_length = True)
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_R.{i+1:03}") for i in range(4)):   
                    for i in range(3):
                        Posicionar_Bones(SudDef_Anular_R[i], Base_Anular_R[i+1].head, Base_Anular_R[i+1].tail, 
                                             Base_Anular_R[i+1].roll, Base_Anular_R[i+1].length / 4, tengo_length = True)   

                    pocioner_Bones_tail(SudDef_Anular_R[3], Base_Anular_R[3].head, Base_Anular_R[3].tail, 
                                        Base_Anular_R[3].roll, Base_Anular_R[3].length / 4, tengo_length = True)

            #SubFK_Anular_L or SubFK_Anular_R
            SubFK_Anular_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("SubFK_Anular_L", 2, SubFK_Anular_L)
            SubFK_Anular_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("SubFK_Anular_R", 2, SubFK_Anular_R)    

            if SubFK_Anular_L or SubFK_Anular_R:
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_L.{i+1:03}") for i in range(4)):
                    Posicionar_Bones(SubFK_Anular_L[0], Base_Anular_L[1].head, Base_Anular_L[1].tail, 
                                    Base_Anular_L[1].roll, Base_Anular_L[1].length / 2, tengo_length = True)
                    Posicionar_Bones(SubFK_Anular_L[1], Base_Anular_L[1].head, Base_Anular_L[1].tail, 
                                    Base_Anular_L[1].roll, (Base_Anular_L[1].length+
                                                            Base_Anular_L[2].length+
                                                            Base_Anular_L[3].length), tengo_length = True)

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_R.{i+1:03}") for i in range(4)):
                    Posicionar_Bones(SubFK_Anular_R[0], Base_Anular_R[1].head, Base_Anular_R[1].tail, 
                                    Base_Anular_R[1].roll, Base_Anular_R[1].length / 2, tengo_length = True)
                    Posicionar_Bones(SubFK_Anular_R[1], Base_Anular_R[1].head, Base_Anular_R[1].tail, 
                                    Base_Anular_R[1].roll, (Base_Anular_R[1].length+
                                                            Base_Anular_R[2].length+
                                                            Base_Anular_R[3].length), tengo_length = True)  

        Base_Miñique_L = []
        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
            Encontral_Bones("Base_Miñique_L", 4, Base_Miñique_L)
        Base_Miñique_R = []
        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
            Encontral_Bones("Base_Miñique_R", 4, Base_Miñique_R)    

        if Base_Miñique_L or Base_Miñique_R:    

            #Def_Miñique_L or Def_Miñique_R
            Def_Miñique_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("Def_Miñique_L", 4, Def_Miñique_L)
            Def_Miñique_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("Def_Miñique_R", 4, Def_Miñique_R)  

            if Def_Miñique_L or Def_Miñique_R:
                for i in range(4):
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(Def_Miñique_L[i], Base_Miñique_L[i].head, Base_Miñique_L[i].tail, 
                                         Base_Miñique_L[i].roll, Base_Miñique_L[i].length, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_R.{i+1:03}") for i in range(4)):    
                        Posicionar_Bones(Def_Miñique_R[i], Base_Miñique_R[i].head, Base_Miñique_R[i].tail, 
                                         Base_Miñique_R[i].roll, Base_Miñique_R[i].length, tengo_length = True) 

            #FK_Miñique_L or FK_Miñique_R       
            FK_Miñique_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("FK_Miñique_L", 4, FK_Miñique_L)    

            FK_Miñique_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("FK_Miñique_R", 4, FK_Miñique_R)    

            if FK_Miñique_L or FK_Miñique_R:
                for i in range(4):
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(FK_Miñique_L[i], Base_Miñique_L[i].head, Base_Miñique_L[i].tail, 
                                         Base_Miñique_L[i].roll, Base_Miñique_L[i].length, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(FK_Miñique_R[i], Base_Miñique_R[i].head, Base_Miñique_R[i].tail, 
                                         Base_Miñique_R[i].roll, Base_Miñique_R[i].length, tengo_length = True) 

            #SudDef_Miñique_L or SudDef_Miñique_R
            SudDef_Miñique_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("SudDef_Miñique_L", 4, SudDef_Miñique_L)
            SudDef_Miñique_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("SudDef_Miñique_R", 4, SudDef_Miñique_R)    

            if SudDef_Miñique_L or SudDef_Miñique_R:
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
                    for i in range(3):
                        Posicionar_Bones(SudDef_Miñique_L[i], Base_Miñique_L[i+1].head, Base_Miñique_L[i+1].tail, 
                                             Base_Miñique_L[i+1].roll, Base_Miñique_L[i+1].length / 4, tengo_length = True) 

                    pocioner_Bones_tail(SudDef_Miñique_L[3], Base_Miñique_L[3].head, Base_Miñique_L[3].tail, 
                                        Base_Miñique_L[3].roll, Base_Miñique_L[3].length / 4, tengo_length = True)
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_R.{i+1:03}") for i in range(4)):
                    for i in range(3):
                        Posicionar_Bones(SudDef_Miñique_R[i], Base_Miñique_R[i+1].head, Base_Miñique_R[i+1].tail, 
                                             Base_Miñique_R[i+1].roll, Base_Miñique_R[i+1].length / 4, tengo_length = True)     

                    pocioner_Bones_tail(SudDef_Miñique_R[3], Base_Miñique_R[3].head, Base_Miñique_R[3].tail, 
                                        Base_Miñique_R[3].roll, Base_Miñique_R[3].length / 4, tengo_length = True)

            #SubFK_Miñique_L or SubFK_Miñique_R
            SubFK_Miñique_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("SubFK_Miñique_L", 2, SubFK_Miñique_L)
            SubFK_Miñique_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("SubFK_Miñique_R", 2, SubFK_Miñique_R)  

            if SubFK_Miñique_L or SubFK_Miñique_R:
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
                    Posicionar_Bones(SubFK_Miñique_L[0], Base_Miñique_L[1].head, Base_Miñique_L[1].tail, 
                                    Base_Miñique_L[1].roll, Base_Miñique_L[1].length / 2, tengo_length = True)
                    Posicionar_Bones(SubFK_Miñique_L[1], Base_Miñique_L[1].head, Base_Miñique_L[1].tail, 
                                    Base_Miñique_L[1].roll, (Base_Miñique_L[1].length+
                                                             Base_Miñique_L[2].length+
                                                             Base_Miñique_L[3].length), tengo_length = True)

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_R.{i+1:03}") for i in range(4)):  
                    Posicionar_Bones(SubFK_Miñique_R[0], Base_Miñique_R[1].head, Base_Miñique_R[1].tail, 
                                    Base_Miñique_R[1].roll, Base_Miñique_R[1].length / 2, tengo_length = True)
                    Posicionar_Bones(SubFK_Miñique_R[1], Base_Miñique_R[1].head, Base_Miñique_R[1].tail, 
                                    Base_Miñique_R[1].roll, (Base_Miñique_R[1].length+
                                                             Base_Miñique_R[2].length+
                                                             Base_Miñique_R[3].length), tengo_length = True)    

        #Base_Pierna_L or Base_Pierna_R
        Base_Pierna_L = []
        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
            Encontral_Bones("Base_Pierna_L", 4, Base_Pierna_L)
        Base_Pierna_R = []
        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
            Encontral_Bones("Base_Pierna_R", 4, Base_Pierna_R)  

        if Base_Pierna_L or Base_Pierna_R:  

            #Root_Pierna_L or Root_Pierna_R
            Root_Pierna_L = Bones_get.get("Root_Pierna_L")
            Root_Pierna_R = Bones_get.get("Root_Pierna_R")  

            if Root_Pierna_L or Root_Pierna_R:
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):    
                    Posicionar_Bones(
                        Root_Pierna_L, 
                        Base_Pierna_L[0].head, 
                        Base_Pierna_L[0].tail, 
                        Base_Pierna_L[0].roll, 
                        Base_Pierna_L[0].length / 2, 
                        tengo_length = True
                        )
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    Posicionar_Bones(
                        Root_Pierna_R, 
                        Base_Pierna_R[0].head, 
                        Base_Pierna_R[0].tail, 
                        Base_Pierna_R[0].roll, 
                        Base_Pierna_R[0].length / 2, 
                        tengo_length = True
                        )   

            #SUbDef_Pierna_UP_L or SUbDef_Pierna_UP_R
            SUbDef_Pierna_UP_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("SUbDef_Pierna_UP_L", 4, SUbDef_Pierna_UP_L)
            SUbDef_Pierna_UP_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("SUbDef_Pierna_UP_R", 4, SUbDef_Pierna_UP_R)    

            if SUbDef_Pierna_UP_L or SUbDef_Pierna_UP_R:
                #L
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    Posicionar_Bones(
                        SUbDef_Pierna_UP_L[0], 
                        Base_Pierna_L[0].head, 
                        ((Base_Pierna_L[0].tail + Base_Pierna_L[0].head) / 2), 
                        Base_Pierna_L[0].roll, 
                        Base_Pierna_L[0].length / 8, 
                        tengo_length = True
                        )   

                    Posicionar_Bones(
                        SUbDef_Pierna_UP_L[1], 
                        ((Base_Pierna_L[0].tail + Base_Pierna_L[0].head) / 2), 
                        Base_Pierna_L[0].tail, 
                        Base_Pierna_L[0].roll, 
                        Base_Pierna_L[0].length / 8, 
                        tengo_length = True
                        )   


                    for i in range(2):  
                        pocioner_Bones_tail(
                            SUbDef_Pierna_UP_L[i + 2], 
                            Base_Pierna_L[0].head, 
                            Base_Pierna_L[0].tail, 
                            Base_Pierna_L[0].roll, 
                            Base_Pierna_L[0].length / 8, 
                            tengo_length = True
                            )
                    #R 
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):  
                    Posicionar_Bones(
                        SUbDef_Pierna_UP_R[0], 
                        Base_Pierna_R[0].head, 
                        ((Base_Pierna_R[0].tail + Base_Pierna_R[0].head) / 2), 
                        Base_Pierna_R[0].roll, 
                        Base_Pierna_R[0].length / 8, 
                        tengo_length = True
                        )   

                    Posicionar_Bones(
                        SUbDef_Pierna_UP_R[1], 
                        ((Base_Pierna_R[0].tail + Base_Pierna_R[0].head) / 2), 
                        Base_Pierna_R[0].tail, 
                        Base_Pierna_R[0].roll, 
                        Base_Pierna_R[0].length / 8, 
                        tengo_length = True
                        )   


                    for i in range(2):  
                        pocioner_Bones_tail(
                            SUbDef_Pierna_UP_R[i + 2], 
                            Base_Pierna_R[0].head, 
                            Base_Pierna_R[0].tail, 
                            Base_Pierna_R[0].roll, 
                            Base_Pierna_R[0].length / 8, 
                            tengo_length = True
                            )   


            #SUbDef_Pierna_DOWN_L or SUbDef_Pierna_DOWN_R
            SUbDef_Pierna_DOWN_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("SUbDef_Pierna_DOWN_L", 4, SUbDef_Pierna_DOWN_L)
            SUbDef_Pierna_DOWN_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("SUbDef_Pierna_DOWN_R", 4, SUbDef_Pierna_DOWN_R)    

            if SUbDef_Pierna_DOWN_L or SUbDef_Pierna_DOWN_R:
                #L
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    Posicionar_Bones(
                        SUbDef_Pierna_DOWN_L[0], 
                        Base_Pierna_L[1].head, 
                        ((Base_Pierna_L[1].tail + Base_Pierna_L[1].head) / 2), 
                        Base_Pierna_L[1].roll, 
                        Base_Pierna_L[1].length / 8, 
                        tengo_length = True
                        )   

                    Posicionar_Bones(
                        SUbDef_Pierna_DOWN_L[1], 
                        ((Base_Pierna_L[1].tail + Base_Pierna_L[1].head) / 2), 
                        Base_Pierna_L[1].tail, 
                        Base_Pierna_L[1].roll, 
                        Base_Pierna_L[1].length / 8, 
                        tengo_length = True
                        )   


                    for i in range(2):  
                        pocioner_Bones_tail(
                            SUbDef_Pierna_DOWN_L[i + 2], 
                            Base_Pierna_L[1].head, 
                            Base_Pierna_L[1].tail, 
                            Base_Pierna_L[1].roll, 
                            Base_Pierna_L[1].length / 8, 
                            tengo_length = True
                            )
                #R 
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):        
                    Posicionar_Bones(
                        SUbDef_Pierna_DOWN_R[0], 
                        Base_Pierna_R[1].head, 
                        ((Base_Pierna_R[1].tail + Base_Pierna_R[1].head) / 2), 
                        Base_Pierna_R[1].roll, 
                        Base_Pierna_R[1].length / 8, 
                        tengo_length = True
                        )   

                    Posicionar_Bones(
                        SUbDef_Pierna_DOWN_R[1], 
                        ((Base_Pierna_R[1].tail + Base_Pierna_R[1].head) / 2), 
                        Base_Pierna_R[1].tail, 
                        Base_Pierna_R[1].roll, 
                        Base_Pierna_R[1].length / 8, 
                        tengo_length = True
                        )   


                    for i in range(2):  
                        pocioner_Bones_tail(
                            SUbDef_Pierna_DOWN_R[i + 2], 
                            Base_Pierna_R[1].head, 
                            Base_Pierna_R[1].tail, 
                            Base_Pierna_R[1].roll, 
                            Base_Pierna_R[1].length / 8, 
                            tengo_length = True
                            )   

            #SUbDef_Pie_L or SUbDef_Pie_R
            SUbDef_Pie_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("SUbDef_Pie_L", 3, SUbDef_Pie_L)
            SUbDef_Pie_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("SUbDef_Pie_R", 3, SUbDef_Pie_R)    

            if SUbDef_Pie_L or SUbDef_Pie_R:    

                #L
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    for i in range(2):  

                        Posicionar_Bones(
                            SUbDef_Pie_L[i], 
                            Base_Pierna_L[i+2].head, 
                            Base_Pierna_L[i+2].tail, 
                            Base_Pierna_L[i+2].roll, 
                            Base_Pierna_L[i+2].length / 4, 
                            tengo_length = True
                            )   

                    pocioner_Bones_tail(
                        SUbDef_Pie_L[2], 
                        Base_Pierna_L[3].head, 
                        Base_Pierna_L[3].tail, 
                        Base_Pierna_L[3].roll, 
                        Base_Pierna_L[3].length / 4, 
                        tengo_length = True
                        )
                #R
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    for i in range(2):  

                        Posicionar_Bones(
                            SUbDef_Pie_R[i], 
                            Base_Pierna_R[i+2].head, 
                            Base_Pierna_R[i+2].tail, 
                            Base_Pierna_R[i+2].roll, 
                            Base_Pierna_R[i+2].length / 4, 
                            tengo_length = True
                            )   

                    pocioner_Bones_tail(
                        SUbDef_Pie_R[2], 
                        Base_Pierna_R[3].head, 
                        Base_Pierna_R[3].tail, 
                        Base_Pierna_R[3].roll, 
                        Base_Pierna_R[3].length / 4, 
                        tengo_length = True
                        )   

            #Def_Pierna_UP_L or Def_Pierna_UP_L
            Def_Pierna_UP_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("Def_Pierna_UP_L", 2, Def_Pierna_UP_L)
            Def_Pierna_UP_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("Def_Pierna_UP_R", 2, Def_Pierna_UP_R)  

            if Def_Pierna_UP_L or Def_Pierna_UP_R:
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    Posicionar_Bones(Def_Pierna_UP_L[0], Base_Pierna_L[0].head, (Base_Pierna_L[0].head + Base_Pierna_L[0].tail) / 2, 
                                     Base_Pierna_L[0].roll, Base_Pierna_L[0].length, tengo_length = False)
                    Posicionar_Bones(Def_Pierna_UP_L[1], (Base_Pierna_L[0].head + Base_Pierna_L[0].tail) / 2, Base_Pierna_L[0].tail , 
                                     Base_Pierna_L[0].roll, Base_Pierna_L[0].length, tengo_length = False)
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    Posicionar_Bones(Def_Pierna_UP_R[0], Base_Pierna_R[0].head, (Base_Pierna_R[0].head + Base_Pierna_R[0].tail) / 2, 
                                     Base_Pierna_R[0].roll, Base_Pierna_R[0].length, tengo_length = False)
                    Posicionar_Bones(Def_Pierna_UP_R[1], (Base_Pierna_R[0].head + Base_Pierna_R[0].tail) / 2, Base_Pierna_R[0].tail , 
                                     Base_Pierna_R[0].roll, Base_Pierna_R[0].length, tengo_length = False)

            #Def_Pierna_DOWN_L or Def_Pierna_DOWN_L
            Def_Pierna_DOWN_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("Def_Pierna_DOWN_L", 2, Def_Pierna_DOWN_L)
            Def_Pierna_DOWN_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("Def_Pierna_DOWN_R", 2, Def_Pierna_DOWN_R)  

            if Def_Pierna_DOWN_L or Def_Pierna_DOWN_R:  

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    Posicionar_Bones(Def_Pierna_DOWN_L[0], Base_Pierna_L[1].head, (Base_Pierna_L[1].head + Base_Pierna_L[1].tail) / 2, 
                                     Base_Pierna_L[1].roll, Base_Pierna_L[1].length, tengo_length = False)
                    Posicionar_Bones(Def_Pierna_DOWN_L[1], (Base_Pierna_L[1].head + Base_Pierna_L[1].tail) / 2, Base_Pierna_L[1].tail , 
                                     Base_Pierna_L[1].roll, Base_Pierna_L[1].length, tengo_length = False)
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    Posicionar_Bones(Def_Pierna_DOWN_R[0], Base_Pierna_R[1].head, (Base_Pierna_R[1].head + Base_Pierna_R[1].tail) / 2, 
                                     Base_Pierna_R[1].roll, Base_Pierna_R[1].length, tengo_length = False)
                    Posicionar_Bones(Def_Pierna_DOWN_R[1], (Base_Pierna_R[1].head + Base_Pierna_R[1].tail) / 2, Base_Pierna_R[1].tail , 
                                     Base_Pierna_R[1].roll, Base_Pierna_R[1].length, tengo_length = False)  

            #Def_Pie_L or Def_Pie_R
            Def_Pie_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("Def_Pie_L", 2, Def_Pie_L)
            Def_Pie_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("Def_Pie_R", 2, Def_Pie_R)  

            if Def_Pie_L or Def_Pie_R:  

                for i in range(2):
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(Def_Pie_L[i], Base_Pierna_L[i+2].head, Base_Pierna_L[i+2].tail, 
                                        Base_Pierna_L[i+2].roll, Base_Pierna_L[i+2].length, tengo_length = False)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(Def_Pie_R[i], Base_Pierna_R[i+2].head, Base_Pierna_R[i+2].tail, 
                                        Base_Pierna_R[i+2].roll, Base_Pierna_R[i+2].length, tengo_length = False)   

            #Base_Talon_L or Base_Talon_R
            Base_Talon_L = Bones_get.get("Base_Talon_L")
            Base_Talon_R = Bones_get.get("Base_Talon_R")
            DefBase_Talon_L = Bones_get.get("DefBase_Talon_L.001")
            DefBase_Talon_R = Bones_get.get("DefBase_Talon_R.001")  

            if  Base_Talon_L or Base_Talon_R:   

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    Posicionar_Bones(DefBase_Talon_L, Base_Talon_L.head, Base_Talon_L.tail, 
                                        Base_Talon_L.roll, Base_Talon_L.length, tengo_length = False)
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    Posicionar_Bones(DefBase_Talon_R, Base_Talon_R.head, Base_Talon_R.tail, 
                                        Base_Talon_R.roll, Base_Talon_R.length, tengo_length = False)   

            #Rot_Pierna_L or Rot_Pierna_R
            Rot_Pierna_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("Rot_Pierna_L", 4, Rot_Pierna_L)
            Rot_Pierna_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("Rot_Pierna_R", 4, Rot_Pierna_R)    

            if Rot_Pierna_L or Rot_Pierna_R:    

                for i in range(4):
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(Rot_Pierna_L[i], Base_Pierna_L[i].head, Base_Pierna_L[i].tail, 
                                        Base_Pierna_L[i].roll, Base_Pierna_L[i].length, tengo_length = False)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(Rot_Pierna_R[i], Base_Pierna_R[i].head, Base_Pierna_R[i].tail, 
                                        Base_Pierna_R[i].roll, Base_Pierna_R[i].length, tengo_length = False)   

            #Control_Def_Pierna_L or Control_Def_Pierna_R
            Control_Def_Pierna_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("Control_Def_Pierna_L", 2, Control_Def_Pierna_L)
            Control_Def_Pierna_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("Control_Def_Pierna_R", 2, Control_Def_Pierna_R)    

            if Control_Def_Pierna_L or Control_Def_Pierna_R:    

                for i in range(2):
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(Control_Def_Pierna_L[i], Base_Pierna_L[i].head, 
                                        Base_Pierna_L[i].tail, Base_Pierna_L[i].roll, Base_Pierna_L[i].length, tengo_length = False)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(Control_Def_Pierna_R[i], Base_Pierna_R[i].head, 
                                        Base_Pierna_R[i].tail, Base_Pierna_R[i].roll, Base_Pierna_R[i].length, tengo_length = False)

            #SubControl_Def_Pierna_L or SubControl_Def_Pierna_R
            SubControl_Def_Pierna_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("SubControl_Def_Pierna_L", 3, SubControl_Def_Pierna_L)
            SubControl_Def_Pierna_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("SubControl_Def_Pierna_R", 3, SubControl_Def_Pierna_R)  

            if SubControl_Def_Pierna_L or SubControl_Def_Pierna_R:  

                for i in range(2):
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):  
                        Posicionar_Bones(SubControl_Def_Pierna_L[i], Base_Pierna_L[i].head, 
                                        Base_Pierna_L[i].tail, Base_Pierna_L[i].roll, Base_Pierna_L[i].length / 4, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(SubControl_Def_Pierna_R[i], Base_Pierna_R[i].head, 
                                        Base_Pierna_R[i].tail, Base_Pierna_R[i].roll, Base_Pierna_R[i].length / 4, tengo_length = True)

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    pocioner_Bones_tail(SubControl_Def_Pierna_L[2], Base_Pierna_L[1].head, 
                                        Base_Pierna_L[1].tail, Base_Pierna_L[1].roll, Base_Pierna_L[1].length / 4, tengo_length = True)
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    pocioner_Bones_tail(SubControl_Def_Pierna_R[2], Base_Pierna_R[1].head, 
                                        Base_Pierna_R[1].tail, Base_Pierna_R[1].roll, Base_Pierna_R[1].length / 4, tengo_length = True) 

            #FK_Pierna_L or FK_Pierna_R
            FK_Pierna_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("FK_Pierna_L", 4, FK_Pierna_L)
            FK_Pierna_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("FK_Pierna_R", 4, FK_Pierna_R)  

            if FK_Pierna_L or FK_Pierna_R:  

                for i in range(4):
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(FK_Pierna_L[i], Base_Pierna_L[i].head, Base_Pierna_L[i].tail, 
                                        Base_Pierna_L[i].roll, Base_Pierna_L[i].length, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(FK_Pierna_R[i], Base_Pierna_R[i].head, Base_Pierna_R[i].tail, 
                                        Base_Pierna_R[i].roll, Base_Pierna_R[i].length, tengo_length = True)    

            #IK_Pierna_L or IK_Pierna_R

            IK_Pierna_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("IK_Pierna_L", 4, IK_Pierna_L)
            IK_Pierna_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("IK_Pierna_R", 4, IK_Pierna_R)  

            if IK_Pierna_L or IK_Pierna_R:
                for i in range(4):  

                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(IK_Pierna_L[i], Base_Pierna_L[i].head, Base_Pierna_L[i].tail, 
                                        Base_Pierna_L[i].roll, Base_Pierna_L[i].length, tengo_length = True)

                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(IK_Pierna_R[i], Base_Pierna_R[i].head, Base_Pierna_R[i].tail, 
                                        Base_Pierna_R[i].roll, Base_Pierna_R[i].length, tengo_length = True)    

            #SudIK_Pierna_L or SudIK_Pierna_R
            SudIK_Pierna_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("SudIK_Pierna_L", 5, SudIK_Pierna_L)
            SudIK_Pierna_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("SudIK_Pierna_R", 5, SudIK_Pierna_R)    

            if SudIK_Pierna_L or SudIK_Pierna_R:
                for i in range(2):
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(SudIK_Pierna_L[i], Base_Pierna_L[0].head, Base_Pierna_L[2].head, 
                                        Base_Pierna_L[0].roll, Base_Pierna_L[0].length / 2, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(SudIK_Pierna_R[i], Base_Pierna_R[0].head, Base_Pierna_R[2].head, 
                                        Base_Pierna_R[0].roll, Base_Pierna_R[0].length / 2, tengo_length = True)

                    if SudIK_Pierna_L[2] or SudIK_Pierna_R[2]:
                        #L
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                            SudIK_Pierna_L[2].head = Base_Pierna_L[1].head  

                            Pocion_Normal = Base_Pierna_L[0].z_axis.normalized()
                            Pocion_Normal_1 = Base_Pierna_L[1].z_axis.normalized()
                            Normales = (Pocion_Normal + Pocion_Normal_1) / 2
                            SudIK_Pierna_L[2].tail = Base_Pierna_L[1].head + (Normales * -1)
                            SudIK_Pierna_L[2].length = 2
                            new_head = (SudIK_Pierna_L[2].head + SudIK_Pierna_L[2].tail) / 2
                            SudIK_Pierna_L[2].head = new_head   

                            SudIK_Pierna_L[2].length = SudIK_Pierna_L[0].length
                        #R
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):   
                            SudIK_Pierna_R[2].head = Base_Pierna_R[1].head  

                            Pocion_Normal = Base_Pierna_R[0].z_axis.normalized()
                            Pocion_Normal_1 = Base_Pierna_R[1].z_axis.normalized()
                            Normales = (Pocion_Normal + Pocion_Normal_1) / 2
                            SudIK_Pierna_R[2].tail = Base_Pierna_R[1].head + (Normales * -1)
                            SudIK_Pierna_R[2].length = 2
                            new_head = (SudIK_Pierna_R[2].head + SudIK_Pierna_R[2].tail) / 2
                            SudIK_Pierna_R[2].head = new_head   

                            SudIK_Pierna_R[2].length = SudIK_Pierna_R[0].length 

                    if SudIK_Pierna_L[3] or SudIK_Pierna_R[3] or SudIK_Pierna_L[4] or SudIK_Pierna_L[4]:
                        #L
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                            SudIK_Pierna_L[3].head = Base_Pierna_L[2].head  

                            SudIK_Pierna_L[3].tail = [
                                (Base_Pierna_L[2].head.x + Base_Pierna_L[2].tail.x) / 2,
                                (Base_Pierna_L[2].head.y + Base_Pierna_L[2].tail.y) / 2,
                                Base_Pierna_L[2].head.z
                                ]   

                        #R
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):    
                            SudIK_Pierna_R[3].head = Base_Pierna_R[2].head  

                            SudIK_Pierna_R[3].tail = [
                                (Base_Pierna_R[2].head.x + Base_Pierna_R[2].tail.x) / 2,
                                (Base_Pierna_R[2].head.y + Base_Pierna_R[2].tail.y) / 2,
                                Base_Pierna_R[2].head.z
                                ]   

                        #L
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):    
                            SudIK_Pierna_L[4].head = Base_Pierna_L[2].head  

                            Pocion_Normal = Base_Pierna_L[2].z_axis.normalized()
                            SudIK_Pierna_L[4].tail = Base_Pierna_L[2].head + (Pocion_Normal)
                            SudIK_Pierna_L[4].tail.z = SudIK_Pierna_L[4].head.z
                            SudIK_Pierna_L[4].length = Base_Pierna_L[2].length / 2
                            SudIK_Pierna_L[4].roll = 0  

                        #R
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):  
                            SudIK_Pierna_R[4].head = Base_Pierna_R[2].head  

                            Pocion_Normal = Base_Pierna_R[2].z_axis.normalized()
                            SudIK_Pierna_R[4].tail = Base_Pierna_R[2].head + (Pocion_Normal)
                            SudIK_Pierna_R[4].tail.z = SudIK_Pierna_R[4].head.z
                            SudIK_Pierna_R[4].length = Base_Pierna_R[2].length / 2
                            SudIK_Pierna_R[4].roll = 0  


            #Rot_IK_Pierna_L or Rot_IK_Pierna_R
            Rot_IK_Pierna_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("Rot_IK_Pierna_L", 6, Rot_IK_Pierna_L)
            Rot_IK_Pierna_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("Rot_IK_Pierna_R", 6, Rot_IK_Pierna_R)  

            if Rot_IK_Pierna_L or Rot_IK_Pierna_R:  

                #ROt_Primeros
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)): 

                    Posicionar_Bones(Rot_IK_Pierna_L[0], Base_Pierna_L[3].head, Base_Pierna_L[3].tail, 
                                        Base_Pierna_L[3].roll, Base_Pierna_L[3].length / 2, tengo_length = True)
                    pocioner_Bones_tail(Rot_IK_Pierna_L[1], Base_Pierna_L[3].head,  Base_Pierna_L[3].tail, 
                                         Base_Pierna_L[3].roll,  Base_Pierna_L[3].length / 2, tengo_length = True)

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):

                    Posicionar_Bones(Rot_IK_Pierna_R[0], Base_Pierna_R[3].head, Base_Pierna_R[3].tail, 
                                        Base_Pierna_R[3].roll, Base_Pierna_R[3].length / 2, tengo_length = True)
                    pocioner_Bones_tail(Rot_IK_Pierna_R[1], Base_Pierna_R[3].head,  Base_Pierna_R[3].tail, 
                                         Base_Pierna_R[3].roll,  Base_Pierna_R[3].length / 2, tengo_length = True)

                for i in range(5):
                #ROt_Plantas
                    if Rot_IK_Pierna_L[2] or Rot_IK_Pierna_R[2]:    

                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                            Rot_IK_Pierna_L[2].head = (Base_Talon_L.head + Base_Talon_L.tail) / 2
                            Normal = Base_Talon_L.x_axis.normalized()
                            Rot_IK_Pierna_L[2].tail += (Normal *-1)
                            Rot_IK_Pierna_L[2].head = Base_Pierna_L[3].tail
                            Rot_IK_Pierna_L[2].length = Base_Pierna_L[2].length / 2 
                            Rot_IK_Pierna_L[2].roll = 0     

                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                            Rot_IK_Pierna_R[2].head = (Base_Talon_R.head + Base_Talon_R.tail) / 2
                            Normal = Base_Talon_R.x_axis.normalized()
                            Rot_IK_Pierna_R[2].tail += (Normal)
                            Rot_IK_Pierna_R[2].head = Base_Pierna_R[3].tail
                            Rot_IK_Pierna_R[2].length = Base_Pierna_R[2].length / 2 
                            Rot_IK_Pierna_R[2].roll = 0     



                    if Rot_IK_Pierna_L[3] or Rot_IK_Pierna_R[3] or Rot_IK_Pierna_L[4] or Rot_IK_Pierna_R[4]:
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                            Rot_IK_Pierna_L[3].head = Base_Talon_L.tail
                            Normal = Base_Talon_L.x_axis.normalized()
                            Rot_IK_Pierna_L[3].tail += Normal * -1
                            Rot_IK_Pierna_L[3].length =  Base_Pierna_L[2].length / 2    

                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                            Rot_IK_Pierna_R[3].head = Base_Talon_R.tail
                            Normal = Base_Talon_R.x_axis.normalized()
                            Rot_IK_Pierna_R[3].tail += Normal
                            Rot_IK_Pierna_R[3].length =  Base_Pierna_R[2].length / 2    

                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                            Rot_IK_Pierna_L[4].head = Base_Talon_L.head
                            Normal = Base_Talon_L.x_axis.normalized()
                            Rot_IK_Pierna_L[4].tail += Normal * -1
                            Rot_IK_Pierna_L[4].length =  Base_Pierna_L[2].length / 2    

                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                            Rot_IK_Pierna_R[4].head = Base_Talon_R.head
                            Normal = Base_Talon_R.x_axis.normalized()
                            Rot_IK_Pierna_R[4].tail += Normal
                            Rot_IK_Pierna_R[4].length =  Base_Pierna_R[2].length / 2 

                    if Rot_IK_Pierna_L[5] or Rot_IK_Pierna_R[5]:    

                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                            Rot_IK_Pierna_L[5].head = (Base_Talon_L.tail + Base_Talon_L.head) / 2
                            Normal = Base_Talon_L.x_axis.normalized()
                            Rot_IK_Pierna_L[5].tail += Normal *-1
                            Rot_IK_Pierna_L[5].length =  Base_Pierna_L[2].length / 2    

                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                            Rot_IK_Pierna_R[5].head = (Base_Talon_R.tail + Base_Talon_R.head) / 2
                            Normal = Base_Talon_R.x_axis.normalized()
                            Rot_IK_Pierna_R[5].tail += Normal
                            Rot_IK_Pierna_R[5].length =  Base_Pierna_R[2].length / 2    

            #Cont_Rot_IK_Pierna_L or Cont_Rot_IK_Pierna_R
            Cont_Rot_IK_Pierna_L = Bones_get.get("Cont_Rot_IK_Pierna_L")
            Cont_Rot_IK_Pierna_R = Bones_get.get("Cont_Rot_IK_Pierna_R")    

            if Cont_Rot_IK_Pierna_L or Cont_Rot_IK_Pierna_R:    

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):  
                    Posicionar_Bones(
                        Cont_Rot_IK_Pierna_L, Rot_IK_Pierna_L[5].head, 
                        Rot_IK_Pierna_L[5].tail, Rot_IK_Pierna_L[5].roll, 
                        Rot_IK_Pierna_L[5].length, tengo_length = True
                        )

                    Cont_Rot_IK_Pierna_L.head.z = (Base_Talon_L.head.z + Base_Pierna_L[2].head.z) / 2
                    Cont_Rot_IK_Pierna_L.tail.z = (Base_Talon_L.head.z + Base_Pierna_L[2].head.z) / 2   

                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    Posicionar_Bones(
                        Cont_Rot_IK_Pierna_R, Rot_IK_Pierna_R[5].head, 
                        Rot_IK_Pierna_R[5].tail, Rot_IK_Pierna_R[5].roll, 
                        Rot_IK_Pierna_R[5].length, tengo_length = True
                        )
                    Cont_Rot_IK_Pierna_R.head.z = (Base_Talon_R.head.z + Base_Pierna_R[2].head.z) / 2
                    Cont_Rot_IK_Pierna_R.tail.z = (Base_Talon_R.head.z + Base_Pierna_R[2].head.z) / 2

        
        #pole
        posicionar_pole_bones(Armature)



    #pose mode 

    bpy.ops.object.mode_set(mode='POSE')    

    pose_Bones_get = Armature.pose.bones    

    def pose_Encontral_Bones(Nombre_Bone_Base, repeticiones, append):   

        for i in range(repeticiones):
            Nombre_Bone = f"{Nombre_Bone_Base}.{(i+1):03}"
            hueso = pose_Bones_get.get(Nombre_Bone)
            append.append(hueso)            


    #Pose_View_Columna
    Pose_Control_Down_Columna = []
    if all(pose_Bones_get.get(f"Control_Down_Columna.{i+1:03}") for i in range(2)):
        pose_Encontral_Bones("Control_Down_Columna", 2, Pose_Control_Down_Columna)
    if Pose_Control_Down_Columna:
        for i in range(2):
            Pose_Control_Down_Columna[i].custom_shape_translation[1] = Pose_Control_Down_Columna[i].length / 2  

    #Control_UP_Columna
    Pose_Control_UP_Columna = []
    if all(pose_Bones_get.get(f"Control_UP_Columna.{i+1:03}") for i in range(2)):
        pose_Encontral_Bones("Control_UP_Columna", 2, Pose_Control_UP_Columna)
    if Pose_Control_UP_Columna:
        for i in range(2):
            Pose_Control_UP_Columna[i].custom_shape_translation[1] = Pose_Control_UP_Columna[i].length / 2  

    #Control_Cuello
    if pose_Bones_get.get("Control_Cuello.001"):
        pose_Bones_get.get("Control_Cuello.001").custom_shape_translation[1] = pose_Bones_get.get("Control_Cuello.001").length / 2
    #Control_Cabeza
    if pose_Bones_get.get("Control_Cabeza.001"):
        pose_Bones_get.get("Control_Cabeza.001").custom_shape_translation[1] = pose_Bones_get.get("Control_Cabeza.001").length
    #Hombros
    if pose_Bones_get.get("Hombros"):
        pose_Bones_get.get("Hombros").custom_shape_translation[1] = pose_Bones_get.get("Hombros").length / 2
    #Cadera
    if pose_Bones_get.get("Cadera"):
        pose_Bones_get.get("Cadera").custom_shape_translation[1] = pose_Bones_get.get("Cadera").length / 2  

    #SudIK_Pierna_L.004
    if pose_Bones_get.get("SudIK_Pierna_L.004"):
        pose_Bones_get.get("SudIK_Pierna_L.004").custom_shape_translation[2] = (
            (pose_Bones_get.get("Base_Pierna_L.003").length / 2) * -1
            )
        pose_Bones_get.get("SudIK_Pierna_L.004").custom_shape_translation[1] = (
            (pose_Bones_get.get("Base_Pierna_L.003").length / 2)
            )
    
    #SudIK_Pierna_R.004
    if pose_Bones_get.get("SudIK_Pierna_R.004"):
        pose_Bones_get.get("SudIK_Pierna_R.004").custom_shape_translation[2] = (
            (pose_Bones_get.get("Base_Pierna_R.003").length / 2) * -1
            )
        pose_Bones_get.get("SudIK_Pierna_R.004").custom_shape_translation[1] = (
            (pose_Bones_get.get("Base_Pierna_R.003").length / 2)
            )   

    #Control_FK_Brazo_L
    Pose_Control_FK_Brazo_L = []
    if all(pose_Bones_get.get(f"Control_FK_Brazo_L.{i+1:03}") for i in range(3)):
        pose_Encontral_Bones("Control_FK_Brazo_L", 3, Pose_Control_FK_Brazo_L)
    if Pose_Control_FK_Brazo_L:
        for i in range(len(Pose_Control_FK_Brazo_L)):
            Pose_Control_FK_Brazo_L[i].custom_shape_translation[1] = Pose_Control_FK_Brazo_L[i].length / 2  

    #Control_FK_Brazo_R
    Pose_Control_FK_Brazo_R = []
    if all(pose_Bones_get.get(f"Control_FK_Brazo_R.{i+1:03}") for i in range(3)):  
        pose_Encontral_Bones("Control_FK_Brazo_R", 3, Pose_Control_FK_Brazo_R)
    if Pose_Control_FK_Brazo_R:
        for i in range(len(Pose_Control_FK_Brazo_R)):
            Pose_Control_FK_Brazo_R[i].custom_shape_translation[1] = Pose_Control_FK_Brazo_R[i].length / 2  



    #FK_Pierna_L
    Pose_FK_Pierna_L = []
    if all(pose_Bones_get.get(f"FK_Pierna_L.{i+1:03}") for i in range(4)):
        pose_Encontral_Bones("FK_Pierna_L", 4, Pose_FK_Pierna_L)
    if Pose_FK_Pierna_L:
        for i in range(len(Pose_FK_Pierna_L)):
            Pose_FK_Pierna_L[i].custom_shape_translation[1] = Pose_FK_Pierna_L[i].length / 2
    #FK_Pierna_R
    Pose_FK_Pierna_R = []
    if all(pose_Bones_get.get(f"FK_Pierna_R.{i+1:03}") for i in range(4)):
        pose_Encontral_Bones("FK_Pierna_R", 4, Pose_FK_Pierna_R)
    if Pose_FK_Pierna_R:
        for i in range(len(Pose_FK_Pierna_L)):
            Pose_FK_Pierna_R[i].custom_shape_translation[1] = Pose_FK_Pierna_R[i].length / 2    



    #Control_IK_Brazo_L.003     
    Control_IK_Brazo_L_003 = pose_Bones_get.get("Control_IK_Brazo_L.003")
    if Control_IK_Brazo_L_003:
        Control_IK_Brazo_L_003.custom_shape_translation[1] = pose_Bones_get.get("Base_Brazo_L.003").length
    #Control_IK_Brazo_R.003
    Control_IK_Brazo_R_003 = pose_Bones_get.get("Control_IK_Brazo_R.003")
    if Control_IK_Brazo_R_003:
        Control_IK_Brazo_R_003.custom_shape_translation[1] = pose_Bones_get.get("Base_Brazo_R.003").length  

    #SubControl_IK_Brazo_L.001
    SubControl_IK_Brazo_L_001 = pose_Bones_get.get("SubControl_IK_Brazo_L.001")
    if SubControl_IK_Brazo_L_001 :
        SubControl_IK_Brazo_L_001.custom_shape_translation[1] = pose_Bones_get.get("Base_Brazo_L.001").length
    #SubControl_IK_Brazo_R.001
    SubControl_IK_Brazo_R_001 = pose_Bones_get.get("SubControl_IK_Brazo_R.001")
    if SubControl_IK_Brazo_R_001 :
        SubControl_IK_Brazo_R_001.custom_shape_translation[1] = pose_Bones_get.get("Base_Brazo_R.001").length   

    #SudIK_Pierna_L.002
    SudIK_Pierna_L_002 = pose_Bones_get.get("SudIK_Pierna_L.002")
    if SudIK_Pierna_L_002 :
        SudIK_Pierna_L_002.custom_shape_translation[1] = pose_Bones_get.get("Base_Pierna_L.001").length
    #SudIK_Pierna_R.002
    SudIK_Pierna_R_002 = pose_Bones_get.get("SudIK_Pierna_R.002")
    if SudIK_Pierna_R_002 :
        SudIK_Pierna_R_002.custom_shape_translation[1] = pose_Bones_get.get("Base_Pierna_R.001").length 




    #Control_Hombros_L.001
    Control_Hombros_L_001 = pose_Bones_get.get("Control_Hombros_L.001")
    if Control_Hombros_L_001:
        Control_Hombros_L_001.custom_shape_translation[1] = pose_Bones_get.get("Base_Hombro_L.002").length
    #Control_Hombros_R.001
    Control_Hombros_R_001 = pose_Bones_get.get("Control_Hombros_R.001")
    if Control_Hombros_R_001:
        Control_Hombros_R_001.custom_shape_translation[1] = pose_Bones_get.get("Base_Hombro_R.002").length  


    #FK_Purgar_L
    Pose_FK_Purgar_L = []
    if all(pose_Bones_get.get(f"FK_Purgar_L.{i+1:03}") for i in range(3)):
        pose_Encontral_Bones("FK_Purgar_L", 3, Pose_FK_Purgar_L)
    if Pose_FK_Purgar_L:
        for i in range(len(Pose_FK_Purgar_L)):
            Pose_FK_Purgar_L[i].custom_shape_translation[1] = Pose_FK_Purgar_L[i].length / 2
    #FK_Indice_L
    Pose_FK_Indice_L = []
    if all(pose_Bones_get.get(f"FK_Indice_L.{i+1:03}") for i in range(4)):
        pose_Encontral_Bones("FK_Indice_L", 4, Pose_FK_Indice_L)
    if Pose_FK_Indice_L:
        for i in range(len(Pose_FK_Indice_L)):
            Pose_FK_Indice_L[i].custom_shape_translation[1] = Pose_FK_Indice_L[i].length / 2
    #FK_Corazon_L
    Pose_FK_Corazon_L = []
    if all(pose_Bones_get.get(f"FK_Corazon_L.{i+1:03}") for i in range(4)):
        pose_Encontral_Bones("FK_Corazon_L", 4, Pose_FK_Corazon_L)
    if Pose_FK_Corazon_L:
        for i in range(len(Pose_FK_Corazon_L)):
            Pose_FK_Corazon_L[i].custom_shape_translation[1] = Pose_FK_Corazon_L[i].length / 2
    #FK_Anular_L
    Pose_FK_Anular_L = []
    if all(pose_Bones_get.get(f"FK_Anular_L.{i+1:03}") for i in range(4)):
        pose_Encontral_Bones("FK_Anular_L", 4, Pose_FK_Anular_L)
    if Pose_FK_Anular_L:
        for i in range(len(Pose_FK_Anular_L)):
            Pose_FK_Anular_L[i].custom_shape_translation[1] = Pose_FK_Anular_L[i].length / 2
    #FK_Miñique_L
    Pose_FK_Miñique_L = []
    if all(pose_Bones_get.get(f"FK_Miñique_L.{i+1:03}") for i in range(4)):
        pose_Encontral_Bones("FK_Miñique_L", 4, Pose_FK_Miñique_L)
    if Pose_FK_Miñique_L:
        for i in range(len(Pose_FK_Miñique_L)):
            Pose_FK_Miñique_L[i].custom_shape_translation[1] = Pose_FK_Miñique_L[i].length / 2  


    #FK_Purgar_R
    Pose_FK_Purgar_R = []
    if all(pose_Bones_get.get(f"FK_Purgar_R.{i+1:03}") for i in range(3)):
        pose_Encontral_Bones("FK_Purgar_R", 3, Pose_FK_Purgar_R)
    if Pose_FK_Purgar_R:
        for i in range(len(Pose_FK_Purgar_R)):
            Pose_FK_Purgar_R[i].custom_shape_translation[1] = Pose_FK_Purgar_R[i].length / 2
    #FK_Indice_R
    Pose_FK_Indice_R = []
    if all(pose_Bones_get.get(f"FK_Indice_R.{i+1:03}") for i in range(4)):
        pose_Encontral_Bones("FK_Indice_R", 4, Pose_FK_Indice_R)
    if Pose_FK_Indice_R:
        for i in range(len(Pose_FK_Indice_R)):
            Pose_FK_Indice_R[i].custom_shape_translation[1] = Pose_FK_Indice_R[i].length / 2
    #FK_Corazon_R
    Pose_FK_Corazon_R = []
    if all(pose_Bones_get.get(f"FK_Corazon_R.{i+1:03}") for i in range(4)):
        pose_Encontral_Bones("FK_Corazon_R", 4, Pose_FK_Corazon_R)
    if Pose_FK_Corazon_R:
        for i in range(len(Pose_FK_Corazon_R)):
            Pose_FK_Corazon_R[i].custom_shape_translation[1] = Pose_FK_Corazon_R[i].length / 2
    #FK_AnuRar_R
    Pose_FK_Anular_R = []
    if all(pose_Bones_get.get(f"FK_Anular_R.{i+1:03}") for i in range(4)):
        pose_Encontral_Bones("FK_Anular_R", 4, Pose_FK_Anular_R)
    if Pose_FK_Anular_R:
        for i in range(len(Pose_FK_Anular_R)):
            Pose_FK_Anular_R[i].custom_shape_translation[1] = Pose_FK_Anular_R[i].length / 2
    #FK_Miñique_R
    Pose_FK_Miñique_R = []
    if all(pose_Bones_get.get(f"FK_Miñique_R.{i+1:03}") for i in range(4)):
        pose_Encontral_Bones("FK_Miñique_R", 4, Pose_FK_Miñique_R)
    if Pose_FK_Miñique_R:
        for i in range(len(Pose_FK_Miñique_R)):
            Pose_FK_Miñique_R[i].custom_shape_translation[1] = Pose_FK_Miñique_R[i].length / 2  




    if bpy.context.active_object or bpy.context.active_object.type == 'ARMATURE':
        armature = bpy.context.active_object
        for bone in armature.pose.bones:
            for constraint in bone.constraints:
                if constraint.type == 'STRETCH_TO':
                    constraint.rest_length = 0
    



