import bpy


def optimizar_mesh_low():
    # Obtiene el objeto activo
    obj = bpy.context.active_object

    # Verifica si el objeto activo existe y es una armadura ('ARMATURE')
    if obj and obj.type == 'ARMATURE':
        armature = obj.data
        
        props = obj.A_object_PropertyGroup
        # Obtiene los objetos hijos del objeto activo
        objetos_hijos = [objeto for objeto in bpy.data.objects if objeto.parent == obj]

        # Itera sobre los objetos hijos
        for Obj_H in objetos_hijos:
            # Verifica si el objeto hijo es un objeto tipo 'MESH'
            if Obj_H and Obj_H.type == 'MESH':
                # Agrega el modificador 'DECIMATE' al objeto hijo
                DECIMATE_EXISTE = False
            
                for Obj in objetos_hijos:
                    for mod in Obj.modifiers:
                        if mod and mod.type == 'DECIMATE':
                            DECIMATE_EXISTE = True
                
                if DECIMATE_EXISTE == False:     
                    modificador = Obj_H.modifiers.new("Hornstromp_Low", 'DECIMATE')
                    modificador.show_render = False  # Oculta el modificador en renderizado
                    modificador.ratio = 0.2  # Ajusta el porcentaje de reducción
                    props.Object_Decimate = 0.2
                
                for Mod in Obj_H.modifiers:
                    if Mod and Mod.type == 'SUBSURF':
                        Mod.levels = 0

def optimizar_mesh_med():
    # Obtiene el objeto activo
    obj = bpy.context.active_object

    # Verifica si el objeto activo existe y es una armadura ('ARMATURE')
    if obj and obj.type == 'ARMATURE':
        armature = obj.data
        
        props = obj.A_object_PropertyGroup
        # Obtiene los objetos hijos del objeto activo
        objetos_hijos = [objeto for objeto in bpy.data.objects if objeto.parent == obj]

        # Itera sobre los objetos hijos
        for Obj_H in objetos_hijos:
            # Verifica si el objeto hijo es un objeto tipo 'MESH'
            if Obj_H and Obj_H.type == 'MESH':
                
                for Mod in Obj_H.modifiers:
                    if Mod and Mod.type == 'SUBSURF':
                        Mod.levels = 1
                        
                for Mod in Obj_H.modifiers:
                    if Mod and Mod.type == 'DECIMATE':
                        if Mod.name == "Hornstromp_Low":
                            Obj_H.modifiers.remove(Mod)

def optimizar_mesh_quit():
    # Obtiene el objeto activo
    obj = bpy.context.active_object

    # Verifica si el objeto activo existe y es una armadura ('ARMATURE')
    if obj and obj.type == 'ARMATURE':
        armature = obj.data
        
        props = obj.A_object_PropertyGroup
        # Obtiene los objetos hijos del objeto activo
        objetos_hijos = [objeto for objeto in bpy.data.objects if objeto.parent == obj]

        # Itera sobre los objetos hijos
        for Obj_H in objetos_hijos:
            # Verifica si el objeto hijo es un objeto tipo 'MESH'
            if Obj_H and Obj_H.type == 'MESH':
                
                for Mod in Obj_H.modifiers:
                    if Mod and Mod.type == 'SUBSURF':
                        Mod.levels = Mod.render_levels
                        
                for Mod in Obj_H.modifiers:
                    if Mod and Mod.type == 'DECIMATE':
                        if Mod.name == "Hornstromp_Low":
                            Obj_H.modifiers.remove(Mod)