import bpy


from bl_ui.generic_ui_list import draw_ui_list
import sys
import os
current_dir = os.path.dirname(__file__)
sys.path.append(current_dir)

from Characters.Characters_H import *

Cat = "Hornstromp"


class Characters_exist_group(bpy.types.PropertyGroup):

    name: bpy.props.StringProperty(name="")
    link: bpy.props.StringProperty(name="")

class Characters_Add(bpy.types.Panel):
    bl_idname = "Characters_Add"
    bl_label = "Characters Add"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = Cat
    bl_options = {'DEFAULT_CLOSED'}
    bl_order = 5
    
    @classmethod
    def poll(cls, context):
        # Verificar si el objeto seleccionado es una armadura
        return False
    


    def draw(self, context):
        layout = self.layout

        draw_ui_list(
            layout,
            context,
            list_path="scene.Characters_exist",
            active_index_path="scene.Characters_exist_index",
            unique_id="characters_exist",
            insertion_operators=False,
            move_operators=False,
        )

        CTS_list = bpy.context.scene.Characters_exist
        CTS_list_index = bpy.context.scene.Characters_exist_index

        if 0 <= CTS_list_index < len(CTS_list):
            CTS = CTS_list[CTS_list_index]

            layout.label(text = CTS.name)
            layout.operator("wm.url_open", text="Add", icon = 'ADD').url = CTS.link
        
        layout.operator("gen.oper_h", text="Reset", icon = 'FILE_REFRESH').type = "RESET_DATA"
   


@bpy.app.handlers.persistent         
def Update_list(dummy):
    scene = bpy.context.scene
    CTS_list = scene.Characters_exist
    CTS_list.clear()

    if GE_Char:
        for CTS in GE_Char:
            new_list = CTS_list.add()
            new_list.name = CTS[0]
            new_list.link = CTS[1]

bpy.app.handlers.depsgraph_update_pre.append(Update_list)
        