import bpy

import sys
import os
current_dir = os.path.dirname(__file__)
sys.path.append(current_dir) 

from Swith import *
Cat = bl_category

from Paneles.Seletion_Bone_Operation import *

def icon(visible):
    if visible:
        return "RESTRICT_VIEW_OFF"
    else:
        return "RESTRICT_VIEW_ON"
    
def bones_select(collections):
    for bone in collections.bones:
        if not bone.select:
            return False
    return True
            
#selecionar los bones en la collecions 
def select(row, collections, context):
    
    if context.active_object.mode == 'POSE':
        
        if not bones_select(collections):
            icon = "RESTRICT_SELECT_OFF"
        else:
            icon = "RESTRICT_SELECT_ON"
            
        op = row.operator("select.bones", text="", icon=icon)
        op.type = not bones_select(collections)                   
        op.collection = collections.name
    if context.active_object.mode == 'POSE' or context.active_object.mode == 'EDIT': 
        if context.active_object.A_object_PropertyGroup.use_collections_input:
            row.operator("input.bones", text="", icon="IMPORT").collection = collections.name

    
class VIEWColletions_layers(bpy.types.Panel):
    bl_idname = "VIEWColletions_layers"
    bl_label = "Collections"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = Cat
    bl_options = {'HEADER_LAYOUT_EXPAND'}
    bl_order = 1

    @classmethod
    def poll(cls, context):
        # Verificar si el objeto seleccionado es una armadura
        return context.active_object and context.active_object.type == 'ARMATURE'
    
    def draw_header(self, context):
        row = self.layout.row()
        row.alignment = "RIGHT"
        row.scale_x = 1.1
        row.menu(Collections_menu.bl_idname,text='Options', icon='PREFERENCES')
        
    def draw(self, context):
        layout = self.layout
        

class Collections_menu(bpy.types.Menu):
    bl_idname = "col.Collections_menu"
    bl_label = "Collections Menu"

    def draw(self, context):
        layout = self.layout
        obj = context.active_object
        if obj and obj.type == 'ARMATURE':
            props = obj.A_object_PropertyGroup
            layout.prop(props, "use_collections_rig_creator", text=f"Use Collections {Cat}")
            layout.prop(props, "use_collections_input", text="Use Input")
            
class Collections_layers_Rig_Creator(bpy.types.Panel):
    bl_idname = "Collections_layers_Rig_Creator"
    bl_label = f"Collections {Cat}"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = Cat
    bl_parent_id = "VIEWColletions_layers"
    bl_options = {'HEADER_LAYOUT_EXPAND'}
    bl_order = 1
    
    @classmethod
    def poll(cls, context):
        # Verificar si el objeto seleccionado es una armadura
        return context.active_object.A_object_PropertyGroup.use_collections_rig_creator
    
    def draw(self, context):
        layout = self.layout
        
        
        

        obj = context.active_object
        if obj and obj.type == 'ARMATURE':
            armature = obj.data
            props = obj.A_object_PropertyGroup
            

            # Define un diccionario vacío para almacenar las colecciones
            Colletion = {}

            # Define una lista de los nombres de las colecciones
            nombres_colecciones = [
                'Cabeza', 'Cabeza_Def',
                'Torzo', 'Torzo_Def',
                'Brazo_G_L', 'Brazo_Fk_L', 'Brazo_IK_L',
                'Brazo_G_R', 'Brazo_Fk_R', 'Brazo_IK_R',
                'Pierna_G_L', 'Pierna_Fk_L', 'Pierna_Ik_L',
                'Pierna_G_R', 'Pierna_Fk_R', 'Pierna_Ik_R',
                'Mano_L', 'Mano_R'
            ]

            # Verifica si cada colección existe y agrégala al diccionario si es así
            for nombre in nombres_colecciones:
                if nombre in armature.collections:
                    Colletion[nombre] = armature.collections[nombre]

            if not '...' in Colletion :
                Colletion['...'] = None
            
                    
            #deselecionar los bones en la collecions  
            def deselect(row, collections):
                if context.active_object.mode == 'POSE':
                    op = row.operator("select.bones", text="", icon="RESTRICT_SELECT_ON")
                    op.type = False
                    op.collection = collections.name
                
            def prop(row, properties):
                
                row = row.row(align=True)
                
                row.prop(properties, "is_visible", text=properties.name, icon=icon(properties.is_visible))
                
                
                select(row, properties, context)
                #deselect(row, properties)
                
                
            if Colletion:

                Scale_x = 1
                Scale_y = 1.25

                def Column(layout, Colletion_A, Colletion_B, use_colums = False, ):
                    row = layout.row(align=True, translate=False)
                    row.scale_x = Scale_x
                    row.scale_y = Scale_y
                    if use_colums == False:
                        for col in Colletion_A:
                            if col:
                                prop(row, col)
                            
                    else:
                        col_B = row.column(align=True)
                        col_A = row.column(align=True)
                        for col in Colletion_B:
                            if col:
                                prop(col_B, col)
                        for col in Colletion_A:
                            if col:
                                prop(col_A, col) 

                def existe(Coll):
                    if Coll:
                        if Coll.name in armature.collections:
                            return Coll
                        else:
                            return None
                    else:
                        return None
                
                def IDexiste(Coll):
                    if Coll in Colletion:
                        return Coll
                    else:
                        return '...'
                    
                Column(
                layout, 
                Colletion_A = [
                    existe(Colletion[IDexiste('Cabeza')]),
                    existe(Colletion[IDexiste('Cabeza_Def')]),
                    ],
                Colletion_B = [], 
                use_colums = False
                        )

                Column(
                layout, 
                Colletion_A = [
                    existe(Colletion[IDexiste('Torzo')]),
                    existe(Colletion[IDexiste('Torzo_Def')]),
                    ],
                Colletion_B = [], 
                use_colums = False
                        )
                
                Column(
                layout, 
                Colletion_A = [
                    existe(Colletion[IDexiste('Brazo_G_L')]),
                    existe(Colletion[IDexiste('Brazo_Fk_L')]),
                    existe(Colletion[IDexiste('Brazo_IK_L')]),
                    ],
                Colletion_B = [
                    existe(Colletion[IDexiste('Brazo_G_R')]),
                    existe(Colletion[IDexiste('Brazo_Fk_R')]),
                    existe(Colletion[IDexiste('Brazo_IK_R')]),
                ], 
                use_colums = True
                        )

                Column(
                layout, 
                Colletion_A = [
                    existe(Colletion[IDexiste('Pierna_G_L')]),
                    existe(Colletion[IDexiste('Pierna_Fk_L')]),
                    existe(Colletion[IDexiste('Pierna_Ik_L')]),
                    ],
                Colletion_B = [
                    existe(Colletion[IDexiste('Pierna_G_R')]),
                    existe(Colletion[IDexiste('Pierna_Fk_R')]),
                    existe(Colletion[IDexiste('Pierna_Ik_R')]),
                ], 
                use_colums = True
                        )
                
                Column(
                layout, 
                Colletion_A = [
                    existe(Colletion[IDexiste('Mano_R')]),
                    existe(Colletion[IDexiste('Mano_L')]),
                    ],
                Colletion_B = [], 
                use_colums = False
                        )

            def icon_(visible):
                if visible:
                    return "DOWNARROW_HLT"
                else:
                    return "RIGHTARROW"
            
            

class Collections_layers(bpy.types.Panel):
    bl_idname = "Collections_layers"
    bl_label = "Collections"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = Cat
    bl_parent_id = "VIEWColletions_layers"
    bl_options = {'DEFAULT_CLOSED'}
    bl_order = 2
    
    def draw_header(self, context):
        layout = self.layout
        
        #layout.operator("gen.oper_h", text="", icon='THREE_DOTS').type="CALL_COL_MENU"
        layout.menu(call_menu_col.bl_idname,text='', icon='PREFERENCES')
    def draw(self, context):
        layout = self.layout
        
        obj = context.active_object
        if obj and obj.type == 'ARMATURE':
            armature = obj.data
            props = obj.A_object_PropertyGroup
            

            # Define un diccionario vacío para almacenar las colecciones
            Colletion = {}

            # Define una lista de los nombres de las colecciones
            nombres_colecciones = [
                'Cabeza', 'Cabeza_Def',
                'Torzo', 'Torzo_Def',
                'Brazo_G_L', 'Brazo_Fk_L', 'Brazo_IK_L',
                'Brazo_G_R', 'Brazo_Fk_R', 'Brazo_IK_R',
                'Pierna_G_L', 'Pierna_Fk_L', 'Pierna_Ik_L',
                'Pierna_G_R', 'Pierna_Fk_R', 'Pierna_Ik_R',
                'Mano_L', 'Mano_R'
            ]

            # Verifica si cada colección existe y agrégala al diccionario si es así
            for nombre in nombres_colecciones:
                if nombre in armature.collections:
                    Colletion[nombre] = armature.collections[nombre]

            if not '...' in Colletion :
                Colletion['...'] = None

           
            prop = context.object.A_object_PropertyGroup 
            
            col_ = layout.grid_flow(
                    row_major=False, 
                    columns=prop.props_col, 
                    even_columns=False, 
                    even_rows=False, 
                    align=True)
            
            
            def name_(col):
                if prop.props_col > 3:
                    return col.name[:2].upper()
                else:
                    return col.name
            
            if armature.collections:
                for col in armature.collections:
                    if prop.use_collections_rig_creator:
                        if not col.name in nombres_colecciones:
                            row = col_.row(align=True)
                            row.prop(col,"is_visible", text=name_(col), icon = icon(col.is_visible),
                                     )
                            select(row, col, context)
                            #deselect(row, col)
                    else:
                        
                        row = col_.row(align=True)
                        row.prop(col,"is_visible", text=name_(col), icon = icon(col.is_visible), 
                                 )
                        select(row, col, context) 
                        
class call_menu_col(bpy.types.Menu):
    bl_idname = "col.call_menu"
    bl_label = "Columns"

    def draw(self, context):
        layout = self.layout
        prop = context.object.A_object_PropertyGroup 
        layout.prop(prop, "props_col", text="Columns")
        