import bpy

import sys
import os
current_dir = os.path.dirname(__file__)
sys.path.append(current_dir) 



from Swith import *

#from Paneles.Enum_properties.Enum_Panel import *

Cat = bl_category

def posebone_tiene_custom_props(posebone):
    return bool(posebone.keys())  

class object_PropertyGroup(bpy.types.PropertyGroup):
    
    
    Layers_More: bpy.props.BoolProperty(default = False)
    Props_More: bpy.props.BoolProperty(default = False)
    Props_More_Armature: bpy.props.BoolProperty(default = False)
    
    Auto_BRAZO_R: bpy.props.BoolProperty(default = False)
    Auto_BRAZO_L: bpy.props.BoolProperty(default = False)
    
    Auto_PIERNA_R: bpy.props.BoolProperty(default = False)
    Auto_PIERNA_L: bpy.props.BoolProperty(default = False)
    
    Object_Decimate: bpy.props.FloatProperty(default = 0.0)
    
    use_collections_input: bpy.props.BoolProperty(default = False)
    
    use_collections_rig_creator: bpy.props.BoolProperty(default = True)
    use_properties_rig_creator: bpy.props.BoolProperty(default = True)
    
    props_col: bpy.props.IntProperty(default=2, min=1, max=4)
    props_armature_col: bpy.props.IntProperty(default=2, min=1, max=4)
    
    props_bone_col: bpy.props.IntProperty(default=2, min=1, max=4)
    props_bone_col_prop: bpy.props.IntProperty(default=2, min=1, max=4)

    use_prop_bone_view: bpy.props.BoolProperty(default = False)
    
class VIEWCustomProperties(bpy.types.Panel):
    bl_idname = "VIEWCustomProperties"
    bl_label = "Properties"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = Cat
    bl_options = {'HEADER_LAYOUT_EXPAND'}    
    bl_order = 2

    @classmethod
    def poll(cls, context):
        # Verificar si el objeto seleccionado es una armadura
        return context.active_object and context.active_object.type == 'ARMATURE'

    def draw_header(self, context):
        layout = self.layout
        row = layout.row()
        row.alignment = "RIGHT"
        row.scale_x = 1.1
        row.menu(Properties_menu.bl_idname,text='Options', icon='PREFERENCES')
        
    def draw(self, context):
        layout = self.layout
        
class Properties_menu(bpy.types.Menu):
    bl_idname = "col.Properties_menu"
    bl_label = "Properties Menu"

    def draw(self, context):
        layout = self.layout
        obj = context.active_object
        if obj and obj.type == 'ARMATURE':
            props = obj.A_object_PropertyGroup
            layout.prop(props, "use_properties_rig_creator", text=f"Use Properties {Cat}")
            
class Panel_rig_creator_props(bpy.types.Panel):
    bl_idname = "Panel_rig_creator_props"
    bl_label = f"Properties {Cat}"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = Cat
    bl_options = {'HEADER_LAYOUT_EXPAND'} 
    bl_parent_id = "VIEWCustomProperties"
    bl_order = 1
    
    @classmethod
    def poll(cls, context):
        # Verificar si el objeto seleccionado es una armadura
        return context.active_object.A_object_PropertyGroup.use_properties_rig_creator
    
    def draw(self, context):
        layout = self.layout
        obj = context.active_object
        if obj and obj.type == 'ARMATURE':
            armature = obj.data

            Scale_x = 1
            Scale_y = 1.5

            prop = {
                'Cabeza_Global_Local': "Cabeza_Global_Local",
                'Ojos_Global_Local': "Ojos_Global_Local",
                'Brazo_IK_FK_L': "Brazo_IK_FK_L",
                'Brazo_IK_FK_R': "Brazo_IK_FK_R",
                'Brazo_IK_Stretch_L': "Brazo_IK_Stretch_L",
                'Brazo_IK_Stretch_R': "Brazo_IK_Stretch_R",
                'Brazo_Rot_Mov_L': "Brazo_Rot_Mov_L",
                'Brazo_Rot_Mov_R': "Brazo_Rot_Mov_R",
                'Global_Local_Brazo_L': "Global_Local_Brazo_L",
                'Global_Local_Brazo_R': "Global_Local_Brazo_R",
                'Pierna_IK_Fk_L': "Pierna_IK_Fk_L",
                'Pierna_IK_Fk_R': "Pierna_IK_Fk_R",
                'Pierna_IK_Stretch_L': "Pierna_IK_Stretch_L",
                'Pierna_IK_Stretch_R': "Pierna_IK_Stretch_R",
                'Pierna_Rot_Mov_L': "Pierna_Rot_Mov_L",
                'Pierna_Rot_Mov_R': "Pierna_Rot_Mov_R",
            }

            # Define un diccionario para almacenar los valores de las propiedades
            prop_valor = {}

            # Verifica si cada propiedad existe y agrega su valor al diccionario si es así
            for nombre, propiedad in prop.items():
                if propiedad in armature:
                    prop_valor[nombre] = armature[propiedad]

            def Column(row, prop_A, text_A, use_facto = False,): 
                for p in range(len(prop_A)):
                    if prop_A[p]:
                        if prop_A[p] in armature:
                            row.prop(armature, f'["{prop_A[p]}"]', text=text_A[p], slider = use_facto)
                
            def existe(prop):
                if prop:
                    if prop in armature:
                        return prop
                    else:
                        return None
                else:
                    return None    
            row = layout.row(align=False, translate=False)
            
            if existe(prop['Cabeza_Global_Local']):
                row.label(text = "Cabeza")
            if existe(prop['Ojos_Global_Local']):
                row.label(text = "Ojos")

            row = layout.row(align=False, translate=False)
            row.scale_x = Scale_x
            row.scale_y = Scale_y

            #cabeza Properties
            Column(
                row, 
                prop_A = [
                    existe(prop['Cabeza_Global_Local']),
                    existe(prop['Ojos_Global_Local']),
                ], 
                text_A = [
                    "GLobal Local",
                    "GLobal Local",    
                ],
                use_facto = True,
                   )
            
            
            def Ik_Fk(row, 
                      properties_a = [], label_a = "", Text_a = [], use_Factor_a = [],
                      properties_b = [], label_b = "", Text_b = [], use_Factor_b = [],
                      use_columns = False,
                      ):

                col_B = row.column(align=True)
                col_A = row.column(align=True)
                
                if use_columns == False:
                    existe=None
                    for i in properties_a:
                        existe=i
                    if existe != None:
                        col_A.label(text = label_a)

                    for i in range(len(properties_a)):
                        if properties_a[i]:
                            if properties_a[i] in armature:  
                                col_A.prop(armature, f'["{properties_a[i]}"]', text=Text_a[i], slider = use_Factor_a[i], toggle = use_Factor_a[i])
                else:
                    
                    existe=None
                    
                    for i in properties_a:
                        existe=i
                        
                    if existe != None:
                        col_A.label(text = label_a)
                        
                    for i in properties_b:
                      existe=i  
                      
                    if existe != None:
                        col_B.label(text = label_b)

                    for i in range(len(properties_a)):
                        if properties_a[i]:
                            if properties_a[i] in armature:  
                                col_A.prop(armature, f'["{properties_a[i]}"]', text=Text_a[i], slider = use_Factor_a[i], toggle = use_Factor_a[i])

                    for i in range(len(properties_b)):
                        if properties_a[i]:
                            if properties_b[i] in armature:  
                                col_B.prop(armature, f'["{properties_b[i]}"]', text=Text_b[i], slider = use_Factor_b[i], toggle = use_Factor_b[i])



            row = layout.row(align=False, translate=False)
            row.scale_x = Scale_x
            row.scale_y = Scale_y / 1.5

            Ik_Fk(row, 
                  
                #L
                  properties_a = [
                    existe(prop["Brazo_IK_FK_L"]), 
                    existe(prop["Brazo_IK_Stretch_L"]), 
                    existe(prop["Brazo_Rot_Mov_L"]),
                    ], 
                  label_a = "Brazo L", 
                  Text_a = [
                      "IK FK", "Streth", "Rot Mov"
                      ], 
                  use_Factor_a = [
                      True, True, True
                      ],

                #R
                  properties_b = [
                    existe(prop["Brazo_IK_FK_R"]), 
                    existe(prop["Brazo_IK_Stretch_R"]), 
                    existe(prop["Brazo_Rot_Mov_R"]),
                    ], 
                  label_b = "Brazo R", 
                  Text_b = [
                      "IK FK", "Streth", "Rot Mov"
                      ], 
                  use_Factor_b = [
                      True, True, True
                      ],

                use_columns = True

                  )
            
            
            #Menu de cambio de follow 
            if prop_valor.get("Global_Local_Brazo_L") is not None and prop_valor.get("Global_Local_Brazo_R") is not None:
                if isinstance(prop_valor["Global_Local_Brazo_L"], int) and isinstance(prop_valor["Global_Local_Brazo_R"], int):
                    row = layout.row(align=False, translate=False)
                    row_a = row.row(align=True, translate=False)
                    row_b = row.row(align=True, translate=False)
                    row.scale_x = Scale_x
                    row.scale_y = Scale_y / 1.5
                    
                    if "Global_Local_Brazo_R" in armature:
                        row_a.prop(armature, f'["{prop["Global_Local_Brazo_R"]}"]', text="Follow", slider = False)
                        row_a.menu(Enum_Follow_R.bl_idname,text='', icon='CON_FOLLOWPATH')
                        #row_a.prop_menu_enum(obj, "follow_emun_R", text="", icon = 'CON_FOLLOWPATH')
                    if "Global_Local_Brazo_L" in armature:
                        row_b.prop(armature, f'["{prop["Global_Local_Brazo_L"]}"]', text="Follow", slider = False)
                        row_b.menu(Enum_Follow_L.bl_idname,text='', icon='CON_FOLLOWPATH')
                        #row_b.prop_menu_enum(obj, "follow_emun_L", text="", icon = 'CON_FOLLOWPATH')
    
                    
                else:
                    row = layout.row(align=False, translate=False)
                    row.scale_x = Scale_x
                    row.scale_y = Scale_y / 1.5
                    if "Global_Local_Brazo_R" in armature:
                        row.prop(armature, f'["{prop["Global_Local_Brazo_R"]}"]', text="GLobal Local", slider = True)
                    if "Global_Local_Brazo_L" in armature:
                        row.prop(armature, f'["{prop["Global_Local_Brazo_L"]}"]', text="GLobal Local", slider = True)
            
            
            row = layout.row(align=False, translate=False)
            row.scale_x = Scale_x
            row.scale_y = Scale_y / 1.5
            
            def Bono_existe(IK_exite):
                for Bone in armature.bones:
                    if Bone.name in IK_exite:
                        return True
                    
                return False
            
            props = obj.A_object_PropertyGroup
            
            
            
            IK_exite = [
            "Control_FK_Brazo_R.001",
            "Control_FK_Brazo_R.002",
            "Control_FK_Brazo_R.003", 
            ]
            if Bono_existe(IK_exite):
                row_ = row.row(align=True)
                row_.operator("gen.oper_h", text = "FK->IK", 
                             emboss=True, icon='SNAP_ON').type = "IMAN_BRAZO_R"
                row_1 = row_.row(align=True)
                row_1.enabled = armature["Brazo_Rot_Mov_R"]
                new = row_1.operator("gen.oper_h", text = "IK->FK", 
                                 emboss=True, icon='SNAP_ON')
                new.type = "IK_IMAN_BRAZO_R"
                
            IK_exite = [
            "Control_FK_Brazo_L.001",
            "Control_FK_Brazo_L.002",
            "Control_FK_Brazo_L.003", 
            ]
            if Bono_existe(IK_exite):
                row_ = row.row(align=True)
                row_.operator("gen.oper_h", text = "FK->IK", 
                             emboss=True, icon='SNAP_ON').type = "IMAN_BRAZO_L"
                row_1 = row_.row(align=True)
                row_1.enabled = armature["Brazo_Rot_Mov_L"]
                new = row_1.operator("gen.oper_h", text = "IK->FK", 
                                 emboss=True, icon='SNAP_ON')
                new.type = "IK_IMAN_BRAZO_L"
                
                          
            row = layout.row(align=False, translate=False)
            row.scale_x = Scale_x
            row.scale_y = Scale_y / 1.5

            Ik_Fk(row, 
                  
                #L
                  properties_a = [
                    existe(prop["Pierna_IK_Fk_L"]), 
                    existe(prop["Pierna_IK_Stretch_L"]), 
                    existe(prop["Pierna_Rot_Mov_L"]),
                    ], 
                  label_a = "Pierna L", 
                  Text_a = [
                      "IK FK", "Streth", "Rot Mov"
                      ], 
                  use_Factor_a = [
                      True, True, True
                      ],

                #R
                  properties_b = [
                    existe(prop["Pierna_IK_Fk_R"]), 
                    existe(prop["Pierna_IK_Stretch_R"]), 
                    existe(prop["Pierna_Rot_Mov_R"]),
                    ], 
                  label_b = "Pierna R", 
                  Text_b = [
                      "IK FK", "Streth", "Rot Mov"
                      ], 
                  use_Factor_b = [
                      True, True, True
                      ],

                use_columns = True

                  )
            
            row = layout.row(align=False, translate=False)
            row.scale_x = Scale_x
            row.scale_y = Scale_y / 1.5
            
            IK_exite = [
            "FK_Pierna_R.001",
            "FK_Pierna_R.002",
            "FK_Pierna_R.003", 
            "FK_Pierna_R.004", 
            ]
            if Bono_existe(IK_exite):
                row_ = row.row(align=True)
                row_.operator("gen.oper_h", text = "FK->IK", 
                             emboss=True, icon='SNAP_ON').type = "IMAN_PIERNA_R"
                row_1 = row_.row(align=True)
                row_1.enabled =armature["Pierna_Rot_Mov_R"]
                new = row_1.operator("gen.oper_h", text = "IK->FK", 
                                 emboss=True, icon='SNAP_ON')
                new.type = "IK_IMAN_PIERNA_R"
                
            IK_exite = [
            "FK_Pierna_L.001",
            "FK_Pierna_L.002",
            "FK_Pierna_L.003", 
            "FK_Pierna_L.004", 
            ]
            if Bono_existe(IK_exite):
                row_ = row.row(align=True)
                row_.operator("gen.oper_h", text = "FK->IK", 
                             emboss=True, icon='SNAP_ON').type = "IMAN_PIERNA_L"
                row_1 = row_.row(align=True)
                row_1.enabled = armature["Pierna_Rot_Mov_L"]
                new = row_1.operator("gen.oper_h", text = "IK->FK", 
                                 emboss=True, icon='SNAP_ON')
                new.type = "IK_IMAN_PIERNA_L"
                
            
            
            
def posebone_tiene_custom_props(posebone):
    return bool(posebone.keys())  

def existo(prop, bone):
    if prop.use_prop_bone_view:
        for prop_name, prop_value in bone.items():
            if prop_name != "Bone_Constraint_list" and prop_name != "Bone_Constraint_list_index":
                if prop_name.startswith("View"):
                    return True
        return False
    else:
        
        for prop_name, prop_value in bone.items():
            if prop_name != "Bone_Constraint_list" and prop_name != "Bone_Constraint_list_index":
                return True
        return False

class Props_panel_Armature(bpy.types.Panel):
    bl_idname = "props_panel_Armature"
    bl_label = "Properties Armature"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = Cat
    bl_parent_id = "VIEWCustomProperties"
    bl_options = {'DEFAULT_CLOSED'}
    bl_order = 2
    
    def draw_header(self, context):
        layout = self.layout
        row = layout.row()
        row.alignment = "LEFT"
        row.menu(call_menu_prop_armature.bl_idname,text='', icon='PREFERENCES')
        #row.operator("gen.oper_h", text="", icon='THREE_DOTS').type="CALL_ARMATURE_MENU"
    
    def draw(self, context):
        layout = self.layout

        obj = context.active_object

        if obj and obj.type == 'ARMATURE':
            armature = obj.data
            props = context.active_object.Enum
            
            

            
            prop = context.object.A_object_PropertyGroup 
            col = layout.grid_flow(
                    row_major=False, 
                    columns=prop.props_armature_col, 
                    even_columns=False, 
                    even_rows=False, 
                    align=True)
            for index, enum in enumerate(props):
                row = col.row()
                row.label(text=enum.name)
                row.alignment = "RIGHT"
                if enum.use_visible:
                    row_ = row.row(align=True)
                    for item in enum.items:
                        row_.prop_enum(enum,"Enum",f"{item.type}",text=item.name) 
                else:
                    row.prop(enum, "Enum", text="")
            
            if posebone_tiene_custom_props(armature):
                
                for prop_name, prop_value in armature.items():
                    if prop_name.startswith("View"):
                        text = prop_name.replace("View", "")
                        if isinstance(prop_value, float):
                            col.prop(armature, f'["{prop_name}"]', text=text, toggle = True, slider= True)
                        else:
                            col.prop(armature, f'["{prop_name}"]', text=text, toggle = True)



class Props_panel_bone(bpy.types.Panel):
    bl_idname = "Props_panel_bone"
    bl_label = "Properties Bone"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = Cat
    bl_parent_id = "VIEWCustomProperties"
    bl_options = {'DEFAULT_CLOSED'}
    bl_order = 3
    
    def draw_header(self, context):
        layout = self.layout
        row = layout.row()
        #row.operator("gen.oper_h", text="", icon='THREE_DOTS').type="CALL_BONE_MENU"
        row.menu(call_menu_prop_bone.bl_idname,text='', icon='PREFERENCES')
    def draw(self, context):
        layout = self.layout
        obj = context.active_object

        if obj and obj.type == 'ARMATURE' and obj.mode == 'POSE':
            armature = obj
            
            prop = context.object.A_object_PropertyGroup 
            
            layout = layout.grid_flow(
                row_major=False, 
                columns=prop.props_bone_col, 
                even_columns=False, 
                even_rows=False, 
                align=True
                )
            
            # Iterar sobre los huesos del armature
            for bone in armature.pose.bones:
                # Verificar si el hueso tiene propiedades personalizadas
                if bool(bone.keys()) and existo(prop, bone):

                    box = layout.box()
                    box.label(text=bone.name, icon="BONE_DATA")
                    col = box.grid_flow(
                        row_major=False, 
                        columns=prop.props_bone_col_prop, 
                        even_columns=False, 
                        even_rows=False, 
                        align=True)
                    # Mostrar todas las propiedades personalizadas del hueso
                    for prop_name, prop_value in bone.items():
                        if prop_name != "Bone_Constraint_list" and prop_name != "Bone_Constraint_list_index":
                            if prop.use_prop_bone_view:
                                if prop_name.startswith("View"):
                                    text = prop_name.replace("View", "")
                                    if isinstance(prop_value, float):
                                        col.prop(bone, f'["{prop_name}"]', text=text, toggle=True, slider=True)
                                    else:
                                        col.prop(bone, f'["{prop_name}"]', text=text, toggle=True)
                            else:
                                if isinstance(prop_value, float):
                                    col.prop(bone, f'["{prop_name}"]', text=prop_name, toggle=True, slider=True)
                                else:
                                    col.prop(bone, f'["{prop_name}"]', text=prop_name, toggle=True)

class call_menu_prop_armature(bpy.types.Menu):
    bl_idname = "col.call_menu_prop_armature"
    bl_label = "Columns"

    def draw(self, context):
        layout = self.layout
        prop = context.object.A_object_PropertyGroup 
        layout.prop(prop, "props_armature_col", text="Columns")
        
        layout.separator(factor=1.0)
        layout.label(text="How to call properties?")
        layout.label(text="     To display the properties, ensure they are")
        layout.label(text="     labeled with 'View' in their names.")

class call_menu_prop_bone(bpy.types.Menu):
    bl_idname = "col.call_menu_prop_bone"
    bl_label = "Columns"

    def draw(self, context):
        layout = self.layout
        prop = context.object.A_object_PropertyGroup 
        layout.prop(prop, "props_bone_col", text="Columns")
        layout.prop(prop, "props_bone_col_prop", text="Columns To Bones")
        layout.separator(factor=1.0)
        layout.prop(prop, "use_prop_bone_view", text="Only 'View' labels")
        if prop.use_prop_bone_view:
            layout.label(text="How to call properties?")
            layout.label(text="     To display the properties, ensure they are")
            layout.label(text="     labeled with 'View' in their names.")

mapeo_valores = [
        "Root Move",
        "Root Cadera",
        "Hombros",
        "Hombro",  
        "Root Brazo",
        ]  
   
def icon_enum_selct(valor, cual):
    obj = bpy.context.active_object
    if obj and obj.type == 'ARMATURE':
        armature = obj.data
        if armature:
            if armature[cual] == valor:
                return "RESTRICT_SELECT_OFF"
            else:
                return "RESTRICT_SELECT_ON"  
    else:
        return "BLANK1" 
def select_enum(valor, cual):
    obj = bpy.context.active_object
    if obj and obj.type == 'ARMATURE':
        armature = obj.data
        if armature:
            if armature[cual] == valor:
                return True
            else:
                return False  
    else:
        return False              
class Enum_Follow_L(bpy.types.Menu):
    bl_idname = "enum.follow_l"
    bl_label = "Enum_Follow_L"
    
    def draw(self, context):
        layout = self.layout

        for i in range(len(mapeo_valores)):
            
            new = layout.operator(
                "enum.callvalue", 
                text=mapeo_valores[i], 
                icon=icon_enum_selct(i, "Global_Local_Brazo_L"), 
                depress=select_enum(i, "Global_Local_Brazo_L"))
            new.cual = "L"
            new.type = mapeo_valores[i]
  
class Enum_Follow_R(bpy.types.Menu):
    bl_idname = "enum.follow_r"
    bl_label = "Enum_Follow_R"

    def draw(self, context):
        layout = self.layout       

        for i in range(len(mapeo_valores)):
            new = layout.operator(
                "enum.callvalue", 
                text=mapeo_valores[i], 
                icon=icon_enum_selct(i, "Global_Local_Brazo_R"), 
                depress=select_enum(i, "Global_Local_Brazo_R"))
            new.cual = "R"
            new.type = mapeo_valores[i]
            
class call_enum_operator(bpy.types.Operator):
    bl_idname = "enum.callvalue"
    bl_label = "Call Enum"
    bl_options = {"REGISTER"}

    cual: bpy.props.StringProperty(default="")
    type: bpy.props.StringProperty(default="")

    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        obj = bpy.context.active_object
        if obj and obj.type == 'ARMATURE':
            armature = obj.data
            if armature:
                mapeo_valores = {
                "Root Move": 0,
                "Root Cadera": 1,
                "Hombros": 2,
                "Hombro": 3,  
                "Root Brazo": 4,
                }

                if self.cual == "L":
                    if "Global_Local_Brazo_L" in armature:
                        if isinstance(armature["Global_Local_Brazo_L"], int):
                                armature["Global_Local_Brazo_L"] = mapeo_valores[self.type]
                else:
                    if "Global_Local_Brazo_R" in armature:
                        if isinstance(armature["Global_Local_Brazo_R"], int):
                                armature["Global_Local_Brazo_R"] = mapeo_valores[self.type]

        return {"FINISHED"}

@bpy.app.handlers.persistent            
def deselect_bones(dummy):
    obj = bpy.context.active_object
    if obj and obj.type == 'ARMATURE' and obj.mode == 'POSE':
        
        names = [
            "IK_(key:4ffff)pole_brazo_L",
            "IK_(key:4ffff)pole_brazo_R",
            "IK_(key:4ffff)pole_Piena_L",
            "IK_(key:4ffff)pole_Piena_R"
        ]
        
        for name in names:
            bone = obj.pose.bones.get(name)
            if bone:
                bone.bone.select = False
             # Desactivar el hueso si es el hueso activo
                if obj.data.bones.active == bone.bone:
                    obj.data.bones.active = None
bpy.app.handlers.depsgraph_update_pre.append(deselect_bones)       
    

    
