import bpy 
import time
import sys
import os
from bl_ui.generic_ui_list import draw_ui_list
current_dir = os.path.dirname(__file__)
sys.path.append(current_dir) 

def Call_Paneles(Name, self, context, layout):
    if hasattr(bpy.types, Name):
        panel_class = getattr(bpy.types, Name)
        
        panel_instance = panel_class(context)
        panel_instance.layout = layout
        panel_instance.draw(context)
            
    else:
        layout.label(text="Can't display this panel!", icon="ERROR")

Paneles=[
        "Armature Reset", 
        "Generator Def, Fk y Fingers", 
        "Generator IK", 
        "Generator Fk",
        "Generator Bones",
        ]  

class Rig_Creator_PropertyGroup(bpy.types.PropertyGroup):
    view_subpanels: bpy.props.BoolVectorProperty(
        default=(False, False, False, False, False, False), 
        size=6,)
    
    Crear_Hueso_Def: bpy.props.BoolProperty(default=(True))
    
    #constraint
    Add_activo_or_Seletion: bpy.props.EnumProperty(items=[
        ('ACTIVE', "Bone Active", ""),
        ('SELECTION', "Bones Selections", ""),
        ], 
        name='Add_Activo_or_Seletion', 
        default='ACTIVE', 
        )
    
    #Genarador (Fk, DEF y ROT)
    use_def: bpy.props.BoolProperty(default=(True))
    use_fk: bpy.props.BoolProperty(default=(True))
    use_dedos: bpy.props.BoolProperty(default=(False))
    use_dedos_rot: bpy.props.BoolProperty(default=(False))
    use_Segments: bpy.props.BoolProperty(default=(True))
    use_Parent: bpy.props.BoolProperty(default=(True))
    Base_name_DEF: bpy.props.StringProperty(default="Def_")
    Base_name_FK: bpy.props.StringProperty(default="Fk_")
    Base_name_DEDOS: bpy.props.StringProperty(default="Fingers_")
    int_Segments: bpy.props.IntProperty(default=32, min=1, max=32)
    
    #Generador IK
    use_strech: bpy.props.BoolProperty(default=(True))
    use_pole_target: bpy.props.BoolProperty(default=(True))
    use_track_to: bpy.props.BoolProperty(default=(True))
    use_copy_transforms_IK: bpy.props.BoolProperty(default=(False))
    Angle_IK: bpy.props.FloatProperty(default=-1.5708,subtype='ANGLE')
    Base_name_IK: bpy.props.StringProperty(default="IK_")
    
    #Generador FK
    use_view_object: bpy.props.BoolProperty(default=(True))
    use_copy_transforms_FK: bpy.props.BoolProperty(default=(True))
    Base_name_FK_S: bpy.props.StringProperty(default="Fk_")
    
    #Generador Bone
    look_bone: bpy.props.EnumProperty(items=[
        ('X', "X", ""),
        ('Y', "Y", ""),
        ('Z', "Z", ""),
        ('-X', "-X", ""),
        ('-Y', "-Y", ""),
        ('-Z', "-Z", ""),
        ], 
        name='LooK Bone', 
        default={'Z'}, 
        options={'ENUM_FLAG'}
        )
    add_orientation: bpy.props.EnumProperty(items=[
        ('GLOBAL', "Global", ""),
        ('NORMAL', "Normal", ""),
        ], 
        name='Add Orientation', 
        default='GLOBAL', 
        )
    viewport_D_tipo: bpy.props.EnumProperty(items=[
        ('SINGLE_ARROW', "Arrow", "EMPTY_SINGLE_ARROW"),
        ('CIRCLE', "Circle", "MESH_CIRCLE"),
        ('CUBE', "Cube", "CUBE"),
        ('SPHERE', "Sphere", "SPHERE"),
        ], 
        name='Type', 
        default='SPHERE', 
        )
    use_Parent_b: bpy.props.BoolProperty(default=(True))
    use_Strech_to_b: bpy.props.BoolProperty(default=(True))
    use_viewport_d: bpy.props.BoolProperty(default=(True))
    use_mas_1: bpy.props.BoolProperty(default=(False))
    Base_name_b: bpy.props.StringProperty(default="Add_")

    #Generador Curve Bone
    use_Auto_Bone: bpy.props.BoolProperty(default=False)
    curve_bulge: bpy.props.FloatProperty(default=1.0, min=0 , max=100.0)
    use_curve_root: bpy.props.BoolProperty(default=(False))
    Base_name_curve_free: bpy.props.StringProperty(default="Free_")
    Base_name_curve_cont: bpy.props.StringProperty(default="Cont_")
    Base_name_curve_root: bpy.props.StringProperty(default="Root_")
    curve_int_Segments: bpy.props.IntProperty(default=32, min=1, max=32)
     
from Operadores.Rig_Creator_Operation.RIg_Constraint_G import *

class OBJECT_OT_toggle_edit(bpy.types.Operator):
    bl_idname = "object.toggle_edit"
    bl_label = "Toggle Edit"
    bl_description = "Toggle edit mode for the item"
    
    item_index: bpy.props.IntProperty()
    type: bpy.props.StringProperty(default = "")
    
    def execute(self, context):
        if self.type == "RUN":
            item = context.scene.save_constraint[self.item_index]
            item.editing = not item.editing
            
        return {'FINISHED'}
    
class CONST_UL_List(bpy.types.UIList):
    
    def draw_item(self, context, layout, data, item, icon, active_data, active_propname, index):
        
        if self.layout_type in {'DEFAULT', 'COMPACT'}:

            row = layout.row(align=True)
            row.alignment = 'LEFT'
            row.prop(item, "type", text="", icon="ADD", icon_only=True, emboss=False) 
            row.prop(item, "name", text="",  emboss=False)
            row = layout.row(align=True)
            row.alignment = 'RIGHT'
            row.prop(item, "influence", text="",  emboss=False)
                 
                
        elif self.layout_type in {'GRID'}:
            layout.alignment = 'CENTER'
            layout.label(text="", icon="")


#constraint
def constraint_list(layout, context, save_const):
    
    Rig_props = context.scene.Rig_Creator_PropertyGroup
    
    row = layout.row(align=True)
    scene = context.scene
    row.template_list("CONST_UL_List", "save_constraint", scene, "save_constraint", scene, "save_constraint_index")
    
    col = row.column(align=True)
    col.operator("rig.creator", text= "", icon="ADD").type = "ADD_CONST"
    row_ = col.column(align=True)
    
    if save_const:
       row_.active = True
    else:
        row_.active = False
    
    row_.operator("rig.creator", text= "", icon="REMOVE").type = "X_CONST"
    
    
    if save_const: 
        col.operator("rig.creator", text= "", icon="TRIA_UP").type = "UP_CONST"
        col.operator("rig.creator", text= "", icon="TRIA_DOWN").type = "DOWN_CONST"
    
    
    col.menu(add_Advanced.bl_idname, text = "", icon = 'DOWNARROW_HLT')
    
    row = layout.row(align=True)
    row.operator("rig.creator", text= "Add", icon= 'ADD').type = "ADD_CONST_NEW" 
    row.prop_menu_enum(Rig_props, "Add_activo_or_Seletion", text="", icon='BONE_DATA')
    
    row = layout.row(align=True)
    row.operator("rig.creator", text= "Save").type = "SAVE_CONST"  
    
    
class Rig_Creator_Constraint(bpy.types.Panel):
    bl_idname = "Rig_Creator_Constraint"
    bl_label = "Custom Constraint"
    bl_space_type = 'PROPERTIES'
    bl_region_type = 'WINDOW'
    bl_context = "bone_constraint"
    bl_options = {'DEFAULT_CLOSED'}
    bl_order = 1
    
    @classmethod
    def poll(cls, context):
        return False
        return (context.pose_bone and context.active_pose_bone)
        
    def draw(self, context):
        layout = self.layout
        
        save_constraint_index = bpy.context.scene.save_constraint_index
        save_const = bpy.context.scene.save_constraint
        print(save_const)
        constraint_list(layout, context, save_const)
        
class View_3D_Rig_Creator_Constraint(bpy.types.Panel):
    bl_idname = "View_3D_Rig_Creator_Constraint"
    bl_label = "Rig Creator Constraint"
    bl_space_type = 'PROPERTIES'
    bl_region_type = 'WINDOW'
    bl_context = "Pass"
    
    @classmethod
    def poll(cls, context):
        return False
        return (
            context.active_object and context.active_object.type == 'ARMATURE'and context.mode == 'POSE')
               
    def draw(self, context):
        layout = self.layout
        save_constraint_index = bpy.context.scene.save_constraint_index
        save_const = bpy.context.scene.save_constraint
        constraint_list(layout, context, save_const)
        
        Rig_props = context.scene.Rig_Creator_PropertyGroup 
        
        row = layout.row(align=True)
        
        def icon_(Valor):
            if Valor:
                return 'TRIA_DOWN'
            else:
                return 'TRIA_RIGHT'
        
        row.alignment = 'LEFT'
        row.prop(
            Rig_props, 
            "view_subpanels", 
            text="Advanced Options", 
            icon = icon_(Rig_props.view_subpanels[0]), 
            index = 0,
            emboss=False
            )
        
        if Rig_props.view_subpanels[0] == True:
            Call_Paneles("Const_Advanced_Options", self, context, layout)
        
class Const_Advanced_Options(bpy.types.Panel):
    bl_idname = "Const_Advanced_Options"
    bl_label = "Advanced Options"
    bl_space_type = 'PROPERTIES'
    bl_region_type = 'WINDOW'
    bl_context = "bone_constraint"
    bl_parent_id = "Rig_Creator_Constraint"
    bl_options = {'DEFAULT_CLOSED'}
    
    @classmethod
    def poll(cls, context):
        return False
        return (context.pose_bone and context.active_pose_bone)

    def draw(self, context):
        layout = self.layout
        Rig_props = context.scene.Rig_Creator_PropertyGroup 
        
        save_constraint_index = bpy.context.scene.save_constraint_index
        save_const = bpy.context.scene.save_constraint
        
        if 0 <= save_constraint_index < len(save_const):
            props = save_const[save_constraint_index]
            
            layout.separator(factor=1.0)
            
            layout.prop(props, "type", text = "Constraint", icon = 'CONSTRAINT_BONE')
            
            layout.separator(factor=1.0)
            
            Itms = [
                'CAMERA_SOLVER',
                'FOLLOW_TRACK', 
                'OBJECT_SOLVER',
            ]
            
            if props.type not in Itms:
                row = layout.row(align=True)
                row.prop(props, "use_active_object", text = "")
                row.label(text="Active Object")
                row_2 = row.row(align=True)
                row_2.scale_x = 1.2
                row_2.active = not props.use_active_object
                row_2.prop(props, "target", text = "Target")

                def T_bone():
                    row = layout.row(align=True)
                    row.prop(props, "use_active_bone", text = "")
                    row.label(text="Active Bone")
                    row_2 = row.row(align=True)
                    row_2.scale_x = 1.2
                    row_2.active = not props.use_active_bone
                    row_2.prop(props, "bone", text = "Bone", icon = 'BONE_DATA')
                
                if props.use_active_object == False:
                    if props.target and props.target.type == 'ARMATURE':
                        T_bone()
                else:
                    T_bone()
            
            
            #constraint Properties
            layout.separator(factor=1.0)
            
            row = layout.row(align=True)
            
            def icon_(Valor):
                if Valor:
                    return 'TRIA_DOWN'
                else:
                    return 'TRIA_RIGHT'
            
            col = layout.column(align=False, heading='', heading_ctxt='', translate=True)
            col.alignment = 'RIGHT'
            
            camera_solver(col, props)
            follow_track(col, props)
            object_solver(col, props)
            copy_location(col, props)
            copy_rotation(col, props)
            copy_scale(col, props)
            copy_transforms(col, props)
            limit_distance(col, props)
            
            #target Space
            layout.separator(factor=1.0)
            
            Itms = [
                'CAMERA_SOLVER',
                'FOLLOW_TRACK', 
                'OBJECT_SOLVER',
            ]
            
            if props.type not in Itms:
                layout.prop(props, "target_space", text = "Target")
                layout.prop(props, "owner_space", text = "Owner")
            
            layout.separator(factor=1.0)
            row = layout.row(align=True)
            row.label(text= "Influence")
            row.prop(props, "influence", text = "")

class add_Advanced(bpy.types.Menu):
    bl_idname = "add_Advanced"
    bl_label = ""

    def draw(self, context):
        layout = self.layout
        layout.operator("rig.creator", text= "Add Default").type = "ADD_DEFAULT" 
        layout.operator("rig.creator", text= "Del All").type = "DEL_ALL" 

def Add_const_advanced_Options(self, context):
    if bpy.context.object and bpy.context.object.mode == 'POSE':
        layout = self.layout
        
        #bone = bpy.context.active_pose_bone
        #if bone:
        #    layout.prop(bone, "name", text="", icon="BONE_DATA")
        #layout.popover(
        #    'View_3D_Rig_Creator_Constraint', 
        #    text="Add Constraint List", 
        #    icon='CONSTRAINT_BONE', 
        #    translate=True
        #    )
            
@bpy.app.handlers.persistent   
def Actulidor(dummy):
    save_constraint_index = bpy.context.scene.save_constraint_index
    save_const = bpy.context.scene.save_constraint

    # Diccionario para rastrear los nombres y sus recuentos
    name_counts = {}

    # Iterar sobre los elementos de la lista save_constraint
    for save in save_const:
        name = save.name

        # Obtener el nombre base sin la extensión
        base_name = name.split(".")[0]

        # Si el nombre base ya está en name_counts, aumenta el recuento
        if base_name in name_counts:
            name_counts[base_name] += 1
        else:
            name_counts[base_name] = 1

        # Actualizar el nombre con la extensión
        if name_counts[base_name] > 1:
            save.name = f"{base_name}.{name_counts[base_name]-1:03}"
        else:
            # Si no hay duplicados, restablecer el nombre original
            save.name = base_name
    
bpy.app.handlers.depsgraph_update_pre.append(Actulidor)


def sna_add_to_bone_pt_display_custom_shape(self, context):
    
    layout = self.layout
    layout.operator("rig.creator", text="length To Translation(y)",icon='PLAY').type="LENG_TO_TRANS"

def length_To_Translation_y_():
    
    bpy.ops.object.mode_set(mode='POSE')
    
    if bpy.context.active_object and bpy.context.active_object.type == 'ARMATURE':
        Bone = bpy.context.active_pose_bone
        Name_B = Bone.name
        length = 0
        if Name_B:
            bpy.ops.object.mode_set(mode='EDIT')
            edit_bone = bpy.context.object.data.edit_bones.get(Name_B)
            length = edit_bone.length
            bpy.ops.object.mode_set(mode='POSE')
            pose_bone = bpy.context.object.pose.bones.get(Name_B)
            pose_bone.custom_shape_translation[1] = length

#Generadores 
class Rig_Creator(bpy.types.Panel):
    bl_idname = "Rig_Creator"
    bl_label = "Rig Creator"
    bl_space_type = 'PROPERTIES'
    bl_region_type = 'WINDOW'
    bl_context = "data"

    @classmethod
    def poll(cls, context):
        
        return (
            context.active_object and context.active_object.type == 'ARMATURE')

    def draw(self, context):
        layout = self.layout
        Rig_props = context.scene.Rig_Creator_PropertyGroup
        layout.label(text = "Generators", icon ='BONE_DATA')

def icon(visible):
                if visible:
                    return "DOWNARROW_HLT"
                else:
                    return "RIGHTARROW"
          
def lineas(layout):
                box = layout.box()
                box.scale_y = 0.05
                box.label(text="")
                
def view_subpaneles(cual, layout, Rig_props):
    
    row = layout.row(align=True)
    row.alignment = 'LEFT'
    row.prop(
        Rig_props, 
        "view_subpanels", 
        text = Paneles[cual], 
        icon= icon(Rig_props.view_subpanels[cual]),
        index= cual,
        emboss=False,
        toggle=False
        )
    
#Armature Reset
class P_Armature_Reset(bpy.types.Panel):
    bl_idname = "P_Armature_Reset"
    bl_label = "Armature Reset"
    bl_space_type = 'PROPERTIES'
    bl_region_type = 'WINDOW'
    bl_context = "data"
    bl_parent_id = "Rig_Creator"
    bl_options = {'DEFAULT_CLOSED'}
    
    @classmethod
    def poll(cls, context):
        return (
            context.active_object and context.active_object.type == 'ARMATURE')

    def draw(self, context):
        layout = self.layout
        Rig_props = context.scene.Rig_Creator_PropertyGroup 
   
        row = layout.row(align=True)
        layout = row.column(align=True)
        layout.operator(
            "rig.creator", 
            text= "Armature Resect", 
            icon= 'OUTLINER_OB_ARMATURE'
            ).type = "RESECT_ARMATURE"
        
        if bpy.context.object.mode == 'POSE':
            layout.operator(
                    "rig.creator", 
                    text= "Resect Stretch To ", 
                    icon= 'PLAY'
                    ).type = "RESECT_STRETCH_TO"
            
        lineas(layout) 
             
#Generador DEF, FK, DEDOS
class P_Generador_Def_Fk_y_Fingers(bpy.types.Panel):
    bl_idname = "P_Generador_Def_Fk_y_Fingers"
    bl_label = "Generator Def, Fk y Fingers"
    bl_space_type = 'PROPERTIES'
    bl_region_type = 'WINDOW'
    bl_context = "data"
    bl_parent_id = "Rig_Creator"
    bl_options = {'DEFAULT_CLOSED'}
    
    @classmethod
    def poll(cls, context):
        return (
            context.active_object and context.active_object.type == 'ARMATURE' and
            not context.active_object.mode == 'OBJECT')

    def draw(self, context):
        layout = self.layout
        Rig_props = context.scene.Rig_Creator_PropertyGroup 
        
        if not bpy.context.object.mode == 'OBJECT':
            layout = self.layout
            
            layout = layout.column(align=True)
            row = layout.row(align=True)
            
            #Niveles de Uso
            row.prop(Rig_props, "use_def", text="Def", icon = 'SPHERE')
            row.prop(Rig_props, "use_fk", text="Fk", icon = 'CON_ROTLIKE')
            row = layout.row(align=True)
            
            if Rig_props.use_def and Rig_props.use_fk == True:
                row.prop(Rig_props, "use_dedos", text="Fingers", icon = 'FIXED_SIZE')
                row.prop(Rig_props, "use_dedos_rot", text="", icon = 'CON_ROTLIKE')
            else:
                row.prop(Rig_props, "use_dedos_rot", text="Rot", icon = 'CON_ROTLIKE')
            #relacion y Segemnts  
            if Rig_props.use_def or Rig_props.use_fk == True:
                row = layout.row(align=True)
                col = layout.column(align=True)
                row.prop(Rig_props, "use_Segments", text="Use Segments", icon = 'MOD_ARRAY')
                row.prop(Rig_props, "use_Parent", text="Parent", icon = 'FILE_PARENT')
                if Rig_props.use_Segments == True:
                    col.prop(Rig_props, "int_Segments", text="Segments")
                col = layout.column(align=True)
                if Rig_props.use_def == True:
                    col.prop(Rig_props, "Base_name_DEF", text="", icon='SYNTAX_OFF')
                if Rig_props.use_fk == True:
                    col.prop(Rig_props, "Base_name_FK", text="", icon='SYNTAX_OFF')
                if Rig_props.use_dedos and Rig_props.use_def and Rig_props.use_fk == True:
                    col.prop(Rig_props, "Base_name_DEDOS", text="", icon='SYNTAX_OFF')
                layout.operator(
                    "rig.creator", 
                    text= "General", 
                    icon= 'PLAY'
                    ).type = "GEN_DEF_FK_FING"
                
            lineas(layout)           

#Generador IK
class P_Generador_IK(bpy.types.Panel):
    bl_idname = "P_Generador_IK"
    bl_label = "Generator IK"
    bl_space_type = 'PROPERTIES'
    bl_region_type = 'WINDOW'
    bl_context = "data"
    bl_parent_id = "Rig_Creator"
    bl_options = {'DEFAULT_CLOSED'}
    
    @classmethod
    def poll(cls, context):
        return (
            context.active_object and context.active_object.type == 'ARMATURE'and
            not context.active_object.mode == 'OBJECT')

    def draw(self, context):
        layout = self.layout
        Rig_props = context.scene.Rig_Creator_PropertyGroup 
        
        if not bpy.context.object.mode == 'OBJECT':
            
            layout = layout.column(align=True)
            row = layout.row(align=True)
            row.prop(Rig_props, "use_strech", text="Strech To", emboss=True,
                toggle=True)
            row.prop(Rig_props, "use_pole_target", text="Pole Target", emboss=True,
                toggle=True)
            row.prop(Rig_props, "use_track_to", text="", icon='CON_TRACKTO', emboss=True,
                toggle=True)
            
            if Rig_props.use_pole_target == True:
                layout.prop(Rig_props, "Angle_IK", text="Angle")  
                
            layout.prop(Rig_props, "use_copy_transforms_IK", text="Copy Transforms", icon='CON_TRANSFORM')
            layout.prop(Rig_props, "Base_name_IK", text="", icon='SYNTAX_OFF')
            
            def count_selected_bones():
               obj = bpy.context.object
               if obj and obj.type == 'ARMATURE':
                   if bpy.context.mode == 'EDIT_ARMATURE':
                       # Modo de edición
                       armature = obj.data
                       selected_bones = [bone for bone in armature.edit_bones if bone.select]
                       num_selected = len(selected_bones)
                       return num_selected
                   elif bpy.context.mode == 'POSE':
                       # Modo pose
                       pose_bones = obj.pose.bones
                       selected_bones = [bone for bone in pose_bones if bone.bone.select]
                       num_selected = len(selected_bones)
                       return num_selected
                   else:
                       return 0
               else:
                   return 0
            if count_selected_bones() > 1:
                layout.operator(
                        "rig.creator", 
                        text= "General", 
                        icon= 'PLAY'
                        ).type = "GEN_IK"
            else:
                box = layout.box()
                box.label(text = "Select more Bone")
            
            lineas(layout)
 
#Generador FK
class P_Generador_FK(bpy.types.Panel):
    bl_idname = "P_Generador_FK"
    bl_label = "Generator FK"
    bl_space_type = 'PROPERTIES'
    bl_region_type = 'WINDOW'
    bl_context = "data"
    bl_parent_id = "Rig_Creator"
    bl_options = {'DEFAULT_CLOSED'}
    
    @classmethod
    def poll(cls, context):
        return (
            context.active_object and context.active_object.type == 'ARMATURE'and
            not context.active_object.mode == 'OBJECT')

    def draw(self, context):
        layout = self.layout
        Rig_props = context.scene.Rig_Creator_PropertyGroup 
        
        if not bpy.context.object.mode == 'OBJECT':
            layout = layout.column(align=True)
            row = layout.row(align=True)
            row.prop(Rig_props, "use_view_object", text="Viewport Display", emboss=True,icon='SPHERE',
                toggle=True)
            row.prop(Rig_props, "use_copy_transforms_FK", text="Copy Transforms", emboss=True,icon='CON_TRANSFORM',
                toggle=True)
            layout.prop(Rig_props, "Base_name_FK_S", text="", icon='SYNTAX_OFF')
            layout.operator(
                    "rig.creator", 
                    text= "General", 
                    icon= 'PLAY'
                    ).type = "GEN_FK"
            lineas(layout)

#Generador Bones
class P_Generador_Bones(bpy.types.Panel):
    bl_idname = "P_Generador_Bones"
    bl_label = "Generator Bones"
    bl_space_type = 'PROPERTIES'
    bl_region_type = 'WINDOW'
    bl_context = "data"
    bl_parent_id = "Rig_Creator"
    bl_options = {'DEFAULT_CLOSED'}
    
    @classmethod
    def poll(cls, context):
        return (
            context.active_object and context.active_object.type == 'ARMATURE'and
            not context.active_object.mode == 'OBJECT')

    def draw(self, context):
        layout = self.layout
        Rig_props = context.scene.Rig_Creator_PropertyGroup 
        
        if not bpy.context.object.mode == 'OBJECT':
            
            layout = layout.column(align=True)
            layout.label(text="Look Bone")
            row = layout.row(align=True)
            row.prop(Rig_props, "look_bone", text = "XYZ") 
            if Rig_props.add_orientation == 'GLOBAL':
                icon_ = 'ORIENTATION_GLOBAL'
            else:
                icon_ = 'ORIENTATION_NORMAL'
            layout.prop(Rig_props, "add_orientation", text="", icon =icon_)
            row = layout.row(align=True)
            row.prop(Rig_props, "use_Parent_b", text="Parent", icon= 'FILE_PARENT')
            row.prop(Rig_props, "use_Strech_to_b", text="Strech To", icon= 'CON_STRETCHTO') 
            row.prop(Rig_props, "use_mas_1", text="+1", emboss=True,
                toggle=True)
            row = layout.row(align=True)
            if Rig_props.viewport_D_tipo == 'SINGLE_ARROW':
                icon_ =  'EMPTY_SINGLE_ARROW'
            elif Rig_props.viewport_D_tipo == 'CIRCLE':
                icon_ = 'MESH_CIRCLE'
            elif Rig_props.viewport_D_tipo == 'CUBE':
                icon_ = 'CUBE'
            else:
                icon_ = 'SPHERE'
            row.prop(Rig_props, "use_viewport_d", text="Viewport Display", icon= icon_)
            if Rig_props.use_viewport_d == True:
                row.prop_menu_enum(Rig_props, "viewport_D_tipo", text="", icon='OBJECT_DATA')
            layout.prop(Rig_props, "Base_name_b", text="", icon='SYNTAX_OFF')
            layout.operator(
                    "rig.creator", 
                    text= "General", 
                    icon= 'PLAY'
                    ).type = "GEN_BONE"
            
            lineas(layout)

#Auto rig automatico, de bones, def, rot
class P_Generador_Auto_Bones(bpy.types.Panel):
    bl_idname = "P_Generador_Auto_Bones"
    bl_label = "Generator Curve Bones"
    bl_space_type = 'PROPERTIES'
    bl_region_type = 'WINDOW'
    bl_context = "data"
    bl_parent_id = "Rig_Creator"
    bl_options = {'DEFAULT_CLOSED'}
    
    @classmethod
    def poll(cls, context):
        return (
            context.active_object and context.active_object.type == 'ARMATURE'and
            not context.active_object.mode == 'OBJECT')
        
    def draw(self, context):
        layout = self.layout
        Rig_props = context.scene.Rig_Creator_PropertyGroup 
        
        layout = layout.column(align=True)
        layout.prop(Rig_props, "curve_bulge", text="Volumen variention",toggle=True)
        layout.prop(Rig_props, "curve_int_Segments", text="Segments", icon='MOD_ARRAY')
        layout.prop(Rig_props, "use_curve_root", text="Use Root",emboss=True,toggle=True)
        
        layout.prop(Rig_props, "Base_name_curve_free", text="")
        layout.prop(Rig_props, "Base_name_curve_cont", text="")
        
        if Rig_props.use_curve_root:
            layout.prop(Rig_props, "Base_name_curve_root", text="")
        
        layout.operator("rig.creator", text= "General", icon= 'PLAY').type = "GEN_CURVE_BONE"
        
        lineas(layout)

@bpy.app.handlers.persistent   
def Generator(dummy):
    pass

bpy.app.handlers.depsgraph_update_pre.append(Generator)
        
from Paneles.Colletions_layers import *  
from Paneles.Custom_properties import *  
from Paneles.Paneles_Constraint.Constraint_Bone import *

PANLES = (
        P_Generador_Def_Fk_y_Fingers,
        P_Generador_IK,
        P_Generador_FK,
        P_Generador_Bones,
        P_Generador_Auto_Bones,
        )

class Call_Rig_Menu(bpy.types.Menu):
    bl_idname = "Call_Rig_Menu"
    bl_label = ""
    @classmethod
    def poll(cls, context):
        return not (False)
    def draw(self, context):
        layout = self.layout.menu_pie()
          
        layout.popover(VIEWColletions_layers.bl_idname, text=VIEWColletions_layers.bl_label)
        layout.popover(VIEWCustomProperties.bl_idname, text=VIEWCustomProperties.bl_label)
        
        layout.popover(P_Armature_Reset.bl_idname, text=P_Armature_Reset.bl_label)  
        
        if (context.active_object and context.active_object.type == 'ARMATURE'and
            not bpy.context.object.mode == 'OBJECT'):
            layout.popover(Call_Rig_Menu_GEN.bl_idname, text=Call_Rig_Menu_GEN.bl_label) 

class Call_Rig_Menu_GEN(bpy.types.Panel):
    bl_idname = "Call_Rig_Menu_GEN"
    bl_label = "Generator"
    bl_space_type = 'PROPERTIES'
    bl_region_type = 'WINDOW'
    bl_context = "Pass"
    bl_options = {'DEFAULT_CLOSED'}
    
    @classmethod
    def poll(cls, context):
        return not (False)
    def draw(self, context):
        layout = self.layout 
        for cls in PANLES:
            layout.operator("call.paneles", text=cls.bl_label).type = cls.bl_idname
        

class call_paneles(bpy.types.Operator):
    bl_idname = "call.paneles"
    bl_label = "My Class Name"

    type: bpy.props.StringProperty(default="")

    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        
        for cls in PANLES:
            if self.type == cls.bl_idname:
                bpy.ops.wm.call_panel(name=cls.bl_idname)
        
        return {"FINISHED"}


from Operadores.Rig_Creator_Operation.Resect_Armature import *       
from Operadores.Rig_Creator_Operation.Generador_FK_DEF_ROT import *   
from Operadores.Rig_Creator_Operation.Materiales import * 
from Operadores.Rig_Creator_Operation.Generador_IK import *
from Operadores.Rig_Creator_Operation.Generador_FK import *
from Operadores.Rig_Creator_Operation.Generador_Bone import *
from Operadores.Rig_Creator_Operation.Append_Collection import *
from Operadores.Rig_Creator_Operation.Creador_Bones import *
from Operadores.Rig_Creator_Operation.RIg_Constraint_G import *
from Operadores.Rig_Creator_Operation.Generador_Curve import * 

class Rig_Creator_OP(bpy.types.Operator):
    bl_idname = "rig.creator"
    bl_label = "Rig Creator"

    type: bpy.props.StringProperty(default="")
    
    def execute(self, context):
        
        #Generator
        if self.type == "RESECT_ARMATURE":
            Resect_Armature()
        
        if self.type == "RESECT_STRETCH_TO":
            for bone in bpy.context.selected_pose_bones:
                for constraint in bone.constraints:
                    if constraint.type == 'STRETCH_TO':
                        constraint.rest_length = 0
        
        if self.type == "GEN_DEF_FK_FING":
            add_colletion()
            Generador_FK_DEF_ROT()
        
        if self.type == "GEN_IK":
            add_colletion()
            Generador_IK()
        
        if self.type == "GEN_FK":
            add_colletion()
            Generador_FK()
        
        if self.type == "GEN_BONE":
            add_colletion()
            Generador_Bone()
        
        if self.type == "ADD_BONE_DEF":
            bone_sin_def()
        
        if self.type == "GEN_CURVE_BONE":
           add_colletion()
           Generator_Curve() 
        #constraint
        if self.type == "SAVE_CONST":
            save_Constraint()
        
        if self.type == "ADD_CONST_NEW":
            add_const_to_Bone("", None)
        
        if self.type == "ADD_CONST":
            None_Constraint()
        
        if self.type == "X_CONST":
            Delet_Constraint()
        
        if self.type == "UP_CONST":
            Move_const("UP_CONST")
        
        if self.type == "DOWN_CONST":
            Move_const("DOWN_CONST")
        
        if self.type == "LENG_TO_TRANS":
            length_To_Translation_y_()
        
        if self.type == "ADD_DEFAULT":
            ADD_DEFAULT()
        
        if self.type == "DEL_ALL":
            DEL_ALL()
            
        return {'FINISHED'}
    
def Add_Menu_Rig_Creator(self, context):
    layout = self.layout
    layout.menu(Rig_Creator_Menu.bl_idname, icon= 'OUTLINER_OB_ARMATURE')
    
def Add_bone(self, context):
    layout = self.layout
    row = layout.row()
    row.operator("rig.creator", text= "Bone (Def off)", text_ctxt="Ctrl Shift A",icon= 'BONE_DATA', translate=True).type = "ADD_BONE_DEF"

class Rig_Creator_Menu(bpy.types.Menu):
    bl_idname = "Rig_Creator_Menu"
    bl_label = "Rig Creator"
    
    def draw(self, context):
        layout = self.layout
        layout.label(text= "Creator (submenu)")
        layout = self.layout
        op = layout.operator('sna.operator_9539c', text='Humanan Base', icon_value=241, emboss=True, depress=False)
        op.sna_type = 'RIG_CREATOR'
        op = layout.operator('sna.operator_9539c', text='Peto', icon_value=200, emboss=True, depress=False)
        op.sna_type = 'RIG_CREATOR_TORZO'
        op = layout.operator('sna.operator_9539c', text='Arm', icon_value=200, emboss=True, depress=False)
        op.sna_type = 'RIG_CREATOR_BRAZO'
        op = layout.operator('sna.operator_9539c', text='Leg', icon_value=200, emboss=True, depress=False)
        op.sna_type = 'RIG_CREATOR_PIERNA'
   
   
#opciones Generales Del addon    
