import bpy 
import sys
import os
from bl_ui.generic_ui_list import draw_ui_list
current_dir = os.path.dirname(__file__)
sys.path.append(current_dir) 

from Swith import *
Cat = bl_category

class OP_Input_Bones(bpy.types.Operator):
    bl_idname = "input.bones"
    bl_label = ""
    
    collection: bpy.props.StringProperty(default="")
    
    def execute(self, context):
        obj = bpy.context.active_object 
        if obj and obj.type == 'ARMATURE':
            
            if obj.mode == 'POSE':
                selected_bones = context.selected_pose_bones
            if obj.mode == 'EDIT':    
                selected_bones = context.selected_bones

            if selected_bones:
                for pose_bone in selected_bones:
                    if obj.mode == 'POSE':
                        collections = pose_bone.bone.collections
                    if obj.mode == 'EDIT': 
                        collections = pose_bone.collections
                    for col in collections:
                        bpy.ops.armature.collection_unassign_named(
                            name=col.name, 
                            bone_name=pose_bone.name
                        )
                bpy.ops.armature.collection_assign(name=self.collection)

                self.report({'INFO'}, f"Bone '{pose_bone.name}' reassigned to collection '{self.collection}'")
            self.report({'INFO'}, f"[Bone is not select] reassigned to collection '{self.collection}'")
                
        return {"FINISHED"}


 
class OP_Select_Bones(bpy.types.Operator):
    bl_idname = "select.bones"
    bl_label = "Select Bones"
    
    type: bpy.props.BoolProperty()
    collection: bpy.props.StringProperty(default="")
    
    def execute(self, context):
        obj = bpy.context.active_object 
        if obj and obj.type == 'ARMATURE':
            armature = obj.data
            collection = armature.collections.get(self.collection)
            
            self.report({'INFO'}, f"Bones Select {self.type} to {self.collection}")
            
            for bone in collection.bones:
                bone.select = self.type

           
        return {"FINISHED"}
       