import bpy

import sys

import os
current_dir = os.path.dirname(__file__)
sys.path.append(current_dir) 

from Swith import *
Cat = bl_category

class S_General_PropertyGroup(bpy.types.PropertyGroup):
    use_active_bone: bpy.props.BoolProperty(default = False)
    View_bone_trans: bpy.props.BoolProperty(default = False)
    

class Optimizar_Rig(bpy.types.Panel):   
    bl_idname = "Optimizar_Rig"
    bl_label = "Optimizar Rig"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = Cat
    bl_options = {'DEFAULT_CLOSED'}
    bl_order = 11


    @classmethod
    def poll(cls, context):
        # Verificar si el objeto seleccionado es una armadura
        return False
        #return context.active_object and context.active_object.type == 'ARMATURE'

    def draw(self, context):
        layout = self.layout
        layout.operator("gen.oper_h", text="G_Rig", emboss=True).type = "G_RIG"
        
        obj = context.active_object
        objetos_hijos = [objeto for objeto in bpy.data.objects if objeto.parent == obj]
        if obj and obj.type == 'ARMATURE':
            armature = obj.data
            row = layout.row(align=True)
            #row.operator("gen.oper_h", text="Low", emboss=True).type = "OPTIMIZAR_MESH_LOW"   
            #row.operator("gen.oper_h", text="Med", emboss=True).type = "OPTIMIZAR_MESH_MED"   
            #row.operator("gen.oper_h", text="", icon="X", emboss=True).type = "OPTIMIZAR_MESH_QUIT"
            props = obj.A_object_PropertyGroup
            DECIMATE_EXISTE = False
            
            for Obj in objetos_hijos:
                for mod in Obj.modifiers:
                    if mod and mod.type == 'DECIMATE':
                        DECIMATE_EXISTE = True
            
            if DECIMATE_EXISTE == True:
                layout.prop(props, "Object_Decimate", text = "Decimate Low")
            
#@bpy.app.handlers.persistent                 
#def Modificar_Decimate(dummy):
#    
#    obj = bpy.context.active_object
#    objetos_hijos = [objeto for objeto in bpy.data.objects if objeto.parent == obj]
#    if obj and obj.type == 'ARMATURE':
#        props = obj.A_object_PropertyGroup
#        for Obj in objetos_hijos:
#            for mod in Obj.modifiers:
#                if mod and mod.type == 'DECIMATE':
#                    mod.ratio = props.Object_Decimate

#bpy.app.handlers.depsgraph_update_pre.append(Modificar_Decimate)       
             
class Auto_Root(bpy.types.Panel):
    bl_idname = "Auto_Root"
    bl_label = "Auto Root"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = Cat
    bl_options = {'DEFAULT_CLOSED'}
    bl_order = 10


    @classmethod
    def poll(cls, context):
        # Verificar si el objeto seleccionado es una armadura
        return context.active_object and context.active_object.type == 'ARMATURE' and Cual == False

    def draw(self, context):
        layout = self.layout

        obj = context.active_object
        if obj and obj.type == 'ARMATURE':
            armature = obj.data

            def Bones_existe():
                for bones in armature.bones:
                    if bones.name == "New_Root_1":
                        return True
                return False
                     
            if not Bones_existe():
                props = context.scene.S_General_PropertyGroup
                layout.prop(props, "use_active_bone", text ="use Active Bone", icon = 'BONE_DATA')

                Bone = None
                if props.use_active_bone == True:
                    Bone = bpy.context.active_pose_bone
                    if Bone:
                        layout.label(text = Bone.name)
                        Select_bone = True
                    else:
                        layout.label(text="Nop selet Bone")
                        Select_bone = False
                else:
                    Select_bone = True 

                layout_button = layout.row()
                layout_button.enabled = Select_bone 
                new = layout_button.operator("gen.oper_h", text = "Auto Root", emboss=True)
                new.type = "AUTO_ROOT"
                if props.use_active_bone == True:
                    if Bone:
                        new.Bone_activo = Bone.name
            else:
                layout.label(text = "Existen, los Huesos")
                
            #Modificar Visual de Bone
            Bone = bpy.context.active_pose_bone
            def icon(icon1, icon2, visible):
                if visible:
                    return icon1
                else:
                    return icon2
            
                 
class bone_context_active(bpy.types.Panel):
    bl_idname = "bone_context_active"
    bl_label = "Custom Shape"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = Cat
    bl_parent_id = "Auto_Root"
    bl_options = {'DEFAULT_CLOSED'}
    
    @classmethod
    def poll(cls, context):
        # Verificar si el objeto seleccionado es una armadura
        return context.active_pose_bone

    def draw(self, context):
        layout = self.layout
        
        Bone = bpy.context.active_pose_bone
        if Bone:
            
            layout.alignment="RIGHT"
            
            col = layout.column(align=True)
            row = col.row()
            row.label(text="Scale X")
            row.prop(Bone, "custom_shape_scale_xyz",index=0,text="")
            row = col.row()
            row.label(text="Y")
            row.prop(Bone, "custom_shape_scale_xyz",index=1,text="")
            row = col.row()
            row.label(text="Z")
            row.prop(Bone, "custom_shape_scale_xyz",index=2,text="")
            
            col = layout.column(align=True)
            row = col.row()
            row.label(text="Translation X")
            row.prop(Bone, "custom_shape_translation",index=0,text="")
            row = col.row()
            row.label(text="Y")
            row.prop(Bone, "custom_shape_translation",index=1,text="")
            row = col.row()
            row.label(text="Z")
            row.prop(Bone, "custom_shape_translation",index=2,text="")
            
            col = layout.column(align=True)
            row = col.row()
            row.label(text="Rotation X")
            row.prop(Bone, "custom_shape_rotation_euler",index=0,text="") 
            row = col.row()
            row.label(text="Y") 
            row.prop(Bone, "custom_shape_rotation_euler",index=1,text="") 
            row = col.row()
            row.label(text="Z")
            row.prop(Bone, "custom_shape_rotation_euler",index=2,text="") 

class Fisicas_PropertyGroup(bpy.types.PropertyGroup):

    Stretch_to: bpy.props.BoolProperty(default = False)

    Frame_Bake_1: bpy.props.IntProperty(default=1)
    Frame_Bake_2: bpy.props.IntProperty(default=240)
    Frame_Bake_Steo: bpy.props.IntProperty(default=1)

    Volume_Varition: bpy.props.FloatProperty(default=0.0, min = 0.0, max = 100.0)
    Fuerza_Fisicas: bpy.props.FloatProperty( default=0.0, min = 0.0, max = 0.8)

class Fisicas(bpy.types.Panel):

    bl_idname = "Fisicas"
    bl_label = "Fisicas"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = Cat
    bl_options = {'DEFAULT_CLOSED'}
    bl_order = 3

    @classmethod
    def poll(cls, context):
        # Verificar si el objeto seleccionado es una armadura
        return context.active_object and context.active_object.type == 'ARMATURE'


    def draw(self, context):
        layout = self.layout

        props = context.scene.H_Fisicas_PropertyGroup
        
        layout.prop(props, "Stretch_to", text = "Use Stretch", icon = 'CON_STRETCHTO')
        row = layout.row(align=True)
        row.prop(props, "Fuerza_Fisicas", text = "Fruerza", slider = True)
        if props.Stretch_to == True:
            row.prop(props, "Volume_Varition", text = "Volumen",)

        row = layout.row(align=True)
        box = row.box()
        box.scale_y = 0.5
        box.label(icon = 'KEYFRAME_HLT')
        row.prop(props, "Frame_Bake_1", text = "Star",)
        row.prop(props, "Frame_Bake_2", text = "End",)
        layout.prop(props, "Frame_Bake_Steo", text = "Step",)
        layout.separator()
        layout_ = layout.row()
        layout_.scale_y = 1.5
        layout_.operator("gen.oper_h", text = "Run", emboss=True, icon='PLAY').type = "FISICAS"

class VIEWMateriales_glithc(bpy.types.Panel):
    bl_idname = "VIEWMateriales_glithc"
    bl_label = "Materiales Glitch"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = Cat
    bl_parent_id = "Panel_rig_creator_props"
    bl_options = {'DEFAULT_CLOSED'}
    
    @classmethod
    def poll(cls, context):
        # Verificar si el objeto seleccionado es una armadura
        prop = [
            "Cuadros_Cuantos?",
            "Emit",
            "Fac",
            "Scale",
            "Speed",   
            ]
        
        return (
            context.active_object and 
            context.active_object.type == 'ARMATURE' and 
            Cual == False and 
            context.active_object.data in prop
            
            )

    def draw(self, context):
        layout = self.layout

        obj = context.active_object
        if obj and obj.type == 'ARMATURE':
            armature = obj.data

            Scale_x = 1
            Scale_y = 1

            
            # Define una lista de los nombres de las colecciones
            prop = {
                'Cuadros_Cuantos?': "Cuadros_Cuantos?",
                'Emit': "Emit",
                'Fac': "Fac",
                'Scale': "Scale",
                'Speed': "Speed",
                
            }

            # Define un diccionario para almacenar los valores de las propiedades
            prop_valor = {}

            # Verifica si cada propiedad existe y agrega su valor al diccionario si es así
            for nombre, propiedad in prop.items():
                if propiedad in armature:
                    prop_valor[nombre] = armature[propiedad]

            def Column(row, prop_A, text_A, use_facto = False,): 
                for p in range(len(prop_A)):
                    if prop_A[p]:
                        if prop_A[p] in armature:
                            row.prop(armature, f'["{prop_A[p]}"]', text=text_A[p], slider = use_facto)
                

            def existe(prop):
                if prop:
                    if prop in armature:
                        return prop
                    else:
                        return None
                else:
                    return None    
                
            
            row = layout.row(align=False, translate=False)
            row.scale_x = Scale_x
            row.scale_y = Scale_y

            
            Column(
                row, 
                prop_A = [
                    existe(prop['Cuadros_Cuantos?']),
                    existe(prop['Emit']),
                ], 
                text_A = [
                    "Cuanto Cuadros?",
                    "Emit",    
                ],
                use_facto = True,
                   )
            
            row = layout.row(align=False, translate=False)
            row.scale_x = Scale_x
            row.scale_y = Scale_y

            Column(
                row, 
                prop_A = [
                    existe(prop['Fac']),
                ], 
                text_A = [
                    "Fac",
                ],
                use_facto = True,
                   )
            
            row = layout.row(align=False, translate=False)
            row.scale_x = Scale_x
            row.scale_y = Scale_y

            
            Column(
                row, 
                prop_A = [
                    existe(prop['Scale']),
                    existe(prop['Speed']),
                ], 
                text_A = [
                    "Scale",
                    "Speed",    
                ],
                use_facto = False,
                   )