

import bpy
import bpy.utils.previews
import os


addon_keymaps = {}
_icons = None


class SNA_OT_Operator_9539C(bpy.types.Operator):
    bl_idname = "sna.operator_9539c"
    bl_label = "Operator"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    
    sna_type: bpy.props.StringProperty(name='Type', description='', default='', subtype='NONE', maxlen=0)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        before_data = list(bpy.data.collections)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'SAVE_RIG_CREATOR.blend') + r'\Collection', filename=self.sna_type, link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.collections)))
        appended_691BE = None if not new_data else new_data[0]
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def extregister():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.utils.register_class(SNA_OT_Operator_9539C)


def extunregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    bpy.utils.unregister_class(SNA_OT_Operator_9539C)
